var folders = window.arguments[0].inn.folders;
var folderTree = window.arguments[0].inn.folderTree;

var SimpleMailArchive = {
  initialize: function() {
    technalxs.simplemail.SimpleMailOverlay = technalxs.simplemail.SimpleMailUtils.getBrowserWindow().technalxs.simplemail.SimpleMailOverlay;
    SimpleMailArchive.populateAccountId();
    var today = new Date();
    technalxs.simplemail.SimpleMailPrefs.setString('dateValue', SimpleMailArchive.initialize.today);
    technalxs.simplemail.SimpleMailDom.get("accountId").selectedIndex=0;
  },

  choice: function(selectedIndex) {
    if (technalxs.simplemail.SimpleMailDom.get("choice").selectedIndex == 0) {
     technalxs.simplemail.SimpleMailDom.get("accountId").disabled = false;
    }  
    else if (technalxs.simplemail.SimpleMailDom.get("choice").selectedIndex == 1){
      technalxs.simplemail.SimpleMailDom.get("accountId").disabled = true;
    }
  },

  archiveType: function(selectedIndex) {
    if (technalxs.simplemail.SimpleMailDom.get("archiveType").selectedIndex == 1) {
      technalxs.simplemail.SimpleMailDom.get('deletemessages').checked = false;
      technalxs.simplemail.SimpleMailDom.get("deletemessages").disabled = true;
    }
    else {
      technalxs.simplemail.SimpleMailDom.get("deletemessages").disabled = false;
    }
  },

  browseDataDirectory: function() {
    var file = technalxs.simplemail.SimpleMailFile.chooseFile("folder");
    if (file) {
      technalxs.simplemail.SimpleMailDom.get("dataDirectory").value = file.path;
      technalxs.simplemail.SimpleMailPrefs.setString("dataDirectory", file.path);
    }
  },

  populateAccountId: function() {
    var accounts = technalxs.simplemail.SimpleMailOverlay.storage.getAccounts();
    var popup = technalxs.simplemail.SimpleMailDom.get("accountId").menupopup;

    for(var i = 0; i < accounts.length; i++) {
      var menuitem = document.createElement("menuitem");
      menuitem.setAttribute("label", accounts[i]);
      menuitem.setAttribute("value", accounts[i].id);
      popup.appendChild(menuitem);
    }
    popup.parentNode.selectedIndex = 0;
  },

  updateWindow: function() {
    if ((technalxs.simplemail.SimpleMailDom.get("archiveType").selectedIndex == 1)) {
      var archiveType = technalxs.simplemail.SimpleMailDom.get("archiveType").selectedIndex;
      window.arguments[0].out = {archiveType:archiveType};
      close();
    }
    else {
      close();
    }
  },

  next: function() {
    var deck = technalxs.simplemail.SimpleMailDom.get("stateDeck");
    var index = deck.getAttribute("selectedIndex");
    switch (index) {
    case "0":
    deck.setAttribute("selectedIndex", "1");
    case "1":
    SimpleMailArchive.okDialog();
    break;
    case "2":
    SimpleMailArchive.updateWindow();
    break;  
    }
  },

  okDialog: function() {
  if ((technalxs.simplemail.SimpleMailDom.get("archiveType").selectedIndex == 1)) {
    if (SimpleMailArchive.outputFolder() == true) {
      SimpleMailArchive.ShowResults(true);
      return(true);
    }
      else {
      SimpleMailArchive.setProgress(5);
      return(false);
    }
    SimpleMailArchive.ShowResults(false);
  }

  if (SimpleMailArchive.outputFile() == true) {
      SimpleMailArchive.ShowResults(true);
      return(true);
    }
    else {
      SimpleMailArchive.setProgress(5);
      return(false);
    }
    SimpleMailArchive.ShowResults(false);
  },

  setProgress: function(pct) {
    if (pct <= 100) {
      var progressMeter = technalxs.simplemail.SimpleMailDom.get("progressMeter");
      progressMeter.value =  pct;
     }
    return; 
  },

  attachStrings: function(aNode, aString) {
    var attachNode = technalxs.simplemail.SimpleMailDom.get(aNode);
    var strings = aString.split("\n");

    for (var i = 0; i < strings.length; i++) {
      if (strings[i]) {
        var currNode = document.createTextNode(strings[i]);
        attachNode.appendChild(currNode);
        var br = document.createElementNS("http://www.w3.org/1999/xhtml", 'br');
        attachNode.appendChild(br);
      }
    }
  },

  ShowResults: function(good) {
    var result;

    if (good) {
      result = technalxs.simplemail.SimpleMailBundle.getString("createdArchive");
    }
    else {
      result = technalxs.simplemail.SimpleMailBundle.getString("errorArchive");
    }
    SimpleMailArchive.attachStrings("results", result);
    var deck = technalxs.simplemail.SimpleMailDom.get("stateDeck");
    deck.setAttribute("selectedIndex", "2");
    var nextButton = technalxs.simplemail.SimpleMailDom.get("next");
    nextButton.label = nextButton.getAttribute("finishedval");
    nextButton.removeAttribute("disabled");
    var cancelButton = technalxs.simplemail.SimpleMailDom.get("cancel");
    cancelButton.setAttribute("hidden", "true");
  },

  getString: function(statement, id) {
    var text = "text: ";
    var value = statement.getString(id);
    return value && value.substr(0, text.length) == text ? value.substr(text.length) : value;
  },

  outputFile: function() {
    var deck = technalxs.simplemail.SimpleMailDom.get("stateDeck");
    var dateValue = new Date(technalxs.simplemail.SimpleMailPrefs.getString('dateValue'));
    if (new Date(technalxs.simplemail.SimpleMailPrefs.getString('dateValue')) > SimpleMailArchive.initialize.today ){
      var confirmText = technalxs.simplemail.SimpleMailBundle.getString("archiveAlert");
        if (!technalxs.simplemail.SimpleMailUtils.confirm(confirmText)) {
          deck.setAttribute("selectedIndex", "0");
          return;
        }
     }

  // Get msgs for account   
    if (technalxs.simplemail.SimpleMailDom.get("choice").selectedIndex == 0) {
      var selectedAccount = technalxs.simplemail.SimpleMailDom.get("accountId").selectedItem.value;
      var Accountlabel = technalxs.simplemail.SimpleMailDom.get("accountId").selectedItem.label;
      var Accountlabel = Accountlabel.replace(/(<).*?/g,"(");
      var Accountlabel = Accountlabel.replace(/(>).*?/g,")"); 
       
      var msg = new Array();  
      var msg = technalxs.simplemail.SimpleMailOverlay.storage.getAccountMessages(selectedAccount);

      var messagesDate = new Array();
      for(var i = msg.length - 1; i >= 0; i--) {
        if ((msg[i].date)< dateValue) {
          messagesDate.push(msg[i]);
        }
      }
    }
    else {
  // Get msgs for selected folder
      var folder = window.arguments[0].inn.folder;
      // Get msgs in subfolders
      var msg = new Array();
      technalxs.simplemail.SimpleMailManageFolder.forEachFolder(folder, function(f) {
        msg = msg.concat(technalxs.simplemail.SimpleMailOverlay.storage.getFolderMessages(f.id));
      });

      var messagesDate = new Array();
      for(var i = msg.length - 1; i >= 0; i--) {
        if ((msg[i].date)< dateValue) {
          messagesDate.push(msg[i]);
        }
      }
    }
    SimpleMailArchive.setProgress(10);

  // Check if messages exists 
    if (msg.length < 1 || messagesDate.length < 1) {
      var confirmText = technalxs.simplemail.SimpleMailBundle.getString("nomailAlert");
      technalxs.simplemail.SimpleMailUtils.alert(confirmText);
      deck.setAttribute("selectedIndex", "0");
      return;
    }

  // Create file    
    if ((technalxs.simplemail.SimpleMailDom.get("archiveType").selectedIndex == 0)) {
      var file = Components.classes["@mozilla.org/file/directory_service;1"]
                 .getService(Components.interfaces.nsIProperties)
                 .get("TmpD", Components.interfaces.nsIFile);
      file.append("simplemail.tmp");
      file.createUnique(file.NORMAL_FILE_TYPE, 0666);
      if (!file) {
        deck.setAttribute("selectedIndex", "0");
        return;
      }
    }
    else if ((technalxs.simplemail.SimpleMailDom.get("archiveType").selectedIndex == 1)) {
      SimpleMailArchive.outputFolder();
      if (!file) {
        deck.setAttribute("selectedIndex", "0");
        return;
      }
    }
    else if ((technalxs.simplemail.SimpleMailDom.get("choice").selectedIndex == 0) && (technalxs.simplemail.SimpleMailDom.get("archiveType").selectedIndex == 2)) {
      var date = technalxs.simplemail.SimpleMailDate.toShortString(dateValue);
      var date = date.replace(/\//g,"-");  
      var file = technalxs.simplemail.SimpleMailFile.chooseFile("save", [], Accountlabel+" - "+date);
      if (!file) {
        deck.setAttribute("selectedIndex", "0");
        return;
      }
    }
    else if ((technalxs.simplemail.SimpleMailDom.get("choice").selectedIndex == 1) && (technalxs.simplemail.SimpleMailDom.get("archiveType").selectedIndex == 2)) {
      var date = technalxs.simplemail.SimpleMailDate.toShortString(dateValue);
      var date = date.replace(/\//g,"-");  
      var file = technalxs.simplemail.SimpleMailFile.chooseFile("save", [], folder.getName()+" - "+date);
      if (!file) {
        deck.setAttribute("selectedIndex", "0");
        return;
      } 
    }

    var out = technalxs.simplemail.SimpleMailFile.createOutputStream(file);
    SimpleMailArchive.setProgress(20);

  // Write file
    for(var i = msg.length - 1; i >= 0; i--) {
      if ((msg[i].date)< dateValue) {
        var source = technalxs.simplemail.SimpleMailFile.getAttachmentsDirectory(msg[i].attachmentsDir);
        source.append(technalxs.simplemail.SimpleMailFile.MESSAGE_SOURCE);
        out.write("From - " + new Date(msg[i].date) + "\r\n");
        out.write(technalxs.simplemail.SimpleMailFile.readFile(source) + "\r\n\r\n");
        SimpleMailArchive.setProgress(30);
      }
    }
    out.close();
    SimpleMailArchive.setProgress(40);

  // Zip file
    if (technalxs.simplemail.SimpleMailDom.get("archiveType").selectedIndex == 0) {
      var PR_RDWR        = 0x04
  	  var PR_CREATE_FILE = 0x08
  	  var PR_TRUNCATE    = 0x20
  	  var COMPRESSION_BEST    = 9;
      var zipWriter = Components.Constructor("@mozilla.org/zipwriter;1","nsIZipWriter");
      var zipW = new zipWriter();
      var date = technalxs.simplemail.SimpleMailDate.toShortString(dateValue);
      var date = date.replace(/\//g,"-"); 

      if (technalxs.simplemail.SimpleMailDom.get("choice").selectedIndex == 0){
        var out = technalxs.simplemail.SimpleMailFile.chooseFile("save", ["*.zip"], Accountlabel+" - "+date+".zip");
        if (!out) {
          deck.setAttribute("selectedIndex", "0");
          file.remove(true);
          return;
        }
      }
      else {
        var out = technalxs.simplemail.SimpleMailFile.chooseFile("save", ["*.zip"], folder.getName()+" - "+date+".zip");
        if (!out) {
          deck.setAttribute("selectedIndex", "0");
          file.remove(true);
          return;
        } 
      }

     var zipfile = technalxs.simplemail.SimpleMailFile.getNsiFile(out);
     var file = technalxs.simplemail.SimpleMailFile.getNsiFile(file);
  
     zipW.open(zipfile, PR_RDWR | PR_CREATE_FILE | PR_TRUNCATE);

     var path = out.leafName.slice(0, -4);
     SimpleMailArchive.setProgress(50);
     zipW.addEntryFile(path, Components.interfaces.nsIZipWriter.COMPRESSION_BEST, file, false);
     zipW.close();
     file.remove(true);
     SimpleMailArchive.setProgress(60);
    }
    SimpleMailArchive.setProgress(70);

  // Delete messages
    if (technalxs.simplemail.SimpleMailDom.get('deletemessages').checked) {
      var msgs = new Array();
        for(var i = msg.length - 1; i >= 0; i--) {
          if ((msg[i].date)< dateValue) {
            msgs.push(msg[i]);
          }
        SimpleMailArchive.setProgress(80);
        }
      var confirmText = technalxs.simplemail.SimpleMailBundle.getString("deleteMessages");
      technalxs.simplemail.SimpleMailOverlay.askDeleteMail(msgs, confirmText, window);
      SimpleMailArchive.setProgress(80);
    }
    SimpleMailArchive.setProgress(90);
    return(true);
  },

  // Archive in folder
  outputFolder: function() {
    var deck = technalxs.simplemail.SimpleMailDom.get("stateDeck");
    var dateValue = new Date(technalxs.simplemail.SimpleMailPrefs.getString('dateValue'));
    if (new Date(technalxs.simplemail.SimpleMailPrefs.getString('dateValue')) > SimpleMailArchive.initialize.today ){
      var confirmText = technalxs.simplemail.SimpleMailBundle.getString("archiveAlert");
        if (!technalxs.simplemail.SimpleMailUtils.confirm(confirmText)) {
          deck.setAttribute("selectedIndex", "0");
          return;
        }
     }

  // Get msgs for account   
    if (technalxs.simplemail.SimpleMailDom.get("choice").selectedIndex == 0) {
      var selectedAccount = technalxs.simplemail.SimpleMailDom.get("accountId").selectedItem.value;
      var Accountlabel = technalxs.simplemail.SimpleMailDom.get("accountId").selectedItem.label;
      var Accountlabel = Accountlabel.replace(/(<).*?/g,"(");
      var Accountlabel = Accountlabel.replace(/(>).*?/g,")");
      var msg = new Array();  
      var msg = technalxs.simplemail.SimpleMailOverlay.storage.getAccountMessages(selectedAccount);
      
      var messagesDate = new Array();
      for(var i = msg.length - 1; i >= 0; i--) {
        if ((msg[i].date)< dateValue) {
          messagesDate.push(msg[i]);
        }
      }
    }
    else {
  // Get msgs for selected folder
      var folder = window.arguments[0].inn.folder;
      // Get msgs in subfolders
      var msg = new Array();
      technalxs.simplemail.SimpleMailManageFolder.forEachFolder(folder, function(f) {
        msg = msg.concat(technalxs.simplemail.SimpleMailOverlay.storage.getFolderMessages(f.id));
      });
      
      var messagesDate = new Array();
      for(var i = msg.length - 1; i >= 0; i--) {
        if ((msg[i].date)< dateValue) {
          messagesDate.push(msg[i]);
        }
      }
    }
    SimpleMailArchive.setProgress(10);

  // Check if messages exists 
    if (msg.length < 1 || messagesDate.length < 1) {
      var confirmText = technalxs.simplemail.SimpleMailBundle.getString("nomailAlert");
      technalxs.simplemail.SimpleMailUtils.alert(confirmText);
      deck.setAttribute("selectedIndex", "0");
      return;
    }

  // Create folder
    var name = {};
    if (technalxs.simplemail.SimpleMailUtils.prompt("folderName", name) && name.value) {
    // Check if Archives folder exist
      var archiveFolder = name.value;
      var file = technalxs.simplemail.SimpleMailFile.getDataDirectory();
      file.append("simplemail.sqlite");

      var storageService = Components.classes["@mozilla.org/storage/service;1"]
                         .getService(Components.interfaces.mozIStorageService);
      var connection = storageService.openDatabase(file);

      var statement = connection.createStatement("SELECT id, parentId, name, open FROM folders");
      try {
        var foldersNames = new Array();
        var foldersId = new Array();
        while(statement.executeStep()) {
          var id = statement.getInt32(0);
          var name = SimpleMailArchive.getString(statement, 2);
          foldersNames.push(name);
          foldersId.push(id);
        }
      }
      finally {
        statement.reset();
      }

      for(var i = foldersNames.length - 1; i >= 0; i--) {
        if ((foldersNames[i]==archiveFolder)) {
          var confirmText = technalxs.simplemail.SimpleMailBundle.getString("alreadyExist");
          technalxs.simplemail.SimpleMailUtils.alert(confirmText);
          deck.setAttribute("selectedIndex", "0");
          return;
        }
      }
    }
    else {
      deck.setAttribute("selectedIndex", "0");
      return;
    }
  // Write Folder
      var folderA = new technalxs.simplemail.SimpleMailModel.SimpleMailFolder(null, null, archiveFolder);
      folderTree = window.arguments[0].inn.folderTree;
      folderTree.view = technalxs.simplemail.folderTreeView; 
      technalxs.simplemail.SimpleMailManageFolder.setFolderParent(folderA, 0);

  // Move Messages
    for(var i = msg.length - 1; i >= 0; i--) {
      if ((msg[i].date)< dateValue) {
        msg[i].folderId = folderA.id;
        technalxs.simplemail.SimpleMailOverlay.storage.saveMessageState(msg[i]);
      }
    SimpleMailArchive.setProgress(60);
    }   
    SimpleMailArchive.setProgress(90);
    return(true);
  },

  onClose: function() {
    technalxs.simplemail.SimpleMailPrefs.clear('dateValue');
  }
}