if(typeof(technalxs) == "undefined") {var technalxs = {};};
if(typeof(technalxs.simplemail) == "undefined" ) {technalxs.simplemail = {};};

technalxs.simplemail.SimpleMailManageFolder = function(){
  var pub = {};

  pub.contextFolder = null,
  pub.foldersCounts = null,
  pub.result = null,
  pub.msgsFolder = [],
  pub.msgsFolders = [],
  pub.tmpString = null,
  pub.chunkSize = 96*1024*1024,
  
  pub.displayInbox = function() {
    var browserWindow = technalxs.simplemail.SimpleMailUtils.getBrowserWindow();
    browserWindow.focus();
  
    var gBrowser = browserWindow.getBrowser();
    gBrowser.selectedTab = technalxs.simplemail.SimpleMailUtils.getDocumentTab(document);

    if (folderTree.currentIndex != 0) {
      folderTree.view.selection.select(0);
    }
    else technalxs.simplemail.messageTreeView.selectFirstMessage();
    messageTree.focus();
  },
  
  pub.getCurrentFolder = function() {
    return technalxs.simplemail.SimpleMailManageFolder.getFolder(folderTree.currentIndex);
  },
  
  pub.getFolder = function(row) {
    technalxs.simplemail.SimpleMailManageFolder.index = 0;
    technalxs.simplemail.SimpleMailManageFolder.forEachOpenFolder(0, function(folder) {
                           if (technalxs.simplemail.SimpleMailManageFolder.index++ == row) technalxs.simplemail.SimpleMailManageFolder.result = folder;
                         });
    return technalxs.simplemail.SimpleMailManageFolder.result;
  },
  
  pub.forEachOpenFolder = function(parentId, onFolder, level) {
    if (!level) level = 0;
    var children = folders[parentId];
    for(var i in children) {
      var child = children[i];
      onFolder(child, level);
      if (child.open) {
        technalxs.simplemail.SimpleMailManageFolder.forEachOpenFolder(child.id, onFolder, level + 1);
      }
    }
  },
  
  pub.getFolderRow = function(folderId) {
    technalxs.simplemail.SimpleMailManageFolder.index = 0;
    var row;
    technalxs.simplemail.SimpleMailManageFolder.forEachOpenFolder(0, function(f) {
                           if (f.id == folderId) row = technalxs.simplemail.SimpleMailManageFolder.index;
                           technalxs.simplemail.SimpleMailManageFolder.index++;
                         });
    return row;
  },
  
  pub.getChildCount = function(folderId) {
    var count = 0;
    technalxs.simplemail.SimpleMailManageFolder.forEachOpenFolder(folderId, function() { count++; });
    return count;
  },
  
  pub.populateFolderMenu = function(event) {
    var row = {}, column = {}, child = {};
    technalxs.simplemail.folderTreeView.treebox.getCellAt(event.clientX, event.clientY, row,
                                     column, child);
    technalxs.simplemail.SimpleMailManageFolder.contextFolder = (row.value != -1) ? technalxs.simplemail.SimpleMailManageFolder.getFolder(row.value) : null;
    var isCustomFolder = technalxs.simplemail.SimpleMailManageFolder.contextFolder && technalxs.simplemail.SimpleMailManageFolder.contextFolder.id > technalxs.simplemail.SimpleMailModel.SimpleMailFolder.TRASH;
    technalxs.simplemail.SimpleMailDom.get("folder-menu-rename").hidden = !isCustomFolder || technalxs.simplemail.SimpleMailManageFolder.contextFolder.getName() == "SPAM";
    technalxs.simplemail.SimpleMailDom.get("folder-menu-delete").hidden = !isCustomFolder;
    technalxs.simplemail.SimpleMailDom.get("folder-menu-import").hidden = !technalxs.simplemail.SimpleMailManageFolder.contextFolder;
    technalxs.simplemail.SimpleMailDom.get("folder-menu-archive").hidden = !technalxs.simplemail.SimpleMailManageFolder.contextFolder;
    technalxs.simplemail.SimpleMailDom.get("folder-menu-empty").hidden = !technalxs.simplemail.SimpleMailManageFolder.contextFolder ||
                                            technalxs.simplemail.SimpleMailManageFolder.contextFolder.id != technalxs.simplemail.SimpleMailModel.SimpleMailFolder.TRASH;
  },
  
  pub.setFolderParent = function(folder, parentId) {
    if (folder.parentId == parentId) return;

    if (typeof(technalxs.simplemail.folderTreeView.treebox) == 'undefined'){
      technalxs.simplemail.folderTreeView = folderTreeView;
    }

    technalxs.simplemail.folderTreeView.treebox.beginUpdateBatch();

    if (folder.parentId != null) {
      technalxs.simplemail.folderTreeView.treebox.rowCountChanged(folderTree.currentIndex - 1, -1);
      var siblings = folders[folder.parentId];
      var len = siblings.length;
      loop:
      for(var i=0; i < len; i++) {
        if (typeof(siblings[i]) == 'undefined'){
        // Break loop;
        continue;
        }
        if (siblings[i].id == folder.id) {
          siblings.splice(i, 1);
        }
      }
    }
  
    folder.parentId = parentId;
    if (!folders[parentId]) {
      folders[parentId] = new Array();
    }
    folders[parentId].push(folder);

    var parentRow;
    if (parentId == 0){
      parentRow = technalxs.simplemail.folderTreeView.rowCount - 1
    } else {
      parentRow = technalxs.simplemail.SimpleMailManageFolder.getFolderRow(parentId);
    }
                                   
    if (parentRow) {
      technalxs.simplemail.folderTreeView.treebox.rowCountChanged(parentRow + 1, 1);
    }

    technalxs.simplemail.folderTreeView.treebox.endUpdateBatch();
    technalxs.simplemail.SimpleMailOverlay.storage.saveFolder(folder);
    technalxs.simplemail.SimpleMailManageFolder.updateFolderCounts();
    technalxs.simplemail.SimpleMailOverlay.refreshTab("chrome://simplemail/content/main/main.xul");
  },
  
  pub.checkFolder = function(name, parentId) {
    var folders = technalxs.simplemail.SimpleMailOverlay.storage.getFolders();
    for(var i in folders) {
      var children = folders[i];
      for (var j in children) {
        if (children[j].name.toLowerCase() == name.toLowerCase() && children[j].parentId == parentId) {
          var confirmText = technalxs.simplemail.SimpleMailBundle.getString("alreadyExist");
          technalxs.simplemail.SimpleMailUtils.alert(confirmText);
          return false;
        }
      }
    }
    for (var k in technalxs.simplemail.SimpleMailModel.SimpleMailFolder.DEFAULT_NAMES) {
      var foldersDefault = technalxs.simplemail.SimpleMailModel.SimpleMailFolder.DEFAULT_NAMES[k];
      var folderDefault = technalxs.simplemail.SimpleMailBundle.getString(foldersDefault);
      if (name.toLowerCase() == foldersDefault.toLowerCase() || name.toLowerCase() == folderDefault.toLowerCase()){
        var confirmText = technalxs.simplemail.SimpleMailBundle.getString("alreadyExist");
        technalxs.simplemail.SimpleMailUtils.alert(confirmText);
        return false;
      }
    }
    return true;
  },
  
  pub.addFolder = function() {
    var name = {};
    if (technalxs.simplemail.SimpleMailUtils.prompt("folderName", name) && name.value) {
      var parentId = technalxs.simplemail.SimpleMailManageFolder.contextFolder ? technalxs.simplemail.SimpleMailManageFolder.contextFolder.id : 0;
      if (technalxs.simplemail.SimpleMailManageFolder.checkFolder(name.value, parentId)) {
        var folder = new technalxs.simplemail.SimpleMailModel.SimpleMailFolder(null, null, name.value);
        technalxs.simplemail.SimpleMailManageFolder.setFolderParent(folder, parentId);
      }
    }
  },
  
  pub.renameFolder = function() {
    var name = { value: technalxs.simplemail.SimpleMailManageFolder.contextFolder.getName() };
    var parentId = technalxs.simplemail.SimpleMailManageFolder.contextFolder ? technalxs.simplemail.SimpleMailManageFolder.contextFolder.id : 0;
    if (technalxs.simplemail.SimpleMailUtils.prompt("folderName", name) && name.value) {
      if (technalxs.simplemail.SimpleMailManageFolder.checkFolder(name.value, parentId)) {
        technalxs.simplemail.SimpleMailManageFolder.contextFolder.name = name.value;
        technalxs.simplemail.folderTreeView.treebox.invalidateRow(folderTree.currentIndex);
        technalxs.simplemail.SimpleMailOverlay.storage.saveFolder(technalxs.simplemail.SimpleMailManageFolder.contextFolder);
      }
    }
  },
  
  pub.deleteFolder = function() {
    var folder = technalxs.simplemail.SimpleMailManageFolder.contextFolder;
    var name = technalxs.simplemail.SimpleMailManageFolder.contextFolder.getName();
    if (folder.parentId != technalxs.simplemail.SimpleMailModel.SimpleMailFolder.TRASH &&
        technalxs.simplemail.SimpleMailPrefs.getBool("moveToTrash"))
    {
      if (name == "SPAM") {
        var tmparray = new Array();
        technalxs.simplemail.SimpleMailManageFolder.deleteFilterSPAM(name);
      }
      technalxs.simplemail.SimpleMailPrefs.setBool('movespam', false);
      technalxs.simplemail.SimpleMailPrefs.setBool('trashspam', false);
      technalxs.simplemail.SimpleMailPrefs.setBool('deletespam', false);
      technalxs.simplemail.SimpleMailPrefs.setBool('nospam', true);
      technalxs.simplemail.SimpleMailPrefs.setBool('markspamasread', false);
      // Add
      var parentRow = technalxs.simplemail.SimpleMailManageFolder.getFolderRow(folder.parentId);
      var parentFolder = technalxs.simplemail.SimpleMailManageFolder.getFolder(parentRow);
      var children = technalxs.simplemail.SimpleMailManageFolder.getChildCount(folder.parentId);
      if (parentFolder.open && children == 1) {
        technalxs.simplemail.folderTreeView.toggleOpenState(parentRow);
      }
      return technalxs.simplemail.SimpleMailManageFolder.setFolderParent(folder, technalxs.simplemail.SimpleMailModel.SimpleMailFolder.TRASH);  
    }
    
    var confirmText = technalxs.simplemail.SimpleMailBundle.getString("deleteFolder", [name]);
    if (name == "SPAM") {
      technalxs.simplemail.SimpleMailManageFolder.askDeleteFolder(folder, confirmText);
      technalxs.simplemail.SimpleMailManageFolder.deleteFilterSPAM(name);
    }
    else{
      technalxs.simplemail.SimpleMailManageFolder.askDeleteFolder(folder, confirmText);
    }  
  },

  pub.deleteFilterSPAM = function(name) {
    var filters = technalxs.simplemail.SimpleMailOverlay.storage.getFilters();
    for(var i in filters) {
      if (filters[i].name == name) {
        var filterSPAM = filters[i];
        if (technalxs.simplemail.SimpleMailUtils.confirm(technalxs.simplemail.SimpleMailBundle.getString("deleteFilter"))) {
          technalxs.simplemail.SimpleMailOverlay.storage.deleteFilter(filterSPAM);
        }
      }
    }
  },
  
  pub.emptyTrash = function() {
    if (!technalxs.simplemail.SimpleMailManageFolder.isTrashEmpty()) {
      var confirmText = technalxs.simplemail.SimpleMailBundle.getString("emptyTrash");
      technalxs.simplemail.SimpleMailManageFolder.askDeleteFolder(technalxs.simplemail.SimpleMailManageFolder.contextFolder, confirmText, true);
    }
  },
  
  pub.forEachFolder = function(folder, onFolder) {
    var children = folders[folder.id];
    for(var i in children) {
      technalxs.simplemail.SimpleMailManageFolder.forEachFolder(children[i], onFolder);
    }
    onFolder(folder);
  },
  
  pub.getFolderMessages = function (folder) {
    technalxs.simplemail.SimpleMailManageFolder.msgsFolders = [];
    technalxs.simplemail.SimpleMailManageFolder.forEachFolder(folder, function(f) {
      technalxs.simplemail.SimpleMailManageFolder.msgsFolders = technalxs.simplemail.SimpleMailManageFolder.msgsFolders.concat(technalxs.simplemail.SimpleMailOverlay.storage.getFolderMessages(f.id));
    });
    return technalxs.simplemail.SimpleMailManageFolder.msgsFolders;
  },  

  pub.askDeleteFolder = function(folder, confirmText, childrenOnly, onExit) {

    function doDeleteFolder() {
      technalxs.simplemail.SimpleMailOverlay.storage.deleteFolder(folder, childrenOnly);

      if (!onExit) {
        // Update tree: delete child folders
        var folderRow = technalxs.simplemail.SimpleMailManageFolder.getFolderRow(folder.id);
        var children = folderRow && folder.open ? technalxs.simplemail.SimpleMailManageFolder.getChildCount(folder.id) : 0;
  
        technalxs.simplemail.SimpleMailManageFolder.forEachFolder(folder, function(f) {
          delete folders[f.id];
        });
  
        technalxs.simplemail.folderTreeView.treebox.rowCountChanged(folderRow, -children);
  
        if (childrenOnly) {
          if (folderRow == folderTree.currentIndex) technalxs.simplemail.SimpleMailManageFolder.displayInbox();
          return;
        }
  
        // Update tree: delete folder itself
        var siblings = folders[folder.parentId];
        var len = siblings.length;
        for(var i=0; i < len; i++) {
          if (siblings[i].id == folder.id) {
            siblings.splice(i, 1);
            technalxs.simplemail.folderTreeView.treebox.rowCountChanged(folderRow - 1, -1);
          }
        }
        // Add
        var parentRow = technalxs.simplemail.SimpleMailManageFolder.getFolderRow(folder.parentId);
        var parentFolder = technalxs.simplemail.SimpleMailManageFolder.getFolder(parentRow);
        var parentChildren = technalxs.simplemail.SimpleMailManageFolder.getChildCount(folder.parentId);
        if (parentFolder.open && parentChildren == 1) {
          technalxs.simplemail.folderTreeView.toggleOpenState(parentRow);
        }
           
        if (folder.name == "SPAM"){
          technalxs.simplemail.SimpleMailPrefs.setBool('movespam', false);
          technalxs.simplemail.SimpleMailPrefs.setBool('trashspam', false);
          technalxs.simplemail.SimpleMailPrefs.setBool('deletespam', false);
          technalxs.simplemail.SimpleMailPrefs.setBool('nospam', true);
          technalxs.simplemail.SimpleMailPrefs.setBool('markspamasread', false);
        }
      }
    }
    // All messages including subfolders
    technalxs.simplemail.SimpleMailManageFolder.msgsFolder = technalxs.simplemail.SimpleMailManageFolder.getFolderMessages(folder);

    if (technalxs.simplemail.SimpleMailManageFolder.msgsFolder.length) {
      technalxs.simplemail.SimpleMailOverlay.askDeleteMail(technalxs.simplemail.SimpleMailManageFolder.msgsFolder, confirmText, window, function() {
        if (technalxs.simplemail.SimpleMailManageFolder.getFolderMessages(folder).length == 0) doDeleteFolder();
      });
    }
    else if (technalxs.simplemail.SimpleMailUtils.confirm(confirmText)) doDeleteFolder();
  },

  pub.importFolder = function() {
    var folder = technalxs.simplemail.SimpleMailManageFolder.getCurrentFolder();
    var files = technalxs.simplemail.SimpleMailFile.chooseFile("multiple");
    if (!files) return;

    for(var i in files) {
      technalxs.simplemail.SimpleMailManageFolder.tmpString = null;
      var file = files[i];
      var thefile = File(file);
      var fileSize = (thefile.size - 1)
      var currentFilePointer = 0;         
      if (fileSize <= technalxs.simplemail.SimpleMailManageFolder.chunkSize) {
        technalxs.simplemail.SimpleMailManageFolder.chunkSize = fileSize;
      }
      var totalBytesRemaining = fileSize;
      var reader = new FileReader();

      reader.onloadend = function(evt) {
        if (evt.target.readyState == FileReader.DONE) {
          var tmpResult = new Array();
          var tmpArray = new Array();
          var tmpResult1 = new Array();
          var tmpfinalResult = new Array(); 
          var chunks;
          chunks = evt.target.result.split(/(?=^From .*\r\n)|\r?\n(?=From .*\r\n)/);
          var len = chunks.length;
          for(var j = 0; j < len; j++) {
            if(typeof(chunks[j+1]) !== 'undefined' && (chunks[j].match(/^From .*\r\n/) && chunks[j+1].match(/^From .*\r\n/))){
                tmpResult.push(chunks[j]); // Chunks is a complete message without attachment
            } else if ((chunks[j].match(/^From .*\r\n/) && chunks[j].match(/--\r\n$/))) {
              tmpResult.push(chunks[j]); // Chunks is a complete message with attachment
            } else { // Chunks is a part of a message
              if (technalxs.simplemail.SimpleMailManageFolder.tmpString == null) {  // First pass
                technalxs.simplemail.SimpleMailManageFolder.tmpString = chunks[j].toString();
              } else { // Other pass
                technalxs.simplemail.SimpleMailManageFolder.tmpString += chunks[j].toString();
              }
            }  
          }

          if (technalxs.simplemail.SimpleMailManageFolder.tmpString !== null) {
            tmpArray = technalxs.simplemail.SimpleMailManageFolder.tmpString.split(/(?=^From .*\r\n)|\r?\n(?=From .*\r\n)/);
            technalxs.simplemail.SimpleMailManageFolder.tmpString = "";
            var len2 = tmpArray.length;
            for (var x = 0; x < len2; x++) {
              if (typeof(tmpArray[x+1]) !== 'undefined' && (tmpArray[x].match(/^From .*\r\n/) && tmpArray[x+1].match(/^From .*\r\n/))) {
                tmpResult1.push(tmpArray[x]); // tmpArray is a complete message without attachment
              } else if ((tmpArray[x].match(/^From .*\r\n/) && tmpArray[x].match(/--\r\n$/))) {
                tmpResult1.push(tmpArray[x]);  // tmpArray is a complete message with attachment
              } else  { // tmpArray is a part of a message
                if (technalxs.simplemail.SimpleMailManageFolder.tmpString == "") {  // First pass
                  technalxs.simplemail.SimpleMailManageFolder.tmpString = tmpArray[x].toString();
                } else { // Other pass
                  technalxs.simplemail.SimpleMailManageFolder.tmpString += tmpArray[x].toString();
                }
              }
            }
          }

          if (tmpResult != "") {  
            tmpfinalResult = tmpResult.concat(tmpResult1)
          }
          if (file.leafName.match(/\.eml$/)) {
            tmpfinalResult = [ evt.target.result ];
          }  
          var len = tmpfinalResult.length;
          var msgs = new Array();
          for(var j = 0; j < len; j++) {
            var chunk = tmpfinalResult[j].replace(/\r\n$/, "");
            var message = technalxs.simplemail.SimpleMailModel.SimpleMailMessage.parse(chunk, true);
            message.folderId = folder.id;
            technalxs.simplemail.SimpleMailOverlay.storage.saveMessage(message);
          } 
          readFileInBlocks();
        }
      }
      readFileInBlocks();
    }

    function readFileInBlocks() {
      if (totalBytesRemaining > 0) {
        var title = technalxs.simplemail.SimpleMailBundle.getString("import");
        var text = technalxs.simplemail.SimpleMailBundle.getString("importText");
        try {
          Components.classes['@mozilla.org/alerts-service;1'].
                    getService(Components.interfaces.nsIAlertsService).
                    showAlertNotification("chrome://simplemail/skin/status/mail_std_large.png", title, text, false, '', null);      
        } catch (e) {
          // This can fail on Mac OS X
          var win = Components.classes['@mozilla.org/embedcomp/window-watcher;1'].
                      getService(Components.interfaces.nsIWindowWatcher).
                      openWindow(null, 'chrome://global/content/alerts/alert.xul',
                                  '_blank', 'chrome,titlebar=no,popup=yes', null);
          win.arguments = ["chrome://simplemail/skin/status/mail_std_large.png", title, text, false, ''];          
        }
        var fileChunk = thefile.slice(currentFilePointer, currentFilePointer + technalxs.simplemail.SimpleMailManageFolder.chunkSize);
        reader.readAsBinaryString(fileChunk);
        currentFilePointer += technalxs.simplemail.SimpleMailManageFolder.chunkSize;
        totalBytesRemaining -= technalxs.simplemail.SimpleMailManageFolder.chunkSize;
        if (totalBytesRemaining <= technalxs.simplemail.SimpleMailManageFolder.chunkSize) {
          technalxs.simplemail.SimpleMailManageFolder.chunkSize = totalBytesRemaining;
        }
      } else { // End of read then parse and save messages
        var finalResult;
        var tmpArray2 = new Array();
        try {
          var title = technalxs.simplemail.SimpleMailBundle.getString("import");
          var text = technalxs.simplemail.SimpleMailBundle.getString("importSaving");
          Components.classes['@mozilla.org/alerts-service;1'].
                    getService(Components.interfaces.nsIAlertsService).
                    showAlertNotification("chrome://simplemail/skin/status/mail_std_large.png", title, text, false, '', null);      
        } catch (e) {
          // This can fail on Mac OS X
          var win = Components.classes['@mozilla.org/embedcomp/window-watcher;1'].
                      getService(Components.interfaces.nsIWindowWatcher).
                      openWindow(null, 'chrome://global/content/alerts/alert.xul',
                                  '_blank', 'chrome,titlebar=no,popup=yes', null);
          win.arguments = ["chrome://simplemail/skin/status/mail_std_large.png", title, text, false, ''];          
        }       

        if (!file.leafName.match(/\.eml$/)) {
          if (technalxs.simplemail.SimpleMailManageFolder.tmpString !== null) {
            tmpArray2 = technalxs.simplemail.SimpleMailManageFolder.tmpString.split(/(?=^From .*\r\n)|\r?\n(?=From .*\r\n)/);
            finalResult = tmpArray2;
          }

          var len = finalResult.length;
          var msgs = new Array();
          for(var j = 0; j < len; j++) {
            var chunk = finalResult[j].replace(/\r\n$/, "");
            var message = technalxs.simplemail.SimpleMailModel.SimpleMailMessage.parse(chunk, true);
            message.folderId = folder.id;
            technalxs.simplemail.SimpleMailOverlay.storage.saveMessage(message);
          }
        }
        // Refresh UI
        setTimeout (function () {
          try {
          var title = technalxs.simplemail.SimpleMailBundle.getString("import");
          var text = technalxs.simplemail.SimpleMailBundle.getString("importOk");
          Components.classes['@mozilla.org/alerts-service;1'].
                    getService(Components.interfaces.nsIAlertsService).
                    showAlertNotification("chrome://simplemail/skin/status/mail_std_large.png", title, text, false, '', null);      
          } catch (e) {
            // This can fail on Mac OS X
            var win = Components.classes['@mozilla.org/embedcomp/window-watcher;1'].
                      getService(Components.interfaces.nsIWindowWatcher).
                      openWindow(null, 'chrome://global/content/alerts/alert.xul',
                                '_blank', 'chrome,titlebar=no,popup=yes', null);
            win.arguments = ["chrome://simplemail/skin/status/mail_std_large.png", title, text, false, ''];          
          }          
          technalxs.simplemail.SimpleMailManageFolder.updateFolderCounts();
          technalxs.simplemail.SimpleMailOverlay.updateIcons();
          technalxs.simplemail.SimpleMailOverlay.refreshTab("chrome://simplemail/content/main/main.xul");
        },500);
      }
    }
  },

  pub.getFolderCount = function(folderId, name) {
    if (!technalxs.simplemail.SimpleMailManageFolder.folderCounts) technalxs.simplemail.SimpleMailManageFolder.folderCounts = technalxs.simplemail.SimpleMailOverlay.storage.updateFolderCounts();
    var counts = technalxs.simplemail.SimpleMailManageFolder.folderCounts && technalxs.simplemail.SimpleMailManageFolder.folderCounts[folderId];
    return counts && counts[name] || 0;
  },
  
  pub.updateFolderCounts = function() {
    technalxs.simplemail.SimpleMailManageFolder.folderCounts = null;
    technalxs.simplemail.folderTreeView.treebox.invalidate();
    technalxs.simplemail.SimpleMailOverlay.updateIcons();
  },
  
  pub.isTrashEmpty = function() {
    var children = folders[technalxs.simplemail.SimpleMailModel.SimpleMailFolder.TRASH];
    return (!children || !children.length) && !technalxs.simplemail.SimpleMailManageFolder.getFolderCount(technalxs.simplemail.SimpleMailModel.SimpleMailFolder.TRASH, "total");
  },
  
  // Get folder's id by name
  pub.getFolderId = function(folderName) {
    var folders = technalxs.simplemail.SimpleMailOverlay.storage.getFolders();
    for(var i in folders) {
      var children = folders[i];
      for (var j in children) {
        if (children[j].name == folderName){
          var folderNameId = children[j].id
          return folderNameId
        }
      }
    }
  }
  return pub;
}();

technalxs.simplemail.folderTreeView = function(){
  var pub = {
    get rowCount() {
      return technalxs.simplemail.SimpleMailManageFolder.getChildCount(0);
    }
  };

  pub.result = null,
  pub.row = null,  
  
  pub.getCellText = function(row, column) {
    var folder = technalxs.simplemail.SimpleMailManageFolder.getFolder(row);
    var name = column.id.replace(/folder-/, "");
    var count = technalxs.simplemail.SimpleMailManageFolder.getFolderCount(folder.id, name);
    switch(name) {
      case "name":   return folder.getName();
      case "size":   return technalxs.simplemail.SimpleMailUtils.size2string(count);
      default:       return count;
    }
  },
  
  pub.getCellProperties = function(row, column, props) {
    var folder = technalxs.simplemail.SimpleMailManageFolder.getFolder(row);
    var folderProps = new Array();
    var name = column.id.replace(/folder-/, "");
    switch(name) {
      case "name":
        var type = (folder.id == technalxs.simplemail.SimpleMailModel.SimpleMailFolder.TRASH) ? "trash" : "folder";
        if (props) {
          var atom = technalxs.simplemail.folderTreeView.atomService.getAtom(type);
          props.AppendElement(atom);
        } else folderProps.push(type);
        if (folder.id == technalxs.simplemail.SimpleMailModel.SimpleMailFolder.TRASH && technalxs.simplemail.SimpleMailManageFolder.isTrashEmpty()) {
          if (props) {
            var atom = technalxs.simplemail.folderTreeView.atomService.getAtom("empty");
            props.AppendElement(atom);
          } else folderProps.push("empty");
        }
        technalxs.simplemail.SimpleMailManageFolder.getFolderId("SPAM");
          if (folder.name == "SPAM"){
            if (props) {
              var atom = technalxs.simplemail.folderTreeView.atomService.getAtom("spamfolder");
              props.AppendElement(atom);
            } else folderProps.push("spamfolder");
          }
        if (technalxs.simplemail.SimpleMailManageFolder.getFolderCount(folder.id, "unread") ||
            (technalxs.simplemail.SimpleMailManageFolder.getFolderCount(folder.id, "childUnread") && !folder.open))
        {
          if (props) {
            var atom = technalxs.simplemail.folderTreeView.atomService.getAtom("unread");
            props.AppendElement(atom);
          } else folderProps.push("unread");
        }
        break;
      case "unread":
        if (technalxs.simplemail.SimpleMailManageFolder.getFolderCount(folder.id, "unread")) {
          if (props) {
            var atom = technalxs.simplemail.folderTreeView.atomService.getAtom("unread");
            props.AppendElement(atom);
          } else folderProps.push("unread");
        }
        break;
    }
    return folderProps.join(" ");
  },
  
  pub.isContainer = function(row) {
    return true;
  },
  
  pub.isContainerOpen = function(row) {
    return technalxs.simplemail.SimpleMailManageFolder.getFolder(row).open;
  },
  
  pub.isContainerEmpty = function(row) {
    var folder = technalxs.simplemail.SimpleMailManageFolder.getFolder(row);
    return !folders[folder.id] || folders[folder.id].length == 0;
  },
  
  pub.getParentIndex = function(row) {
    var folder = technalxs.simplemail.SimpleMailManageFolder.getFolder(row);
    return technalxs.simplemail.SimpleMailManageFolder.getFolderRow(folder.parentId) || -1;
  },
  
  pub.getLevel = function(row) {
    technalxs.simplemail.SimpleMailManageFolder.index = 0;
    technalxs.simplemail.SimpleMailManageFolder.forEachOpenFolder(0, function(folder, level) {
                           if (technalxs.simplemail.SimpleMailManageFolder.index++ == row) technalxs.simplemail.folderTreeView.result = level;
                         });
    return technalxs.simplemail.folderTreeView.result;
  },
  
  pub.hasNextSibling = function(row, afterRow) {
    var folder = technalxs.simplemail.SimpleMailManageFolder.getFolder(row);
    technalxs.simplemail.SimpleMailManageFolder.index = 0;
    technalxs.simplemail.SimpleMailManageFolder.forEachOpenFolder(folder.parentId,
                      function(f, level) {
                        if (f.id == folder.id) technalxs.simplemail.SimpleMailManageFolder.index = 0;
                        if (level == 0 &&
                            technalxs.simplemail.SimpleMailManageFolder.index > afterRow - row) technalxs.simplemail.folderTreeView.result = true;
                            technalxs.simplemail.SimpleMailManageFolder.index++;
                      });
    return technalxs.simplemail.folderTreeView.result;
  },
  
  pub.toggleOpenState = function(row) {
    var folder = technalxs.simplemail.SimpleMailManageFolder.getFolder(row);
    if (!folder.open && technalxs.simplemail.folderTreeView.isContainerEmpty(row)) return;

    folder.open = !folder.open;
    technalxs.simplemail.folderTreeView.treebox.rowCountChanged(row + 1,
      (folder.open ? 1 : -1) * technalxs.simplemail.SimpleMailManageFolder.getChildCount(folder.id));

    technalxs.simplemail.SimpleMailOverlay.storage.saveFolder(folder);
  },
  
  pub.canDrop = function(row, orientation) {
    if (orientation == technalxs.simplemail.folderTreeView.DROP_ON) {
      if (technalxs.simplemail.dragObserver.source == messageTree) return true;

      if (technalxs.simplemail.dragObserver.source == folderTree) {
        // Deny setting self or child as a parent
        var folder = technalxs.simplemail.SimpleMailManageFolder.getCurrentFolder();
        var newParent = technalxs.simplemail.SimpleMailManageFolder.getFolder(row);

        technalxs.simplemail.folderTreeView.result = folder.id != newParent.id;
        technalxs.simplemail.SimpleMailManageFolder.forEachOpenFolder(folder.id, function(f) {
                                       if (f.id == newParent.id) technalxs.simplemail.folderTreeView.result = false;
                                     });
        return technalxs.simplemail.folderTreeView.result;
      }
    }
    if (orientation == technalxs.simplemail.folderTreeView.DROP_AFTER &&
        technalxs.simplemail.dragObserver.source == folderTree &&
        row == technalxs.simplemail.folderTreeView.rowCount - 1) return true;
  },
  
  pub.drop = function(row, orientation) {
    var target = technalxs.simplemail.SimpleMailManageFolder.getFolder(row);

    if (technalxs.simplemail.dragObserver.source == folderTree) {
      var folder = technalxs.simplemail.SimpleMailManageFolder.getCurrentFolder();
      var parentId = (orientation != technalxs.simplemail.folderTreeView.DROP_AFTER) ? target.id : 0;
      technalxs.simplemail.SimpleMailManageFolder.setFolderParent(folder, parentId);
    }
    else if (technalxs.simplemail.dragObserver.source == messageTree) {
      technalxs.simplemail.messageTreeView.moveToFolder(target.id);
    }
    technalxs.simplemail.dragObserver.source = null;
  }
  return pub;
}();

technalxs.simplemail.DefaultTreeView.extend(technalxs.simplemail.folderTreeView);

// Drag-n-Drop
technalxs.simplemail.dragObserver = function(){
  var pub = {};
 
  pub.source = null,
  
  pub.onDragStart = function(event, transferData, action) {
    if (event.target.nodeName != "treechildren") return;

    if (event.target.parentNode == folderTree) {
      var folder = technalxs.simplemail.SimpleMailManageFolder.getCurrentFolder();
      if (folder.id <= technalxs.simplemail.SimpleMailModel.SimpleMailFolder.TRASH) return false;
    }
    transferData.data = new TransferData();
    transferData.data.addDataForFlavour("text/unicode", "");
    technalxs.simplemail.dragObserver.source = event.target.parentNode;
  },
  
  pub.getSupportedFlavours = function() {
    var flavours = new FlavourSet();
    flavours.appendFlavour("text/unicode");
    return flavours;
  },
  
  pub.onDrop = function(event, transferData, session) {}

  return pub;
}();