if(typeof(technalxs) == "undefined") {var technalxs = {};};
if(typeof(technalxs.simplemail) == "undefined" ) {technalxs.simplemail = {};};

technalxs.simplemail.messageTreeView = function(){
  var pub = {
    get rowCount() {
      return technalxs.simplemail.messageTreeView.messages.length;
    }
  };
  
  pub.messages = [],
  
  pub.getCellText = function(row, column) {
    if (column.id == "image" ||
        column.id == "attachmentsCount" ||
        column.id == "read" ||
        column.id == "spam") return null;

    var value = technalxs.simplemail.messageTreeView.messages[row][column.id];
    switch(column.id) {
          case "date": return technalxs.simplemail.SimpleMailDate.toString(value);
          case "size": return technalxs.simplemail.SimpleMailUtils.size2string(value);
          case "folderId": return technalxs.simplemail.SimpleMailOverlay.storage.getFolder(value).getName();
          case "color": return parseInt(value) ? "██" : "";
          default: return value;
    }
  },
  
  pub.getCellValue = function(row, column) {
    return technalxs.simplemail.messageTreeView.messages[row].checked;
  },
  
  pub.setCellValue = function(row, column, value) {
    technalxs.simplemail.messageTreeView.messages[row].checked = value;
    technalxs.simplemail.messageTreeView.cycleCell(row, column);
  },
  
  pub.isEditable = function(row, column) {
    return column.id == "select";
  },
  
  pub.getImageSrc = function(row, column) {
    if (column.id != "image") return null;

    var message = technalxs.simplemail.messageTreeView.messages[row];
    var account = technalxs.simplemail.SimpleMailOverlay.storage.getAccount(message.accountId);
    return message.template ? technalxs.simplemail.SimpleMailFile.getStatusIconURL("notChecked") :
                   !account ? technalxs.simplemail.SimpleMailFile.getStatusIconURL(message.read ? "noMail" : "mail")
                            : technalxs.simplemail.SimpleMailFile.getEnvelopeIconURL(account.color);
  },
  
  pub.getCellProperties = function(row, column, props) {
    var message = technalxs.simplemail.messageTreeView.messages[row];
    var messageProps = new Array();
    if (!message.read) {
      if (props) {
        var atom = technalxs.simplemail.messageTreeView.atomService.getAtom("unread");
        props.AppendElement(atom);
      } else messageProps.push("unread");
    }
    if (column.id == "attachmentsCount" && technalxs.simplemail.messageTreeView.messages[row].attachmentsCount) {
      if (props) {
        var atom = technalxs.simplemail.messageTreeView.atomService.getAtom("attachment");
        props.AppendElement(atom);
      } else messageProps.push("attachment");
    }
    if (column.id == "spam" && message.spam) {
      if (props) {
        var atom = technalxs.simplemail.messageTreeView.atomService.getAtom("spammail");
        props.AppendElement(atom);
      } else messageProps.push("spammail");
    }
    if (column.id == "read" && !message.read) {
      if (props) {
        var atom = technalxs.simplemail.messageTreeView.atomService.getAtom("unreadmail");
        props.AppendElement(atom);
      } else messageProps.push("unreadmail");
    }
    if (column.id == "read" && message.read) {
      if (props) {
        var atom = technalxs.simplemail.messageTreeView.atomService.getAtom("readmail");
        props.AppendElement(atom);
      } else messageProps.push("readmail");
    }
    if (message.color) {
      if (props) {
        var atom = technalxs.simplemail.messageTreeView.atomService.getAtom(SimpleMailCOLORS[message.color]);
        props.AppendElement(atom);
      } else messageProps.push(SimpleMailCOLORS[message.color]);
    }
    if (column.id == "read" && message.read && message.replied) {
      if (props) {
        var atom = technalxs.simplemail.messageTreeView.atomService.getAtom("readreplied");
        props.AppendElement(atom);
      } else messageProps.push("readreplied");
    }
    if (column.id == "read" && !message.read && message.replied) {
      if (props) {
        var atom = technalxs.simplemail.messageTreeView.atomService.getAtom("unreadreplied");
        props.AppendElement(atom);
      } else messageProps.push("unreadreplied");;
    }
    if (column.id == "read" && message.read && message.fwd) {
      if (props) {
        var atom = technalxs.simplemail.messageTreeView.atomService.getAtom("readfwd");
        props.AppendElement(atom);
      } else messageProps.push("readfwd");
    }
    if (column.id == "read" && !message.read && message.fwd) {
      if (props) {
        var atom = technalxs.simplemail.messageTreeView.atomService.getAtom("unreadfwd");
        props.AppendElement(atom);
      } else messageProps.push("unreadfwd");
    }
    return messageProps.join(" ");
  },

  pub.getRowProperties = function(row, props) {
    var message = technalxs.simplemail.messageTreeView.messages[row];
    if (message.color) {
      if (props) {
        var atom = technalxs.simplemail.messageTreeView.atomService.getAtom(SimpleMailCOLORS[message.color]);
        props.AppendElement(atom);
      } else return SimpleMailCOLORS[message.color];
    }
  },
  
  pub.getString = function(statement, id) {
    var text = "text: ";
    var value = statement.getString(id);
    return value && value.substr(0, text.length) == text ? value.substr(text.length) : value;
  },
  
  pub.cycleHeader = function(column) {
    column = technalxs.simplemail.SimpleMailDom.get(column.id);

    if (column.id == "select") {
      var checked = true;
      for (var i = 0; i < technalxs.simplemail.messageTreeView.messages.length; i++) {
        checked &= technalxs.simplemail.messageTreeView.messages[i].checked == "true";
      }
      for (var i = 0; i < technalxs.simplemail.messageTreeView.messages.length; i++) {
        technalxs.simplemail.messageTreeView.messages[i].checked = !checked ? "true" : "false";
      }
      return;
    }

    var sortedColumn = technalxs.simplemail.messageTreeView.getSortedColumn();
    if (sortedColumn && sortedColumn != column) {
      sortedColumn.removeAttribute("sortDirection");
    }            
    var direction = column.getAttribute("sortDirection");
    column.setAttribute("sortDirection",
                        technalxs.simplemail.messageTreeView.nextDirection[direction]);
    technalxs.simplemail.messageTreeView.displayFolder();
  },
  
  pub.onClick = function(event) {
    
    if (typeof(clickcontrol) == 'undefined') {
       var clickcontrol=0;
    }

    if (event.button == 2) {
      var clickcontrol = 1;
      return;
    }

      var row = {}, column = {}, child = {};
      this.treebox.getCellAt(event.clientX, event.clientY, row, column, child);

    if (event.button == 0){
      if (clickcontrol == 1) {
        messageTree.view.selection.clearSelection;
        var clickcontrol = 0;
      }
      else if (clickcontrol == 0 && column.value && column.value.id == "select") {
        var clickcontrol = 1;
        return;
      }
      else if (clickcontrol == 0) {
        technalxs.simplemail.messageTreeView.displayMessageHtml();
      }
    }

    if (!column.value || column.value.id != "select") return;
    // If checkboxes column is Ctrl/Shift clicked, check multiple items
    if (event.ctrlKey || event.shiftKey) {
    clickcontrol = 1;
      technalxs.simplemail.messageTreeView.forEachMessagesSelected(function(index) {
        technalxs.simplemail.messageTreeView.messages[index].checked = "true";
      });
    }
  },
  
  pub.onDisplay = function(event) {
    var body = technalxs.simplemail.SimpleMailDom.get("body");
    if (body.contentDocument.hasFocus() & event.keyCode == 40){
      body.contentWindow.scrollByLines(1);
    } else if (body.contentDocument.hasFocus() & event.keyCode == 38){
      body.contentWindow.scrollByLines(-1);
    } else {
      technalxs.simplemail.messageTreeView.displayMessageHtml(event);
    }
  },
  
  pub.onSelect = function(event) {
  if (typeof(event) !== 'undefined') {
    technalxs.simplemail.messageTreeView.onClick(event);
    }
  },

  pub.action = function() {
    if (technalxs.simplemail.messageTreeView.isPartialSelected()) technalxs.simplemail.messageTreeView.downloadMessageBody();
    else if (technalxs.simplemail.SimpleMailManageFolder.getCurrentFolder().id != technalxs.simplemail.SimpleMailModel.SimpleMailFolder.DRAFTS && technalxs.simplemail.SimpleMailPrefs.getBool('messagesInWindow')) technalxs.simplemail.messageTreeView.openNewWindow();
    else if (technalxs.simplemail.SimpleMailManageFolder.getCurrentFolder().id != technalxs.simplemail.SimpleMailModel.SimpleMailFolder.DRAFTS && technalxs.simplemail.SimpleMailPrefs.getBool('messagesInTab')) technalxs.simplemail.messageTreeView.openNewTab();
    else if (technalxs.simplemail.SimpleMailManageFolder.getCurrentFolder().id != technalxs.simplemail.SimpleMailModel.SimpleMailFolder.DRAFTS) technalxs.simplemail.messageTreeView.toggleRead();
    else {
      var message = technalxs.simplemail.SimpleMailOverlay.storage.getMessage(technalxs.simplemail.messageTreeView.messages[messageTree.currentIndex].id);
      technalxs.simplemail.SimpleMailOverlay.openNewMessage(message);
    }
  },

  pub.onSpamClicked = function(event){
    if (event.type == "dblclick") technalxs.simplemail.SimpleMailOverlay.stop();
    else toggletoSpam();
  },
  
  pub.forEachMessagesSelected = function(onItem) {
    if (!technalxs.simplemail.messageTreeView.forEachChecked(onItem)) {
      technalxs.simplemail.messageTreeView.forEachSelected(onItem);
    }
  },
  
  pub.delete = function (event){
    if (event) {
      technalxs.simplemail.messageTreeView.deleteMail(true);
    } else{
      technalxs.simplemail.messageTreeView.deleteMail();
    }
  },

  pub.openNewWindow = function() {
    var messageTree = technalxs.simplemail.SimpleMailDom.get("message-tree");
    var message = technalxs.simplemail.messageTreeView.messages[messageTree.currentIndex];
    var windowName = message.id;
    
    // Window exist ?
    for (var i = 0; i < technalxs.simplemail.SimpleMailOverlay.openedWindows.length; i++) {
      if (technalxs.simplemail.SimpleMailOverlay.openedWindows[i].name == windowName) {
        technalxs.simplemail.SimpleMailOverlay.openedWindows[i].focus();
        return;
      }
    }

    technalxs.simplemail.SimpleMailPrefs.setObject('message', message);
    technalxs.simplemail.SimpleMailPrefs.setObject('messageTree', messageTree);
    technalxs.simplemail.SimpleMailPrefs.setString('messageIndex', messageTree.currentIndex);
    technalxs.simplemail.SimpleMailPrefs.setString('folderIndex', folderTree.currentIndex);
    var url = "chrome://simplemail/content/main/message.xul";
    technalxs.simplemail.SimpleMailOverlay.messageWindow = window.open(url, windowName, "dependent,chrome=no,location=no,dialog=no,height=400,width=700,resizable");
    technalxs.simplemail.SimpleMailOverlay.openedWindows.push(technalxs.simplemail.SimpleMailOverlay.messageWindow);
  }

  pub.openNewTab = function() {
    var messageTree = technalxs.simplemail.SimpleMailDom.get("message-tree");
    var message = technalxs.simplemail.messageTreeView.messages[messageTree.currentIndex];
    var windowName = message.id;  

    technalxs.simplemail.SimpleMailPrefs.setObject('message', message);
    technalxs.simplemail.SimpleMailPrefs.setObject('messageTree', messageTree);
    technalxs.simplemail.SimpleMailPrefs.setString('messageIndex', messageTree.currentIndex);
    technalxs.simplemail.SimpleMailPrefs.setString('folderIndex', folderTree.currentIndex);
    var url = "chrome://simplemail/content/main/message.xul";  
  
    var gBrowser = technalxs.simplemail.SimpleMailUtils.getBrowser();
    content.location != "about:blank"
        ? gBrowser.selectedTab = gBrowser.addTab(url)
        : content.location.assign(url);
  }
  return pub;
}();

technalxs.simplemail.DefaultTreeView.extend(technalxs.simplemail.messageTreeView);

technalxs.simplemail.messageTreeView.displayMessageHtml = function(event) {
  var body = technalxs.simplemail.SimpleMailDom.get("body");
  body.contentWindow.scroll(0, 0);

  if (typeof(event) !== 'undefined') {
    // Down 
    if (event.keyCode == 40){
      if (messageTree.currentIndex !== technalxs.simplemail.messageTreeView.rowCount-1) {
        var message = technalxs.simplemail.messageTreeView.messages[messageTree.currentIndex + 1];
      }
      else {
        var message = messageTree.currentIndex != -1
                ? technalxs.simplemail.messageTreeView.messages[messageTree.currentIndex] : {};
      }
    }
    // Up
    if (event.keyCode == 38){
      if (messageTree.currentIndex-1 !== -1) {
        var message = technalxs.simplemail.messageTreeView.messages[messageTree.currentIndex - 1];
      }
      else {
        var message = messageTree.currentIndex != -1
                ? technalxs.simplemail.messageTreeView.messages[messageTree.currentIndex] : {};
      }
    }
    // Right - Select last message
    if (event.keyCode == 39){
      event.stopPropagation();
      event.preventDefault();
      var message = technalxs.simplemail.messageTreeView.messages[technalxs.simplemail.messageTreeView.rowCount-1];
      messageTree.view.selection.select(technalxs.simplemail.messageTreeView.rowCount-1);
    }

    // Left - Select First mesage
    if (event.keyCode == 37){
      event.stopPropagation();
      event.preventDefault();
      var message = technalxs.simplemail.messageTreeView.messages[0];
      messageTree.view.selection.select(0);
      messageTree.currentIndex = -1;
      setTimeout (function () { messageTree.currentIndex = 0 }, 100);
    }
  }
  else {
    var message = messageTree.currentIndex != -1
            ? technalxs.simplemail.messageTreeView.messages[messageTree.currentIndex] : {};
  }
         
  technalxs.simplemail.messageTreeView.displayHeaders(message);

  var html = message.partial
               ? technalxs.simplemail.SimpleMailBundle.getString("messageNotDownloaded")
               : message.id ? technalxs.simplemail.SimpleMailOverlay.storage.getMessage(message.id).html : " ";

  var search = technalxs.simplemail.SimpleMailDom.get("search").value;
  if (search) html = technalxs.simplemail.SimpleMailText.highlight(search, html);

  var originalHTML = html;
  
  if (html !== " ") {
    var source = technalxs.simplemail.SimpleMailFile.getAttachmentsDirectory(message.attachmentsDir);
    source.append(technalxs.simplemail.SimpleMailFile.MESSAGE_SOURCE);
    source = technalxs.simplemail.SimpleMailFile.readFile(source);
  }

  if (technalxs.simplemail.SimpleMailPrefs.getBool("plaintextOnReceive") && html !== " ") {
    var partAttachs = technalxs.simplemail.messageTreeView.displayAttachments(html, message);

    var attachments = new Array();
    technalxs.simplemail.SimpleMailMessageEncoder.cidNames = [];
    technalxs.simplemail.SimpleMailMessageEncoder.ContentId = [];
    technalxs.simplemail.SimpleMailMessageEncoder.ContentDisposition = [];
    technalxs.simplemail.SimpleMailMessageEncoder.ContentType = [];
    var tmpMessage = technalxs.simplemail.SimpleMailMessageEncoder.parse(source, attachments, technalxs.simplemail.SimpleMailMessageEncoder.cidNames, technalxs.simplemail.SimpleMailMessageEncoder.ContentId, technalxs.simplemail.SimpleMailMessageEncoder.ContentDisposition, technalxs.simplemail.SimpleMailMessageEncoder.ContentType);

    if (!source.match(/name\=/gim) && !source.match(/filename\=/gim) && !source.match(/Content\-ID\:/gim) || partAttachs == null){  // No Attachments
      var html = technalxs.simplemail.SimpleMailUtils.parseHTML(document, tmpMessage.html, false);
      html = technalxs.simplemail.messageTreeView.plaintextMessage(html);
      html = html.replace(/(\r\n).*?/g,"<br>"); 
    } else {
      if (partAttachs != null) {
        partAttachs = partAttachs.join("");
      }
      if (source.match(/text\/plain/gim)) { // Plaintext part in the message
        var html = tmpMessage.html + "<br>" + partAttachs;
        var html = technalxs.simplemail.SimpleMailUtils.parseHTML(document, html, true);
        html = technalxs.simplemail.messageTreeView.plaintextMessage(html);
      } else {
        // Remove Inline images
        var getImages = tmpMessage.html.toString().match(/<img[^>]*>(.*?)>*/gim); 
        if (getImages != null){
          for (var i in getImages){
            tmpMessage.html = tmpMessage.html.replace(getImages[i], "");
          }
        }
        var html = technalxs.simplemail.SimpleMailUtils.parseHTML(document, tmpMessage.html, true);
        html = technalxs.simplemail.messageTreeView.plaintextMessage(html);
        html = html.replace(/(\r\n).*?/g,"<br>");   
        html = html  + "<br>" + partAttachs;
      }
    }

    if (!(technalxs.simplemail.SimpleMailOverlay.storage.getMessage(message.id).html).match(/\<a\sclass\=\'attachment\'/gim)) {
      message.html = originalHTML;
      technalxs.simplemail.SimpleMailOverlay.storage.updateMessage(message);
    }
  } else {
   html = technalxs.simplemail.messageTreeView.displayAttachments(html, message);
  }

  html = technalxs.simplemail.SimpleMailText.imageToLink(html);
  
  // Change : remove : i don't remember what does this does !!
  /*if (html !== " " && source.toString().match(/Content\-Type\: text\/plain/gim) && technalxs.simplemail.SimpleMailPrefs.getBool("plaintextOnReceive")) {
    html = technalxs.simplemail.SimpleMailText.linkToLink(html);
  }*/
  
  body.contentDocument.title = message.subject;

  if(technalxs.simplemail.SimpleMailPrefs.getBool("removeImages") || technalxs.simplemail.SimpleMailPrefs.getBool("plaintextOnReceive")){
    var getHtmlImages = html.toString().match(/<img[^>]*>(.*?)>*/gim);
    if (getHtmlImages != null){
      for (var k in getHtmlImages){ 
        if (getHtmlImages[k].match(/http/gim)){
          var html = html.replace(getHtmlImages[k], technalxs.simplemail.SimpleMailBundle.getString("removedimages"));
        }
      }
    }
    if (technalxs.simplemail.SimpleMailPrefs.getBool("plaintextOnReceive")){
      html = technalxs.simplemail.SimpleMailText.linkToText(html);
    }
  }

  var fragment = technalxs.simplemail.SimpleMailUtils.parseHTML(body.contentDocument, html, true);
  body.contentDocument.body.innerHTML = "";
  body.contentDocument.body.appendChild(fragment);

  if (message.returnReceiptTo &&
      message.uid && !message.partial)
  {
    technalxs.simplemail.messageTreeView.sendReturnReceipt(message);
  }

  clearTimeout(technalxs.simplemail.messageTreeView.markReadTimeout);
  
  if (!message.read && !message.partial) {
    technalxs.simplemail.messageTreeView.startMarkReadTimeout(message);
  }
}

technalxs.simplemail.messageTreeView.plaintextMessage = function (html) {
  var body = technalxs.simplemail.SimpleMailDom.get("body");
  body.contentDocument.body.innerHTML = "";
  var fonts = body.contentDocument.createElement("font");
  fonts.setAttribute("face", "Consolas");
  var range = document.createRange();
  fonts.appendChild(html);
  var sp2 = body.contentDocument.body.getElementsByTagName("body");
  body.contentDocument.body.insertBefore(fonts, sp2.nextSibling);
  html = body.contentDocument.body.innerHTML
  return html = technalxs.simplemail.SimpleMailUtils.sanitizeHtml(html, true);     
}

technalxs.simplemail.messageTreeView.attachmentHeader = function () {
  var body = technalxs.simplemail.SimpleMailDom.get("body");
  body.contentDocument.body.innerHTML = "";
  var attachDiv = body.contentDocument.createElement("div");
  attachDiv.setAttribute("style", "border-radius: 5px; background-color: gray;");
  attachDiv.setAttribute("class", "line");
  var attachString = body.contentDocument.createTextNode(technalxs.simplemail.SimpleMailBundle.getString("attachments") + " : ");
  var brTag1 = body.contentDocument.createElement("br");
  var brTag2 = body.contentDocument.createElement("br");
  var brTag3 = body.contentDocument.createElement("br");
  var brTag4 = body.contentDocument.createElement("br");
  attachDiv.appendChild(brTag1);
  attachDiv.appendChild(attachString);
  attachDiv.appendChild(brTag2);
  attachDiv.appendChild(brTag3);
  body.contentDocument.body.appendChild(brTag4);
  body.contentDocument.body.appendChild(attachDiv);
  return body.contentDocument.body.innerHTML;
}

technalxs.simplemail.messageTreeView.displayAttachments = function(html, message) {
  if (html == " "){return " ";}
  var messageHtml = html;
  var source = technalxs.simplemail.SimpleMailFile.getAttachmentsDirectory(message.attachmentsDir);
  source.append(technalxs.simplemail.SimpleMailFile.MESSAGE_SOURCE);
  source = technalxs.simplemail.SimpleMailFile.readFile(source);
  if (!source.match(/name\=/gim) && !source.match(/filename\=/gim) && !source.match(/Content\-ID\:/gim)){return html;}

  var htmlTrimed = html.replace(/[\t\n\r ]+/g, " ");
  var getHtml = htmlTrimed.match(/<html[^>]*>(.*?)<\/html>/gim);
  if (getHtml == null){
    htmlTrimed = "<html>" + htmlTrimed + "</html>";
    getHtml = htmlTrimed.match(/<html[^>]*>(.*?)<\/html>/gim);
  }

  // Get attachments in the body
  var getAttachs1 = new Array();
  getAttachs1 = getHtml.toString().match(/<a\sclass\=\'attachment\'[^>]*>(.*?)<\/a>*/gim);
  if (getAttachs1 != null){
    for (var i in getAttachs1){
      htmlTrimed = htmlTrimed.replace(getAttachs1[i], ""); // Delete attachs in the body
      var htmlParsed = htmlTrimed+getAttachs1[i];  // Add attachs after body
    }
  }
  
  // Get attachments not in the body
  if (getAttachs1 == null){
    var getAttachs2 = new Array(); 
    getAttachs2 = htmlTrimed.toString().match(/<a\sclass\=\'attachment\'[^>]*>(.*?)<\/a>*/gim);
      if (getAttachs2 != null){
        var htmlParsed = htmlTrimed;   // Add attachs after body
     }
  }  

  if (technalxs.simplemail.SimpleMailPrefs.getBool("plaintextOnReceive")){
    var getAttachs3 = new Array();
    getAttachs3 = getHtml.toString().match(/<img[^>]*>(.*?)>*/gim);
      if (getAttachs3 != null){
        for (var j in getAttachs3){
          htmlTrimed = htmlTrimed.replace(getAttachs3[j], ""); // Delete attachs in the body
          htmlTrimed = htmlTrimed+getAttachs3[j]; // Add images attachs after body
        }
        if (getAttachs1 != null){
          for (var i in getAttachs1){
            htmlTrimed = htmlTrimed+getAttachs1[i];
          }
        }
      var htmlParsed = htmlTrimed;
    }
  }

  if (getAttachs1 != null) {
    var getAttachs = getAttachs1.concat(getAttachs2, getAttachs3);
  } else if (getAttachs2 != null){
    var getAttachs =  getAttachs2.concat(getAttachs3);
  } else if (getAttachs3 != null){
    var getAttachs = getAttachs3;
  }  

  if (getAttachs == null || typeof(getAttachs) == 'undefined') {
    var getAttachs = null;
    var htmlParsed = htmlTrimed;
  } 

  html = htmlParsed;
  var attachments = new Array();
  technalxs.simplemail.SimpleMailMessageEncoder.cidNames = [];
  technalxs.simplemail.SimpleMailMessageEncoder.ContentId = [];
  technalxs.simplemail.SimpleMailMessageEncoder.ContentDisposition = [];
  technalxs.simplemail.SimpleMailMessageEncoder.ContentType = [];
  
  var newMessage = technalxs.simplemail.SimpleMailMessageEncoder.parse(source, attachments, technalxs.simplemail.SimpleMailMessageEncoder.cidNames, technalxs.simplemail.SimpleMailMessageEncoder.ContentId, technalxs.simplemail.SimpleMailMessageEncoder.ContentDisposition, technalxs.simplemail.SimpleMailMessageEncoder.ContentType);

  for (var j in technalxs.simplemail.SimpleMailMessageEncoder.ContentDisposition) {
    var disposition = technalxs.simplemail.SimpleMailMessageEncoder.ContentDisposition[j];
    var regexp = /(?:[^;\s]*)/; 
    var Disposition =  regexp.exec(disposition);
    if (((Disposition == "attachment" || technalxs.simplemail.SimpleMailPrefs.getBool("plaintextOnReceive")) && !html.toString().match(/\<div\sclass\=\"line\"/gim)) && technalxs.simplemail.SimpleMailPrefs.getBool("newAttachs")){
      html += technalxs.simplemail.messageTreeView.attachmentHeader();
      html = html.replace(/(<\/div>)$/g,"");
    }

    var getName = /name\= *['"]?([^;\r"]*)/i;
    var type = technalxs.simplemail.SimpleMailMessageEncoder.ContentType[j];
    var filename = getName.exec(type);
    if (filename !== null) {
      filename[0] = filename[0].replace(/[\'\[\]\(\)]/gi, "_")
      filename[1] = filename[1].replace(/[\'\[\]\(\)]/gi, "_")
      var file = technalxs.simplemail.SimpleMailFile.getAttachmentsDirectory(message.attachmentsDir);
      file.append(filename[1]);
      if (!file.exists()) {
        var getName = /name\= *['"]?([^;\r'"]*)/i;   // To match old attachments files
        var filename = getName.exec(type);
        filename[0] = filename[0].replace(/[\'\[\]\(\)]/gi, "_")
        filename[1] = filename[1].replace(/[\'\[\]\(\)]/gi, "_")
      }
    }
    else {
      var getFileName = /filename\= *['"]?([^;\r"]*)/i;
      var filename = getFileName.exec(disposition);
      if (filename !== null) {
        filename[0] = filename[0].replace(/[\'\[\]\(\)]/gi, "_")
        filename[1] = filename[1].replace(/[\'\[\]\(\)]/gi, "_")
        var file = technalxs.simplemail.SimpleMailFile.getAttachmentsDirectory(message.attachmentsDir);
        file.append(filename[1]);
        if (!file.exists()) {
          var getFileName = /filename\= *['"]?([^;\r'"]*)/i;  // To match old attachments files
          var filename = getFileName.exec(disposition);
          filename[0] = filename[0].replace(/[\'\[\]\(\)]/gi, "_")
          filename[1] = filename[1].replace(/[\'\[\]\(\)]/gi, "_")
        }
      }
      else {
        for (var k in technalxs.simplemail.SimpleMailMessageEncoder.ContentId){
          var cid = technalxs.simplemail.SimpleMailMessageEncoder.ContentId[k];
        }
        var filename = technalxs.simplemail.SimpleMailMessageEncoder.cidNames[cid];
        if (typeof(filename) !== 'undefined'){
          var file = technalxs.simplemail.SimpleMailFile.getAttachmentsDirectory(message.attachmentsDir);
          file.append(filename);
          if (!file.exists()) {
            filename = filename.toString().replace(/[\'\[\]\(\)]/gi, "_")
          }
        }
      }
    }
    
    // Create attachment file if not exist
    var file = technalxs.simplemail.SimpleMailFile.getAttachmentsDirectory(message.attachmentsDir);
    file.append(filename[1]);
    if (!file.exists()) {
      for(var name in attachments) {
        name = name.toString().replace(/[\'\[\]\(\)] */gi, "_");
        technalxs.simplemail.SimpleMailFile.saveAttachment(message.attachmentsDir, name, attachments[name]);
      }
    }
    
    var regexp = new RegExp ('alt="' + filename[1], "gim");
    var result = regexp.exec(newMessage.html);
    if (result == null & Disposition == "inline") {
      result = true;
    }

    var myArray = html.match(/<html[^>]*>(.*?)<\/html>/gim);  // Get html part
    if (myArray != null){
      if ((message.folderId == 3 || message.folderId == 2) & (Disposition == "attachment" || result == true)) { // Sent and drafts folders
        if (!html.match(/\<div\sclass\=\"line\"/gim) && technalxs.simplemail.SimpleMailPrefs.getBool("newAttachs")){
          html += technalxs.simplemail.messageTreeView.attachmentHeader();
          html = html.replace(/(<\/div>)$/g,"");
        }

        var newUrl = technalxs.simplemail.SimpleMailFile.getAttachmentURL(message.attachmentsDir, filename[1]);
        if (!myArray.toString().match(newUrl)){  // Check if inline file exist
          html += technalxs.simplemail.SimpleMailMessageEncoder.getAttachmentHtml(newUrl);
          var draftDisposition = true;
          messageHtml += technalxs.simplemail.SimpleMailMessageEncoder.getAttachmentHtml(newUrl, draftDisposition);
          var myArray = html.match(/<html[^>]*>(.*?)<\/html>/gim);  // Get html part
        }
      }
      try {
        var myArray = decodeURIComponent(myArray);
      }
      catch(e) {
        myArray = myArray;
      }

      if (typeof(filename) == 'undefined'){
        var filename = getAttachs.toString().match(/>([^<]*)</);
      } 

      if (typeof(filename) !== 'undefined'){
        var checkInline = myArray.toString().match(filename[1]);  // Check if inline file exist
      }
    }

    var newAttachment = "";

    if (Disposition == "attachment" || checkInline == null){
      if (!html.match(/\<div\sclass\=\"line\"/gim) && technalxs.simplemail.SimpleMailPrefs.getBool("newAttachs")){
        html += technalxs.simplemail.messageTreeView.attachmentHeader();
        html = html.replace(/(<\/div>)$/g,"");
      }

      var attachmentsURL = technalxs.simplemail.SimpleMailFile.getAttachmentURL(message.attachmentsDir, filename[1]);
      // Remove attachement
      html = technalxs.simplemail.SimpleMailText.replaceURLs(html,
      function(text, url) {
        if (attachmentsURL == url){
          return " ";
        }
        else {
          return text;
        }
      });

      var background = technalxs.simplemail.SimpleMailMessageEncoder.getIconForAttachment(filename[1]);
      var attachmentSize = technalxs.simplemail.SimpleMailFile.readURL(attachmentsURL).length;
      attachmentSize = technalxs.simplemail.SimpleMailUtils.size2string(attachmentSize);
      var body = technalxs.simplemail.SimpleMailDom.get("body");
      body.contentDocument.body.innerHTML = "";
      var attachClass = body.contentDocument.createElement("a");
      attachClass.setAttribute("style", "background: url(" + background + ")center left no-repeat;");
      attachClass.setAttribute("href", attachmentsURL);
      attachClass.setAttribute("class", "newAttachment");      
      var attachName = body.contentDocument.createTextNode(filename[1]);
      var attachSize = body.contentDocument.createTextNode(" (" + attachmentSize + ")");
      var brTag1 = body.contentDocument.createElement("br");
      var brTag2 = body.contentDocument.createElement("br");
      var brTag3 = body.contentDocument.createElement("br");
      attachClass.appendChild(attachName);
      attachClass.appendChild(attachSize);
      attachClass.appendChild(brTag2);
      attachClass.appendChild(brTag3);
      body.contentDocument.body.appendChild(attachClass);      
      html +=  body.contentDocument.body.innerHTML;
    }
  } 
  
  if (!(technalxs.simplemail.SimpleMailOverlay.storage.getMessage(message.id).html).match(/\<a\sclass\=\'attachment\'/gim) && message.folderId == 3) {
    message.html = messageHtml;
    technalxs.simplemail.SimpleMailOverlay.storage.updateMessage(message);
  }

  if (html.match(/\<div\sclass\=\"line\"/gim))
  {
    html = html+"</div>";
  }

  if (technalxs.simplemail.SimpleMailPrefs.getBool("newAttachs")) {
    var partAttachs = html.toString().match(/\<div\sclass\=\"line\"[^>]*>(.*?)<\/div>*/gim);
  } else {
    var partAttachs = html.toString().match(/\<a\sclass\=\"newAttachment\"[^>]*>(.*?)<\/a>*/gim);
  }

  if (technalxs.simplemail.SimpleMailPrefs.getBool("plaintextOnReceive")) {
    return partAttachs;
  } else {
    return html;
  }
}

technalxs.simplemail.messageTreeView.displayHeaders = function(message) {
  technalxs.simplemail.SimpleMailDom.get("headers-from").value = message.from || "";
  technalxs.simplemail.SimpleMailDom.get("headers-to").value = message.to || "";
  technalxs.simplemail.SimpleMailDom.get("headers-cc").value = message.cc || "";
  technalxs.simplemail.SimpleMailDom.get("headers-bcc").value = message.bcc || "";
  technalxs.simplemail.SimpleMailDom.get("headers-subject").value = message.subject || "";
  technalxs.simplemail.SimpleMailDom.get("headers-date").value = technalxs.simplemail.SimpleMailDate.toString(message.date);
  if (technalxs.simplemail.SimpleMailPrefs.getBool("plaintextOnReceive") & !technalxs.simplemail.SimpleMailPrefs.getBool("warningPlainText")) {
    technalxs.simplemail.SimpleMailDom.get("headers-plaintextonreceive").collapsed = false;
  }
  else {
    technalxs.simplemail.SimpleMailDom.get("headers-plaintextonreceive").collapsed = true;
  }
}

technalxs.simplemail.messageTreeView.sendReturnReceipt = function(message) {
  function clearReturnReceiptTo() {
    message.returnReceiptTo = null;
    technalxs.simplemail.SimpleMailOverlay.storage.saveMessageState(message);
  }
  if (technalxs.simplemail.SimpleMailPrefs.getString("sendreceiptresp") == "asksend") {
    var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                  .getService(Components.interfaces.nsIPromptService);
    var button = prompts.confirmEx(window, "Simple Mail",
                                   technalxs.simplemail.SimpleMailBundle.getString("sendReturnReceipt"),
                                   prompts.BUTTON_POS_0 * prompts.BUTTON_TITLE_YES +
                                   prompts.BUTTON_POS_1 * prompts.BUTTON_TITLE_NO +
                                   prompts.BUTTON_POS_2 * prompts.BUTTON_TITLE_IS_STRING,
                                   null, null, technalxs.simplemail.SimpleMailBundle.getString("later"), null, {});
    if (button == 0) { // "Yes"
      var account = technalxs.simplemail.SimpleMailOverlay.storage.getAccount(message.accountId);
      var receipt = message.createReturnReceipt(account.toString(), message);
      technalxs.simplemail.SimpleMailPrefs.setString('originalTo', receipt.to);
      technalxs.simplemail.SimpleMailPrefs.setString('originalCc', receipt.cc);
      technalxs.simplemail.SimpleMailPrefs.setString('originalBcc', receipt.bcc);
      technalxs.simplemail.SimpleMailOverlay.autosendMail(receipt, clearReturnReceiptTo);
    }
    else if (button == 1) { // "No"
      clearReturnReceiptTo();
    }
  }
  else if (technalxs.simplemail.SimpleMailPrefs.getString("sendreceiptresp") == "alwayssend") {
    var account = technalxs.simplemail.SimpleMailOverlay.storage.getAccount(message.accountId);
    var receipt = message.createReturnReceipt(account.toString(), message);
    technalxs.simplemail.SimpleMailPrefs.setString('originalTo', receipt.to);
    technalxs.simplemail.SimpleMailPrefs.setString('originalCc', receipt.cc);
    technalxs.simplemail.SimpleMailPrefs.setString('originalBcc', receipt.bcc);
    technalxs.simplemail.SimpleMailOverlay.autosendMail(receipt, clearReturnReceiptTo);
  }
  else if (technalxs.simplemail.SimpleMailPrefs.getString("sendreceiptresp") == "neversend") {
    clearReturnReceiptTo();
  }
}

technalxs.simplemail.messageTreeView.original = new Array();

technalxs.simplemail.messageTreeView.autoForward = function(message) {
  function setautoForward() {
    message.fwd = true;
    technalxs.simplemail.SimpleMailOverlay.storage.saveMessageState(message);
  }

  var account = technalxs.simplemail.SimpleMailOverlay.storage.getAccount(message.accountId);
  
  // If exist, delete coma in name    
  message.to = technalxs.simplemail.SimpleMailNewMessage.cleanAddresses(message.to);  
  message.cc = technalxs.simplemail.SimpleMailNewMessage.cleanAddresses(message.cc); 
  message.bcc = technalxs.simplemail.SimpleMailNewMessage.cleanAddresses(message.bcc);
  
  var messageForward = technalxs.simplemail.SimpleMailOverlay.storage.getMessage(message.id).createForward();
  var forwardParam = technalxs.simplemail.SimpleMailPrefs.getString('forwardParam');
  messageForward.to = forwardParam;
  messageForward.from = message.from;
  technalxs.simplemail.SimpleMailOverlay.autosendMail(messageForward, setautoForward);
}

technalxs.simplemail.messageTreeView.markReadTimeout = null;

technalxs.simplemail.messageTreeView.startMarkReadTimeout = function(message) {
  var time = technalxs.simplemail.SimpleMailPrefs.getInt("markReadTimeout");
  if (time == 0 && technalxs.simplemail.messageTreeView.messages[messageTree.currentIndex] &&
        technalxs.simplemail.messageTreeView.messages[messageTree.currentIndex].id == message.id)
  {
    technalxs.simplemail.messageTreeView.markRead(messageTree.currentIndex, true);
  };
   
  if (!time) return;

  technalxs.simplemail.messageTreeView.markReadTimeout = setTimeout(function() {
    if (technalxs.simplemail.messageTreeView.messages[messageTree.currentIndex] &&
        technalxs.simplemail.messageTreeView.messages[messageTree.currentIndex].id == message.id)
    {
      technalxs.simplemail.messageTreeView.markRead(messageTree.currentIndex, true);
    }
  }, time * 1000);
}

// Mark read individual message
technalxs.simplemail.messageTreeView.markRead = function(index, read) {
  var message = technalxs.simplemail.messageTreeView.messages[index];
  message.read = read;
  technalxs.simplemail.SimpleMailOverlay.storage.saveMessageState(message);
  var account = technalxs.simplemail.SimpleMailOverlay.storage.getAccount(message.accountId);
  var flag = message.read == 1 ? "Seen" : "UnSeen"
  var folder = technalxs.simplemail.SimpleMailManageFolder.getCurrentFolder().name;
  var messages = new Array();
  messages.push(technalxs.simplemail.messageTreeView.messages[index]);
  technalxs.simplemail.SimpleMailOverlay.SynchroMail(account, messages, folder, flag);
  flag = "";
  technalxs.simplemail.messageTreeView.treebox.invalidateRow(index);
  technalxs.simplemail.SimpleMailManageFolder.updateFolderCounts();
}

technalxs.simplemail.messageTreeView.displayMessageSource = function() {
  var attachmentsDir = technalxs.simplemail.messageTreeView.messages[messageTree.currentIndex].attachmentsDir;
  var url = technalxs.simplemail.SimpleMailFile.getAttachmentURL(attachmentsDir, technalxs.simplemail.SimpleMailFile.MESSAGE_SOURCE);
  var gBrowser = technalxs.simplemail.SimpleMailUtils.getBrowser();
  gBrowser.selectedTab = gBrowser.addTab(url);
}

// If there's an unread message selected, mark all selected technalxs.simplemail.messageTreeView.messages read.
// Otherwise mark all selected technalxs.simplemail.messageTreeView.messages unread.

technalxs.simplemail.messageTreeView.toggleRead = function() {
  var read = false;
  technalxs.simplemail.messageTreeView.forEachMessagesSelected(function(index) {
    read |= !technalxs.simplemail.messageTreeView.messages[index].read;
  });
  technalxs.simplemail.messageTreeView.forEachMessagesSelected(function(index) {
    technalxs.simplemail.messageTreeView.markRead(index, read);
  });
}

technalxs.simplemail.messageTreeView.deleteMail = function(skipTrash) {
  if (messageTree.view.selection.getRangeCount() == 0) return;

  if (!skipTrash && technalxs.simplemail.SimpleMailManageFolder.getCurrentFolder().id != technalxs.simplemail.SimpleMailModel.SimpleMailFolder.TRASH &&
      technalxs.simplemail.SimpleMailPrefs.getBool("moveToTrash")) return technalxs.simplemail.messageTreeView.moveToFolder(technalxs.simplemail.SimpleMailModel.SimpleMailFolder.TRASH);

  var msgs = new Array();
  technalxs.simplemail.messageTreeView.forEachMessagesSelected(function(index) {
    msgs.push(technalxs.simplemail.messageTreeView.messages[index]);
  });

  var confirmText = technalxs.simplemail.SimpleMailBundle.getString("deleteMessages");

  technalxs.simplemail.SimpleMailOverlay.askDeleteMail(msgs, confirmText, window);
}

technalxs.simplemail.messageTreeView.onMessagesDeleted = function(deleted) {
  if (!deleted) return;

  function isdeleted(message) {
    for(var i in deleted) {
      if (deleted[i].id == message.id) return true;
    }
  }
  var selectionHandler = messageTree.onselect;
  messageTree.onselect = null;
  var index = messageTree.currentIndex;

  for(var i = technalxs.simplemail.messageTreeView.messages.length - 1; i >= 0; i--) {
    if (isdeleted(technalxs.simplemail.messageTreeView.messages[i])) {
      technalxs.simplemail.messageTreeView.treebox.rowCountChanged(i, -1);
      technalxs.simplemail.messageTreeView.messages.splice(i, 1);
      if (i <= index) index = index - 1;
    }
  }
  messageTree.onselect = selectionHandler;

  if (messageTree.currentIndex == -1) {
    index = Math.min(index + 1, technalxs.simplemail.messageTreeView.messages.length - 1);
    if (index != -1) messageTree.view.selection.select(index);
    else technalxs.simplemail.messageTreeView.displayMessageHtml();
  }
  technalxs.simplemail.SimpleMailManageFolder.updateFolderCounts();
  technalxs.simplemail.messageTreeView.displayMessageHtml();
}

technalxs.simplemail.messageTreeView.onMessageAdded = function(message) {
  var folder = technalxs.simplemail.SimpleMailManageFolder.getCurrentFolder();
  if (folder && folder.id == message.folderId) {
    technalxs.simplemail.messageTreeView.messages.splice(0, 0, message);
    technalxs.simplemail.messageTreeView.treebox.rowCountChanged(0, 1);
  }
  technalxs.simplemail.SimpleMailManageFolder.updateFolderCounts();
}

technalxs.simplemail.messageTreeView.onMessageUpdated = function(message) {
  for (var i = 0; i < technalxs.simplemail.messageTreeView.messages.length; i++) {
    if (technalxs.simplemail.messageTreeView.messages[i].id == message.id) {
      technalxs.simplemail.messageTreeView.messages[i] = message;
      technalxs.simplemail.messageTreeView.treebox.invalidateRow(i);
      if (i == messageTree.currentIndex) technalxs.simplemail.messageTreeView.displayMessageHtml();
      break;
    }
  }
}

technalxs.simplemail.messageTreeView.openReply = function(all) {
  if (messageTree.currentIndex != -1) {
    if (!technalxs.simplemail.SimpleMailPrefs.getObject('message')) {
      var message = technalxs.simplemail.messageTreeView.messages[messageTree.currentIndex];
    } else {
      var message = technalxs.simplemail.SimpleMailPrefs.getObject('message');
    }
    technalxs.simplemail.SimpleMailPrefs.setString('originalId', message.id);
    var reply = technalxs.simplemail.SimpleMailOverlay.storage.getMessage(message.id).createReply(all);
    technalxs.simplemail.SimpleMailOverlay.openNewMessage(reply);
  }
}

technalxs.simplemail.messageTreeView.openNew = function(address) {
  var message = new technalxs.simplemail.SimpleMailModel.SimpleMailMessage();
  message.to = address;
  technalxs.simplemail.SimpleMailOverlay.openNewMessage(message);
}

technalxs.simplemail.messageTreeView.openForward = function(address) {
  if (messageTree.currentIndex != -1) {
    if (!technalxs.simplemail.SimpleMailPrefs.getObject('message')) {
      var message = technalxs.simplemail.messageTreeView.messages[messageTree.currentIndex];
    } else {
      var message = technalxs.simplemail.SimpleMailPrefs.getObject('message');
    }
    technalxs.simplemail.SimpleMailPrefs.setString('originalId', message.id);
    var forward = technalxs.simplemail.SimpleMailOverlay.storage.getMessage(message.id).createForward();
    forward.to = address;
    technalxs.simplemail.SimpleMailOverlay.openNewMessage(forward);
  }
}

technalxs.simplemail.messageTreeView.selectFirstMessage = function() {
  if (technalxs.simplemail.messageTreeView.rowCount > 0) {
    messageTree.view.selection.select(0);
    technalxs.simplemail.messageTreeView.treebox.scrollToRow(0);
  }
}

technalxs.simplemail.messageTreeView.displayFolder = function() {
  var folder = technalxs.simplemail.SimpleMailManageFolder.getCurrentFolder();

  var isSentOrDraft = folder.id == technalxs.simplemail.SimpleMailModel.SimpleMailFolder.SENT || folder.id == technalxs.simplemail.SimpleMailModel.SimpleMailFolder.DRAFTS;
  var bothVisible = technalxs.simplemail.SimpleMailDom.get("from").hidden == technalxs.simplemail.SimpleMailDom.get("to").hidden;
  technalxs.simplemail.SimpleMailDom.get("from").setAttribute("hidden", isSentOrDraft && !bothVisible);
  technalxs.simplemail.SimpleMailDom.get("to").setAttribute("hidden", !isSentOrDraft && !bothVisible);

  var search = technalxs.simplemail.SimpleMailDom.get("search").value;
  technalxs.simplemail.SimpleMailDom.get("folderId").hidden = !search;

  var oldCount = technalxs.simplemail.messageTreeView.messages.length;
  technalxs.simplemail.messageTreeView.messages = search ? technalxs.simplemail.SimpleMailOverlay.storage.getSearchMessages(search, technalxs.simplemail.messageTreeView.getSort()) :
             folder ? technalxs.simplemail.SimpleMailOverlay.storage.getFolderMessages(folder.id, technalxs.simplemail.messageTreeView.getSort()) : [];

  var selectionHandler = messageTree.onselect;
  messageTree.onselect = null;

  technalxs.simplemail.messageTreeView.treebox.rowCountChanged(0, technalxs.simplemail.messageTreeView.messages.length - oldCount);
  technalxs.simplemail.messageTreeView.treebox.invalidate();
  technalxs.simplemail.messageTreeView.selectFirstMessage();

  messageTree.onselect = selectionHandler;
  technalxs.simplemail.messageTreeView.displayMessageHtml();
}

technalxs.simplemail.messageTreeView.moveToFolder = function(folderId) {
  var deleted = new Array();
  technalxs.simplemail.messageTreeView.forEachMessagesSelected(function(index) {
    technalxs.simplemail.messageTreeView.messages[index].folderId = folderId;
    // Manage SPAMs
    if (folderId == technalxs.simplemail.SimpleMailManageFolder.getFolderId("SPAM")) {
      technalxs.simplemail.messageTreeView.messages[index].spam = true;
      var messageFrom = technalxs.simplemail.messageTreeView.messages[index].from;
      processFilterSPAM(messageFrom);
    } else if (folderId !== technalxs.simplemail.SimpleMailManageFolder.getFolderId("SPAM") && technalxs.simplemail.messageTreeView.messages[index].spam == true) {
      technalxs.simplemail.messageTreeView.messages[index].spam = false;
      var messageFrom = technalxs.simplemail.messageTreeView.messages[index].from;
      deleteRuleFilterSPAM(messageFrom);
    }

    technalxs.simplemail.SimpleMailOverlay.storage.saveMessageState(technalxs.simplemail.messageTreeView.messages[index]);
    deleted.push(technalxs.simplemail.messageTreeView.messages[index]);
  });
  technalxs.simplemail.messageTreeView.onMessagesDeleted(deleted);
}

technalxs.simplemail.messageTreeView.getSort = function() {
  var column = technalxs.simplemail.messageTreeView.getSortedColumn(); 
  if (!column) return;

  var direction = column.getAttribute("sortDirection");
  if (direction) {
    var sortColumns = {
      "image": "accountId",
      "from" : "fromm",
      "to"   : "too",
      "color": "noColor, color"
    };
    var id = sortColumns[column.id] || column.id;
    return id + " " + (direction == "descending" ? "DESC" : "ASC");
  }
}

// Partially downloaded technalxs.simplemail.messageTreeView.messages

technalxs.simplemail.messageTreeView.populateMessageMenu = function() {
  technalxs.simplemail.SimpleMailDom.get("message-menu-download").hidden = !technalxs.simplemail.messageTreeView.isPartialSelected();
  return messageTree.view.selection.getRangeCount() > 0;
}

technalxs.simplemail.messageTreeView.isPartialSelected = function() {
  technalxs.simplemail.messageTreeView.isPartial = false;

  technalxs.simplemail.messageTreeView.forEachMessagesSelected(function(index) {
    if (technalxs.simplemail.messageTreeView.messages[index].partial) technalxs.simplemail.messageTreeView.isPartial = true;
  });
  return technalxs.simplemail.messageTreeView.isPartial;
}

technalxs.simplemail.messageTreeView.downloadMessageBody = function() {
  technalxs.simplemail.messageTreeView.partial = new Array();
  technalxs.simplemail.messageTreeView.forEachMessagesSelected(function(index) {
    var message = technalxs.simplemail.messageTreeView.messages[index];
    if (message.partial) technalxs.simplemail.messageTreeView.partial[message.id] = message;
  });
  technalxs.simplemail.SimpleMailOverlay.getMailBody(technalxs.simplemail.messageTreeView.partial);
}

technalxs.simplemail.messageTreeView.setMessageColor = function(color) {
  technalxs.simplemail.messageTreeView.forEachMessagesSelected(function(index) {
    var message = technalxs.simplemail.messageTreeView.messages[index];
    message.color = color;
    technalxs.simplemail.SimpleMailOverlay.storage.saveMessageState(message);
    technalxs.simplemail.messageTreeView.treebox.invalidateRow(index);
  });
}

technalxs.simplemail.messageTreeView.printMessage = function() {
  if (messageTree.currentIndex != -1) {
    if (!technalxs.simplemail.SimpleMailPrefs.getObject('message')) {
      var message = technalxs.simplemail.messageTreeView.messages[messageTree.currentIndex];
    } else {
      var message = technalxs.simplemail.SimpleMailPrefs.getObject('message');
    }

    var msg = technalxs.simplemail.SimpleMailOverlay.storage.getMessage(message.id);
    var messageHTML = msg.toHtml();

    var fragment = technalxs.simplemail.SimpleMailUtils.parseHTML(document, messageHTML, true);
    technalxs.simplemail.SimpleMailDom.get("printer").contentDocument.body.appendChild(fragment);
    technalxs.simplemail.SimpleMailDom.get("printer").contentWindow.print();
    technalxs.simplemail.SimpleMailUtils.clearElement(technalxs.simplemail.SimpleMailDom.get("printer").contentDocument.body);
  }
}

technalxs.simplemail.messageTreeView.populateCharsetMenu = function(event) {
  var menupopup = event.target;
  technalxs.simplemail.SimpleMailUtils.clearElement(menupopup);

  var charsets = technalxs.simplemail.SimpleMailUtils.getDefaultCharsets();
  for(var i = 0; i < charsets.length; i++) {
    var menuitem = document.createElement("menuitem");
    menuitem.setAttribute("label", charsets[i]);
    menupopup.appendChild(menuitem);
  }
}

technalxs.simplemail.messageTreeView.recodeMessage = function(charset) {
  technalxs.simplemail.messageTreeView.forEachMessagesSelected(function(index) {
    var message = technalxs.simplemail.SimpleMailOverlay.storage.getMessage(technalxs.simplemail.messageTreeView.messages[index].id);
    message.recode(charset);
    technalxs.simplemail.SimpleMailOverlay.storage.saveMessage(message, true);
    message.html = null; // Don't keep in memory
    technalxs.simplemail.messageTreeView.messages[index] = message;
    technalxs.simplemail.messageTreeView.treebox.invalidateRow(index);
    if (index == messageTree.currentIndex) technalxs.simplemail.messageTreeView.displayMessageHtml();
  });
}

technalxs.simplemail.messageTreeView.populateRefreshMenu = function() {
  var browserWindow = technalxs.simplemail.SimpleMailUtils.getBrowserWindow();
  var foo = browserWindow.document.createElement("menupopup");
  technalxs.simplemail.SimpleMailOverlay.populateMenu(foo);

  var refresh = technalxs.simplemail.SimpleMailDom.get("refresh");
  technalxs.simplemail.SimpleMailUtils.clearElement(refresh);

  for(var i = 0; i < foo.childNodes.length; i++) {
    var menuitem = document.importNode(foo.childNodes[i], true);
    refresh.appendChild(menuitem);
  }
  return  refresh.childNodes.length != 0;
}

technalxs.simplemail.messageTreeView.saveMessageAs = function() {
  if (messageTree.currentIndex == -1) return;
  if (!technalxs.simplemail.SimpleMailPrefs.getObject('message')) {
    var message = technalxs.simplemail.messageTreeView.messages[messageTree.currentIndex];
  } else {
    var message = technalxs.simplemail.SimpleMailPrefs.getObject('message');
  }
  var fp = Components.classes["@mozilla.org/filepicker;1"]
           .createInstance(Components.interfaces.nsIFilePicker);
  fp.init(window, null, fp.modeSave);
  fp.appendFilters(fp.filterHTML);
  fp.appendFilter("*.eml", "*.eml");
  fp.defaultString = message.subject;

  var result = fp.show();
  if (result == fp.returnCancel) return;

  var file = fp.file.clone();

  if (fp.filterIndex == 0) {
    if (!file.leafName.match(/\.html?$/)) {
      file.leafName += ".html";
    }
    technalxs.simplemail.messageTreeView.saveAsHtml(file, message);
  }
  else {
    if (!file.leafName.match(/\.eml$/)) {
      file.leafName += ".eml";
    }
    technalxs.simplemail.messageTreeView.saveAsEmail(file, message);
  }
}

technalxs.simplemail.messageTreeView.saveAsEmail = function(file, message) {
  var source = technalxs.simplemail.SimpleMailFile.getAttachmentsDirectory(message.attachmentsDir);
  source.append(technalxs.simplemail.SimpleMailFile.MESSAGE_SOURCE);
  source.copyTo(file.parent, file.leafName);
}

technalxs.simplemail.messageTreeView.saveAsHtml = function(file, message) {
  message = technalxs.simplemail.SimpleMailOverlay.storage.getMessage(message.id);
  var html = '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">' +
             '<meta http-equiv="Content-Type" content="text/html; charset=utf-8">' +
             '<style>' + technalxs.simplemail.SimpleMailFile.readURL("chrome://simplemail/skin/message.css") + '</style>' +
             '<title>' + message.subject + '</title>' + message.toHtml();

  if (message.attachmentsCount) {
    var dir = file.clone();
    dir.leafName = dir.leafName.replace(/(\.[^.]*)?$/, "_files");
    if (!dir.exists()) dir.create(dir.DIRECTORY_TYPE, 0777);

    html = technalxs.simplemail.SimpleMailText.replaceURLs(html,
      function(text, url) {
        if (url.match(/^simplemail:/i)) {
          var fileName = technalxs.simplemail.SimpleMailFile.getFileName(url);

          var file = dir.clone();
          file.append(fileName);
          if (file.exists()) file.remove(false);
          file = technalxs.simplemail.SimpleMailFile.getAttachmentsDirectory(message.attachmentsDir);
          file.append(fileName);
          file.copyTo(dir, fileName);

          return text.replace(url, dir.leafName + "/" + fileName);
        }
        return text;
      });
    html = technalxs.simplemail.SimpleMailText.imageToLink(html);
  }
  technalxs.simplemail.SimpleMailFile.writeFile(file, html, true);
}

technalxs.simplemail.messageTreeView.clearSearch = function() {
  technalxs.simplemail.SimpleMailDom.get("search").value = "";
}

technalxs.simplemail.messageTreeView.addToAddressBook = function() {
  technalxs.simplemail.messageTreeView.forEachMessagesSelected(function(index) {
    var message = technalxs.simplemail.messageTreeView.messages[index];
    technalxs.simplemail.SimpleMailOverlay.storage.addAddressList(message.from);
  });
  technalxs.simplemail.SimpleMailAdresses.updateAddressTree();
}

technalxs.simplemail.messageTreeView.onRefreshClicked = function(event) {
  if (event.type == "dblclick") technalxs.simplemail.SimpleMailOverlay.stop();
  else technalxs.simplemail.SimpleMailOverlay.getMail();
}