if(typeof(technalxs) == "undefined") {var technalxs = {};};
if(typeof(technalxs.simplemail) == "undefined" ) {technalxs.simplemail = {};};

var   SimpleMailCOLORS = ["black", "red", "orange", "green", "blue", "violet"];

technalxs.simplemail.SimpleMailModel = function(){
  var pub = {};

  pub.SimpleMailAddress = function(id, name, email, group, favorite, postaladdress, phone) {
    this.id = id;
    this.name = name;
    this.email = email;
    this.group = group;
    this.favorite = favorite;
    this.postaladdress = postaladdress;
    this.phone = phone;
  
    this.getLogin = function() {
      return /(.*)@/.exec(this.email)[1];
    }
    this.getHost = function() {
      return /@(.*)/.exec(this.email)[1];
    }
    this.toString = function() {
      return this.name + (this.name && this.email ? " " : "") +
             (this.email ? "<" + this.email + ">" : "");
    }
    this.toHtml = function() {
      return this.name + (this.name && this.email ? " " : "") +
             (this.email ? "&lt;<a href='mailto:" + this.email + "'>" +
                           this.email + "</a>&gt;" : "");
    }
  },
  
  pub.SimpleMailAccount = function(id, index, name, email, replyTo, refresh, deleteMode,
                     color, subject, signature, isImap, pop3auth,
                     pop3host, pop3port, pop3ssl, pop3login,
                     smtpHost, smtpPort, smtpSsl, smtpLogin, smtpTls, smtpAuth) {
    var self = this;
    this.id = id;
    this.index = index;
    this.name = name;
    this.email = email;
    this.replyTo = replyTo;
    this.refresh = refresh;
    this.deleteMode = deleteMode;
    this.color = color;
    this.subject = subject;
    this.signature = signature;
  
    this.pop3 = {
      isImap: isImap,
      auth:   pop3auth,
      host:   pop3host,
      port:   pop3port,
      ssl:    pop3ssl,
      login:  pop3login
    }
    this.pop3.getPassword = function() {
      return SimpleMailPasswordManager.getPassword(self.id + "/pop3/");
    }
    this.pop3.setPassword = function(password) {
      return SimpleMailPasswordManager.setPassword(self.id + "/pop3/", password);
    }
    this.smtp = {
      host:  smtpHost,
      port:  smtpPort,
      ssl:   smtpSsl,
      login: smtpLogin,
      tls:   smtpTls,
      auth:  smtpAuth
    }
    this.smtp.getPassword = function() {
      return SimpleMailPasswordManager.getPassword(self.id + "/smtp/");
    }
    this.smtp.setPassword = function(password) {
      return SimpleMailPasswordManager.setPassword(self.id + "/smtp/", password);
    }
    this.toString = function() {
      return (this.name ? this.name + " " : "") + "<" + this.email + ">";
    }
  },

  pub.SimpleMailAccount.create = function() {
    return new technalxs.simplemail.SimpleMailModel.SimpleMailAccount(null,
                         null,
                         null,
                         null,
                         null,
                         60,
                         null,
                         null,
                         null,
                         null,
                         null,
                         0,
                         null, 
                         110,
                         null,
                         null,
                         null,
                         25,
                         null,
                         null);
  },

  pub.SimpleMailMessage = function(id, accountId, uid, from, to, cc, bcc, subject, date, size, charset,
                     read, deleted, attachmentsDir, attachmentsCount, html, folderId,
                     partial, template, color, returnReceiptTo, replyTo, spam, replied, fwd) {
    this.id = id;
    this.accountId = accountId;
    this.uid = uid;
    this.from = from;
    this.to = to || "";
    this.cc = cc || "";
    this.bcc = bcc || "";
    this.subject = subject;
    this.date = date;
    this.size = size;
    this.charset = charset;
    this.read = read;
    this.deleted = deleted;
    this.attachmentsDir = attachmentsDir || technalxs.simplemail.SimpleMailUtils.getUniqueId();
    this.attachmentsCount = attachmentsCount || 0;
    this.html = html;
    this.folderId = folderId;
    this.partial = partial;
    this.template = template;
    this.color = color;
    this.returnReceiptTo = returnReceiptTo;
    this.replyTo = replyTo;
    this.spam = spam;
    this.replied = replied;
    this.fwd = fwd;
      
    this.contentType;
    this.source;
  
    this.getSize = function() {
      if (this.size == null) {
        this.size = this.toString().length;
      }
      return this.size;
    }
  
    this.toString = function() {
      if (!this.source) {
        this.source = technalxs.simplemail.SimpleMailMessageEncoder.encode(this);
      }
      return this.source;
    }
  
    this.toHtml = function() {
      function mailList2html(value) {
        var addresses = technalxs.simplemail.SimpleMailModel.SimpleMailAddress.parseList(value);
        var result = "";
        if (technalxs.simplemail.SimpleMailPrefs.getBool("plaintextOnSend")) {
          for(var i in addresses) {
            result += (result ? ", " : "") + addresses[i].toString();
          }
          result = result.replace(/<[\/]{0,1}/ig,"(");
          result = result.replace(/>[\/]{0,1}/ig,")");
          return result;
        } else {
          for(var i in addresses) {
            result += (result ? ", " : "") + addresses[i].toHtml();
          }
          return result;
        }
      }

      if (technalxs.simplemail.SimpleMailPrefs.getBool("plaintextOnSend") && this.from) {
        this.from = this.from.replace(/<[\/]{0,1}/ig,"(");
        this.from = this.from.replace(/>[\/]{0,1}/ig,")");
        var from = this.from
      } else {
        var from = this.from ? technalxs.simplemail.SimpleMailModel.SimpleMailAddress.parse(this.from).toHtml() : "";
      }
      return "<span style='color: gray;'>" +
             "From: " + from + "<br>" +
             "To: " + mailList2html(this.to) + "<br>" + 
             (this.cc ? "Cc: " + mailList2html(this.cc) + "<br>" : "") +
             "Date: " + technalxs.simplemail.SimpleMailDate.toString(this.date) + "<br>" +
             "Subject: " + this.subject + "<br>" +
             "</span><br>" + this.html;
    }

    this.toHtmlReceipt = function() {
      function mailList2html(value) {
        var addresses = technalxs.simplemail.SimpleMailModel.SimpleMailAddress.parseList(value);
        var result = "";
        for(var i in addresses) {
          result += (result ? ", " : "") + addresses[i].toHtml();
        }
        return result;
      }
      var from = this.from ? technalxs.simplemail.SimpleMailModel.SimpleMailAddress.parse(this.from).toHtml() : "";
      return "<span style='color: gray;'>" +
             "From: " + from + "<br>" +
             "To: " + mailList2html(this.to) + "<br>" + 
             (this.cc ? "Cc: " + mailList2html(this.cc) + "<br>" : "") +
             "Date: " + technalxs.simplemail.SimpleMailDate.toString(this.date) + "<br>" +
             "Subject: " + this.subject + "<br>" +
             "</span><br>";
    }

    this.createReply = function(all) {
      var reply = new technalxs.simplemail.SimpleMailModel.SimpleMailMessage();
      reply.accountId = this.accountId;
      reply.charset = this.charset;
      reply.to = this.replyTo || this.from;
      if (all) {
        if (this.to) reply.to += ", " + this.to;
        reply.cc = this.cc;
        reply.bcc = this.bcc;
      }
      reply.subject = this.subject.replace(/^(Re: )?/i, "Re: ");
      // Remove attachments
      reply.html = technalxs.simplemail.SimpleMailText.replaceURLs(this.html,
        function(text, url) {
          return technalxs.simplemail.SimpleMailFile.isLocalURL(url)
             ? technalxs.simplemail.SimpleMailBundle.getString("attachments") + " : " + "[" + technalxs.simplemail.SimpleMailFile.getFileName(url) + "]" + "<br>" : text;
        });

      if (technalxs.simplemail.SimpleMailPrefs.getBool("plaintextOnSend")) {
        this.from = this.from.replace(/<[\/]{0,1}/ig,"(");
        this.from = this.from.replace(/>[\/]{0,1}/ig,")");
        reply.html = "<br><br><span style='color: gray;'>" +
                     technalxs.simplemail.SimpleMailPrefs.getString("reply")
                            .replace(/{author}/gi, this.from)
                            .replace(/{date}/gi, technalxs.simplemail.SimpleMailDate.toString(this.date))
                            .replace(/{date-gmt}/gi, technalxs.simplemail.SimpleMailDate.toGMT(this.date))
                            .replace(/{date-locale}/gi, new Date(this.date).toLocaleString())
                            .replace(/{subject}/gi, this.subject) +
                     "</span><br>" +
                     "<span style='font-style: italic'>" + reply.html + "</span>"
        return reply;
      } else {
        reply.html = "<br><br><span style='color: gray;'>" +
                     technalxs.simplemail.SimpleMailPrefs.getString("reply")
                            .replace(/{author}/gi, technalxs.simplemail.SimpleMailModel.SimpleMailAddress.parse(this.from).toHtml())
                            .replace(/{date}/gi, technalxs.simplemail.SimpleMailDate.toString(this.date))
                            .replace(/{date-gmt}/gi, technalxs.simplemail.SimpleMailDate.toGMT(this.date))
                            .replace(/{date-locale}/gi, new Date(this.date).toLocaleString())
                            .replace(/{subject}/gi, this.subject) +
                     "</span><br>" +
                     "<blockquote style='border-left: 1px solid rgb(204, 204, 204);" +
                                        "margin: 0 0 0 0.8ex;" +
                                        "padding: 1ex 0 0 1ex;'>" + reply.html + "</blockquote>";
        return reply;      
      }                                
    }
  
    this.createForward = function() {
      var forward = new technalxs.simplemail.SimpleMailModel.SimpleMailMessage();
      forward.accountId = this.accountId;
      forward.charset = this.charset;
      forward.subject = this.subject.replace(/^(Fwd?: )?/i, "Fwd: ");
      if (technalxs.simplemail.SimpleMailPrefs.getBool("plaintextOnSend")) {
        forward.html = "<br><br> -- Message -- <br><br>" + this.toHtml();
        return forward;
      } else {
        forward.html = "<br><br><hr>" + this.toHtml();
        return forward;
      }
    }
  
    this.createReturnReceipt = function(recipient, message) {
      var source = technalxs.simplemail.SimpleMailFile.getAttachmentsDirectory(message.attachmentsDir);
      source.append(technalxs.simplemail.SimpleMailFile.MESSAGE_SOURCE);
      source = technalxs.simplemail.SimpleMailFile.readFile(source);
      var originalMessageID = source.match(/^Message-ID:[^<]*<(.*?)>/gim)
      originalMessageID = originalMessageID.toString().match(/<.*>/);
          
      var receipt = new technalxs.simplemail.SimpleMailModel.SimpleMailMessage();
      receipt.accountId = this.accountId;
      receipt.from = recipient;
      receipt.to = this.returnReceiptTo;
      receipt.charset = "utf-8";
      receipt.subject = "Rcpt: " + this.subject;

      var html = technalxs.simplemail.SimpleMailBundle.getString("receipt") + "<br>" + technalxs.simplemail.SimpleMailBundle.getString("date") +" : " + technalxs.simplemail.SimpleMailDate.toString(new Date().getTime()) + " - " + technalxs.simplemail.SimpleMailBundle.getString("messageReceived")+" :<br><hr>";

      // Create MDNFile.txt
      var file = technalxs.simplemail.SimpleMailFile.getAttachmentsDirectory(receipt.attachmentsDir);
      file.append("MDNFile.txt");
      var out = technalxs.simplemail.SimpleMailFile.createOutputStream(file);
      out.write("Reporting-UA: SimpleMail" + "\r\n");
      out.write("Final-Recipient: rfc822;" + receipt.from + "\r\n");
      out.write("Original-Message-ID: " + originalMessageID + "\r\n");
      if (technalxs.simplemail.SimpleMailPrefs.getString("sendreceiptresp") == "asksend") {
        out.write("Disposition: manual-action/MDN-sent-manually; displayed" + "\r\n");
      } else {
        out.write("Disposition: automatic-action/MDN-sent-automatically; displayed" + "\r\n");
      }
      out.close();
            
      // Attach MDNFile.txt
      var url = technalxs.simplemail.SimpleMailFile.getFileURL(file);
      var filename = technalxs.simplemail.SimpleMailFile.getFileName(url);
      var background = technalxs.simplemail.SimpleMailMessageEncoder.getIconForAttachment(filename);
      html += "<a class='attachment' style='background: url(" + background + ")center left no-repeat;' href='" + url + "'>" + filename + "</a>";
      receipt.html = html + this.toHtmlReceipt() + "<hr>";
      return receipt;
    }
  
    var fields = ["from", "to", "cc", "bcc", "subject", "charset",
                  "html", "returnReceiptTo"];
  
    this.equals = function(message) {
      if (message == null) return true;
      for(var i in fields) {
        var field = fields[i];
        if (this[field] != message[field]) return false;
      }
      return true;
    }
  
    this.copyTo = function(message) {
      for(var i in fields) {
        var field = fields[i];
        message[field] = this[field];
      }
    }
  
    this.recode = function(charset) {
      try {
        var message = new technalxs.simplemail.SimpleMailModel.SimpleMailMessage();
        for(var i in fields) {
          var field = fields[i];
          message[field] = technalxs.simplemail.SimpleMailText.fromUnicode(this[field], this.charset);
          message[field] = technalxs.simplemail.SimpleMailText.toUnicode(message[field], charset);
        }
        message.charset = charset;
        // If no exceptions, update original message
        message.copyTo(this);
      }
      catch(e) {}
    }
  },

  pub.SimpleMailFolder = function(id, parentId, name, open) {
    this.id = id;
    this.parentId = parentId;
    this.name = name;
    this.open = open;
  
    this.getName = function() {
      return technalxs.simplemail.SimpleMailBundle.getString(this.name) || this.name;
    }
  },    

  pub.SimpleMailRule = function(id, filterId, property, not, condition, param) {
    this.id = id;
    this.filterId = filterId;
    this.property = property;
    this.not = not;
    this.condition = condition;
    this.param = param;
  
    function matchAll(string, patterns) {
      string = String.toLowerCase(string);
      for(var i = 0; i < patterns.length; i++) {
        var pattern = technalxs.simplemail.SimpleMailText.trim(patterns[i]).toLowerCase();
        if (string.indexOf(pattern) == -1) return false;
      }
      return true;
    }
  
    this.test = function(message, storage, mail) {
      var value = message[property];
      var result;
  
      switch(this.condition) {
        case "equals":
            result = value == this.param;
            break;
        case "contains":
            // "," separator means "or", "+" means "and"
            var any = this.param.split(/,/);
            for(var i = 0; !result && i < any.length; i++) {
              var all = any[i].split(/\+/);
              result |= matchAll(value, all);
            }
            break;
        case "inAddressBook":
            var address = technalxs.simplemail.SimpleMailModel.SimpleMailAddress.parse(value);
            result = address && storage.getAddressByEmail(address.email);
            break;
        case "greaterThan":
            result = parseInt(value) > parseInt(this.param);
            break;
        default:
            technalxs.simplemail.SimpleMailUtils.error("Unknown condition: " + this.condition);
            break;
      }

      if (this.not & result == 1) {
        return 0;
      } else if (this.not & result == 0) {
        return 1
      } else return result;
    }
  },

  pub.SimpleMailAction = function(id, filterId, name, param) {
    this.id = id;
    this.filterId = filterId;
    this.name = name;
    this.param = param;
  
    this.execute = function(message, storage, mail) {
      switch(this.name) {
        case "sound":
            technalxs.simplemail.SimpleMailSound.play(param);
            break
        case "color":
            message.color = param;
            break;
        case "folder":
            if (storage.getFolder(param)) {
              message.folderId = param;
            }
            break;
        case "delete":
            mail.delete(message);
            return;
        case "download":
            if (message.partial) {
              mail.getBody(message);
              return;
            }
            break;
        case "charset":
            message.recode(param);
            break;
        case "forward":
            technalxs.simplemail.SimpleMailPrefs.setString('forwardParam', param);
            break;          
        case "popup":
        case "counter":
            break; // Obsolete
        default:
            technalxs.simplemail.SimpleMailUtils.error("Unknown action: " + this.name);
            break;
      }
      return message;
    }
  },
  
  pub.SimpleMailFilter = function(id, index, name, type, rules, actions) {
    this.id = id;
    this.index = index;
    this.name = name;
    this.type = type || technalxs.simplemail.SimpleMailModel.SimpleMailFilter.INBOX;
    this.rules = rules;
    this.actions = actions;
  
    this.getName = function() {
      return technalxs.simplemail.SimpleMailBundle.getString(this.name) || this.name;
    }
  
    this.execute = function(message, storage, mail) {
      var len = this.rules.length;
      for(var i = 0; i < len; i++) {
        if (this.rules[i].test(message, storage, mail)) {
          for(var j = 0; message && j < this.actions.length; j++) {
            message = this.actions[j].execute(message, storage, mail);
          }
        }
      }
    return message;
    }
  },

  pub.SimpleMailFilterManager = function(storage, mail) {
    this.storage = storage;
    this.mail = mail;
  
    var filters = storage.getFilters();
  
    this.execute = function(message, type) {
      for(var i = 0; message && i < filters.length; i++) {
        var filter = filters[i];
        // Check if a rule is present
        if (type == filter.type && filter.rules[0]) {
          // Don't apply SPAM filter if SPAM not managed
          if (technalxs.simplemail.SimpleMailPrefs.getBool("nospam") && filter.name !=="SPAM"){
            message = filter.execute(message, this.storage, this.mail);
          }
          else if (!technalxs.simplemail.SimpleMailPrefs.getBool("nospam")){ 
            var filterSPAM = filter;
            var messageFrom = message.from;
            for (var j in filterSPAM.rules){
              if (filterSPAM.rules[j].param == messageFrom) {
                message.spam = true;
                if (technalxs.simplemail.SimpleMailPrefs.getBool("markspamasread")) {
                  message.read = true;
                }
              }
              storage.saveMessageState(message);
            }
            message = filter.execute(message, this.storage, this.mail);
          }
        }
      } 
    return message;          
    }  
  }
  return pub;
}();

technalxs.simplemail.SimpleMailModel.SimpleMailAddress.parse = function(text) {
  if (!text) return;

  var name, email;
  text = text.replace(/[^'"\s<>]+@[^'"\s<>]+/, function($0) {
    email = $0;
    return "";
  });
  name = text.replace(/^['"\s<>]*|['"\s<>]*$/g, "");
  if (name || email) {
    return new technalxs.simplemail.SimpleMailModel.SimpleMailAddress(null, name, email);
  }
}

technalxs.simplemail.SimpleMailModel.SimpleMailAddress.parseList = function(text) {
  var addresses = new Array();
  if (text) {
    var list = ("" + text).split(/[,;]/);
    for(var i in list) {
      var address = technalxs.simplemail.SimpleMailModel.SimpleMailAddress.parse(list[i]);
      if (address) addresses.push(address);
    }
  }
  return addresses;
}

technalxs.simplemail.SimpleMailModel.SimpleMailAddress.create = function() {
  return new technalxs.simplemail.SimpleMailModel.SimpleMailAddress(null, null, null, null, null, null, null);
}

technalxs.simplemail.SimpleMailModel.SimpleMailAccount.ASK = "ask";
technalxs.simplemail.SimpleMailModel.SimpleMailAccount.ALWAYS = "always";
technalxs.simplemail.SimpleMailModel.SimpleMailAccount.ON_RECEIVE = "onreceive";
technalxs.simplemail.SimpleMailModel.SimpleMailAccount.NEVER = "never";

technalxs.simplemail.SimpleMailModel.SimpleMailMessage.parse = function(source, create) {
  return technalxs.simplemail.SimpleMailMessageEncoder.decode(source, create);
}

technalxs.simplemail.SimpleMailModel.SimpleMailMessage.parseMailto = function(mailto) {
  function getUrlParameter(name) {
    var regexp = new RegExp("[?&]" + name + "=([^&]*)", "i");
    var result = regexp.exec(mailto);
    return result ? decodeURIComponent(result[1]) : null;
  }
  var message = new technalxs.simplemail.SimpleMailModel.SimpleMailMessage();
  message.to = decodeURIComponent(/mailto:([^?&]*)/.exec(mailto)[1]);
  message.cc = getUrlParameter("cc");
  message.bcc = getUrlParameter("bcc");
  message.subject = getUrlParameter("subject");
  message.html = getUrlParameter("body");
  return message;
}

technalxs.simplemail.SimpleMailModel.SimpleMailFolder.DEFAULT_NAMES = ["inbox", "sent", "drafts", "trash"];
technalxs.simplemail.SimpleMailModel.SimpleMailFolder.INBOX = 1;
technalxs.simplemail.SimpleMailModel.SimpleMailFolder.SENT = 2;
technalxs.simplemail.SimpleMailModel.SimpleMailFolder.DRAFTS = 3;
technalxs.simplemail.SimpleMailModel.SimpleMailFolder.TRASH = 4;

technalxs.simplemail.SimpleMailModel.SimpleMailRule.getProperties = function() {
 return ["accountId", "from", "to", "subject", "html", "size", "source"];
}

technalxs.simplemail.SimpleMailModel.SimpleMailRule.getConditions = function(property) {
  switch(property) {
    case "accountId":
        return ["equals"];
    case "from":
        return ["contains", "inAddressBook"];
    case "size":
        return ["greaterThan"];
    default:
        return ["contains"];
  }
}

technalxs.simplemail.SimpleMailModel.SimpleMailRule.create = function() {
  return new technalxs.simplemail.SimpleMailModel.SimpleMailRule(null, null, null, null, null, null);
}

technalxs.simplemail.SimpleMailModel.SimpleMailAction.getNames = function() {
  return [ "sound", "color", "folder", "delete", "download", "charset", "forward" ];
}

technalxs.simplemail.SimpleMailModel.SimpleMailAction.create = function() {
  return new technalxs.simplemail.SimpleMailModel.SimpleMailAction(null, null, null, null);
}

technalxs.simplemail.SimpleMailModel.SimpleMailFilter.INBOX = 1;
technalxs.simplemail.SimpleMailModel.SimpleMailFilter.SENT = 2;

technalxs.simplemail.SimpleMailModel.SimpleMailFilter.create = function() {
  return new technalxs.simplemail.SimpleMailModel.SimpleMailFilter(null, null, null, technalxs.simplemail.SimpleMailModel.SimpleMailFilter.INBOX, new Array(), new Array());
}
  
