if(typeof(technalxs) == "undefined") {var technalxs = {};};
if(typeof(technalxs.simplemail) == "undefined" ) {technalxs.simplemail = {};};

technalxs.simplemail.SimpleMailNewMessage = function() {
  var pub = {};

  pub.messageSent = null,
  pub.tmpId =  null,
  pub.tabContainer = null,
  pub.browserWindow = technalxs.simplemail.SimpleMailUtils.getBrowserWindow(),

  // OnLoad event fires twice when iframe is present (FF bug)
  pub.initialized = false,
  
  pub.initialize = function() {
    if (technalxs.simplemail.SimpleMailNewMessage.initialized) return;
    technalxs.simplemail.SimpleMailNewMessage.initialized = true;
    technalxs.simplemail.SimpleMailOverlay = technalxs.simplemail.SimpleMailNewMessage.browserWindow.technalxs.simplemail.SimpleMailOverlay;
    technalxs.simplemail.SimpleMailNewMessage.tabContainer = technalxs.simplemail.SimpleMailNewMessage.browserWindow.getBrowser().tabContainer;
    technalxs.simplemail.SimpleMailNewMessage.initToolbarMode();
    technalxs.simplemail.SimpleMailNewMessage.updateLayout();
    technalxs.simplemail.SimpleMailNewMessage.populateCharset();
    technalxs.simplemail.SimpleMailNewMessage.populateFontName();

    if (technalxs.simplemail.SimpleMailPrefs.getBool("old")) {
      technalxs.simplemail.SimpleMailDom.remove("nuvola-style");
      technalxs.simplemail.SimpleMailDom.remove("oxygen-style");
      technalxs.simplemail.SimpleMailDom.remove("australis-style");
    }
    else if (technalxs.simplemail.SimpleMailPrefs.getBool("nuvola")) {
      technalxs.simplemail.SimpleMailDom.remove("old-style");
      technalxs.simplemail.SimpleMailDom.remove("oxygen-style");
      technalxs.simplemail.SimpleMailDom.remove("australis-style");
    }
    else if (technalxs.simplemail.SimpleMailPrefs.getBool("oxygen")) {
      technalxs.simplemail.SimpleMailDom.remove("old-style");
      technalxs.simplemail.SimpleMailDom.remove("nuvola-style");
      technalxs.simplemail.SimpleMailDom.remove("australis-style");
    }
    else if (technalxs.simplemail.SimpleMailPrefs.getBool("australis")) {
      technalxs.simplemail.SimpleMailDom.remove("old-style");
      technalxs.simplemail.SimpleMailDom.remove("nuvola-style");
      technalxs.simplemail.SimpleMailDom.remove("oxygen-style");
    }

    if (technalxs.simplemail.SimpleMailPrefs.getBool("newMessagesInWindow") || technalxs.simplemail.SimpleMailPrefs.getBool("messagesInWindow")) { 
          technalxs.simplemail.SimpleMailNewMessage.tmpId = technalxs.simplemail.SimpleMailPrefs.getString('tmpId');
          var message = technalxs.simplemail.SimpleMailPrefs.getObject('message');
          technalxs.simplemail.SimpleMailOverlay.tmp[technalxs.simplemail.SimpleMailNewMessage.tmpId] = message;
    }

    // Important: Do not allow mail messages to execute javascript,
    // Because this javascript would be executed with chrome privileges
    technalxs.simplemail.SimpleMailDom.get("body").docShell.allowJavascript = false;

    technalxs.simplemail.SimpleMailNewMessage.populateFrom();

    var doc = technalxs.simplemail.SimpleMailDom.get("body").contentDocument;

    doc.addEventListener("keyup", technalxs.simplemail.SimpleMailNewMessage.onKeyUp, false);
    doc.addEventListener("keypress", technalxs.simplemail.SimpleMailNewMessage.onKeyPress, false);
    doc.addEventListener("mouseup", technalxs.simplemail.SimpleMailNewMessage.onMouseUp, false);
    doc.addEventListener("drop", technalxs.simplemail.SimpleMailNewMessage.dodrop, false);
    if (!window.technalxs.simplemail.SimpleMailNewMessage.tmpId) technalxs.simplemail.SimpleMailNewMessage.tmpId = /\?(.*)/.exec(location.href)[1];

    technalxs.simplemail.SimpleMailNewMessage.setMessage(technalxs.simplemail.SimpleMailOverlay.tmp[technalxs.simplemail.SimpleMailNewMessage.tmpId]);
    technalxs.simplemail.SimpleMailNewMessage.getMessage().copyTo(technalxs.simplemail.SimpleMailOverlay.tmp[technalxs.simplemail.SimpleMailNewMessage.tmpId]);

    doc.designMode = "on";
    doc.documentElement.contentEditable = "true";
    doc.body.spellcheck = "true";
    // Support for RTL language
    var lang = window.navigator.language
    if  (lang == "ar" || lang == "he"){
      doc.dir = "rtl";
    }

    if (technalxs.simplemail.SimpleMailPrefs.getBool("plaintextOnSend")) {
      technalxs.simplemail.SimpleMailDom.get("smile").hidden = true;
      technalxs.simplemail.SimpleMailDom.get("message-edit-toolbar").collapsed = true;
      if (!technalxs.simplemail.SimpleMailPrefs.getBool("warningPlainText")) {
        technalxs.simplemail.SimpleMailDom.get("headers-plaintextonsend").hidden = false;
      } else {
        technalxs.simplemail.SimpleMailDom.get("headers-plaintextonsend").hidden = true;
      }
      technalxs.simplemail.SimpleMailNewMessage.execCommand('FontName', 'Consolas');
      technalxs.simplemail.SimpleMailNewMessage.execCommand('FontSize', '2');
      technalxs.simplemail.SimpleMailNewMessage.execCommand('ForeColor', '#000000');
      doc.body.style.fontFamily = "Consolas";
      doc.body.style.fontSize = "0.8em";       
    } 
    else {
      technalxs.simplemail.SimpleMailDom.get("headers-plaintextonsend").hidden = true;
      var font = technalxs.simplemail.SimpleMailPrefs.getObject("font");
      if (font["FontName"] == "Consolas") {
        technalxs.simplemail.SimpleMailNewMessage.execCommand('FontName', 'Arial');
        technalxs.simplemail.SimpleMailNewMessage.execCommand('FontSize', '2');
      }
    }

    technalxs.simplemail.SimpleMailNewMessage.getFont();

    // Need to do this on timeout, otherwise iframe.contentWindow isn't focused
    setTimeout(function() {
                 !technalxs.simplemail.SimpleMailDom.get("to").value ? technalxs.simplemail.SimpleMailDom.get("to").focus() :
                 !technalxs.simplemail.SimpleMailDom.get("subject").value ? technalxs.simplemail.SimpleMailDom.get("subject").focus()
                                     : technalxs.simplemail.SimpleMailDom.get("body").contentWindow.focus();
               }, 0);
  
    if (!technalxs.simplemail.SimpleMailPrefs.getBool("newMessagesInWindow")) { 
      technalxs.simplemail.SimpleMailNewMessage.tabContainer.addEventListener("TabClose", technalxs.simplemail.SimpleMailNewMessage.onTabClose, false);
    }
  },
  
  pub.onUnload = function () {
    // Need to remove event listener when message window is closed/reloaded
    if (technalxs.simplemail.SimpleMailPrefs.getBool("newMessagesInWindow")) {
      technalxs.simplemail.SimpleMailNewMessage.onClose();    
    }
    else {
      technalxs.simplemail.SimpleMailNewMessage.tabContainer.removeEventListener("TabClose", technalxs.simplemail.SimpleMailNewMessage.onTabClose, false);
    }
  },
  
  pub.onTabClose = function(event) {
      if (event.target.linkedBrowser.contentDocument == document) technalxs.simplemail.SimpleMailNewMessage.onClose();
  },
  
  pub.onClose = function() {

    technalxs.simplemail.SimpleMailNewMessage.saveDraft();
    technalxs.simplemail.SimpleMailOverlay.tmp[technalxs.simplemail.SimpleMailNewMessage.tmpId] = null; // Clean up temporary message
    technalxs.simplemail.SimpleMailPrefs.clear('originalId');

    if (technalxs.simplemail.SimpleMailPrefs.getBool("newMessagesInWindow") || technalxs.simplemail.SimpleMailPrefs.getBool("messagesInWindow")) {
      technalxs.simplemail.SimpleMailPrefs.clear('tmpId'); // Clean up temporary prefs
      technalxs.simplemail.SimpleMailPrefs.clear('message');
      technalxs.simplemail.SimpleMailPrefs.clear('originalId');
      technalxs.simplemail.SimpleMailOverlay.refreshTab("chrome://simplemail/content/main/main.xul");
    }
  },
  
  pub.saveDraft = function(doSave, template) {
    var original = technalxs.simplemail.SimpleMailOverlay.tmp[technalxs.simplemail.SimpleMailNewMessage.tmpId];
    var message = technalxs.simplemail.SimpleMailNewMessage.getMessage();
    if (message.equals(original)) return;
    
    if (!doSave) {
      doSave = !technalxs.simplemail.SimpleMailNewMessage.messageSent &&
                   !message.equals(original) &&
                   technalxs.simplemail.SimpleMailNewMessage.confirmSaveDraft();
    }
 
    if (doSave) {
      message.folderId = technalxs.simplemail.SimpleMailModel.SimpleMailFolder.DRAFTS;
      message.template = template;
      technalxs.simplemail.SimpleMailOverlay.addMessage(message);
      technalxs.simplemail.SimpleMailOverlay.tmp[technalxs.simplemail.SimpleMailNewMessage.tmpId] = technalxs.simplemail.SimpleMailNewMessage.getMessage();
      if (technalxs.simplemail.SimpleMailPrefs.getBool("newMessagesInWindow")){
        var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                     .getService(Components.interfaces.nsIWindowMediator);
        var win = wm.getMostRecentWindow(null);
        technalxs.simplemail.SimpleMailOverlay.refreshTab("chrome://simplemail/content/main/main.xul");
        setTimeout(function(){win.focus();}, 500);
      }
    }

    if (original == null) return;

    if (original.id && (!original.template || template) &&
        (technalxs.simplemail.SimpleMailNewMessage.messageSent || doSave))
    {
      setTimeout(function(){technalxs.simplemail.SimpleMailOverlay.deleteMessages([original]);}, 5000);
    }
  },
  
  pub.confirmSaveDraft = function() {
    var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                  .getService(Components.interfaces.nsIPromptService);
    var button = prompts.confirmEx(window, "Simple Mail",
                                   technalxs.simplemail.SimpleMailBundle.getString("saveAsDraft"),
                                   prompts.STD_YES_NO_BUTTONS, null, null, null,
                                   null, {});
    return (button == 0); // "Yes"
  },
  
  pub.populateFrom = function() {
    var accounts = technalxs.simplemail.SimpleMailOverlay.storage.getAccounts();
    for(var i in accounts) {
      if (!accounts[i].smtp.host) continue;
  
      var menuitem = document.createElement("menuitem");
      menuitem.setAttribute("label", accounts[i]);
      menuitem.setAttribute("value", accounts[i].id);
      technalxs.simplemail.SimpleMailDom.get("from").menupopup.appendChild(menuitem);
    }
  },
  
  pub.filterAddressList = function(list, exclude) {
    var result = "";
    exclude = technalxs.simplemail.SimpleMailModel.SimpleMailAddress.parse(exclude);
    var addresses = technalxs.simplemail.SimpleMailModel.SimpleMailAddress.parseList(list);
    for(var i in addresses) {
      if (addresses[i].email != exclude.email) {
        result += result ? ", " + addresses[i] : addresses[i];
      }
    }
    return result;
  },
  
  pub.getMessage = function() {
    var message = new technalxs.simplemail.SimpleMailModel.SimpleMailMessage();
    message.accountId = technalxs.simplemail.SimpleMailDom.get("from").selectedItem.value;
    message.charset = technalxs.simplemail.SimpleMailDom.get("charset").selectedItem.label;
    message.returnReceiptTo = technalxs.simplemail.SimpleMailDom.get("returnReceipt").checked
                                  ? technalxs.simplemail.SimpleMailDom.get("from").selectedItem.label : null;
    message.from = technalxs.simplemail.SimpleMailDom.get("from").label;
    var account = technalxs.simplemail.SimpleMailOverlay.storage.getAccount(message.accountId);
    message.replyTo = account.replyTo;
    message.to = technalxs.simplemail.SimpleMailDom.get("to").value;
    message.cc = technalxs.simplemail.SimpleMailDom.get("cc").value;
    message.bcc = technalxs.simplemail.SimpleMailDom.get("bcc").value;
    message.subject = technalxs.simplemail.SimpleMailDom.get("subject").value;
    message.html = technalxs.simplemail.SimpleMailDom.get("body").contentDocument.body.innerHTML;
    return message;
  },
  
  pub.cleanAddresses = function(text) {
    var result = "";
    if (text.match(/(>,)/g)){
      text = text.replace (/(>,).*?/ig, ">;");
    }
    if (text.match(/(,)/g)){
      text = text.replace (/(,).*?/ig, ";");
    }    
    var list = ("" + text).split(/[;]/);
    for(var i in list){
      if (list[i].toString().match(/(@)/g)){
        result += result ? " " + list[i] + ", ": list[i] + ", ";
      } else {
        result += result ? " " + list[i] : list[i];
      }
    }
    result = result.replace(/(, )$/, "");
    return result;
   },
  
  pub.sendMail = function() {
    var message = technalxs.simplemail.SimpleMailNewMessage.getMessage();
    if (!message.to && !message.cc && !message.bcc) {
      var confirmText = technalxs.simplemail.SimpleMailBundle.getString("specifyRecipient");
      technalxs.simplemail.SimpleMailUtils.alert(confirmText);
      return;
    }

    // If exist, delete coma in name
    technalxs.simplemail.SimpleMailPrefs.setString('originalTo', message.to);
    technalxs.simplemail.SimpleMailPrefs.setString('originalCc', message.cc);
    technalxs.simplemail.SimpleMailPrefs.setString('originalBcc', message.bcc);
    
    message.to = technalxs.simplemail.SimpleMailNewMessage.cleanAddresses(message.to);
    message.cc = technalxs.simplemail.SimpleMailNewMessage.cleanAddresses(message.cc); 
    message.bcc = technalxs.simplemail.SimpleMailNewMessage.cleanAddresses(message.bcc);
     
    technalxs.simplemail.SimpleMailOverlay.sendMail(message, function() {
      technalxs.simplemail.SimpleMailNewMessage.messageSent = true;
      var mainWindow = technalxs.simplemail.SimpleMailOverlay.getMainWindow(true);
      window.close();
      if (mainWindow) mainWindow.history.go();
    });
  },

  // 1. Groups may be nested
  // 2. Have to work around circular references
  
  pub.expandGroups = function(string) {
    var addresses = technalxs.simplemail.SimpleMailModel.SimpleMailAddress.parseList(string);
    var results = [], processed = [];
    var address;
    while((address = addresses.shift())) {
      if (!address.email && !address.id) {
        var address = technalxs.simplemail.SimpleMailOverlay.storage.getAddressByName(address) || address;
      }
      if (!address.group) {
        results.push(address);
      }
      else if (!processed[address.id]) {
        processed[address.id] = true;
        var group = technalxs.simplemail.SimpleMailOverlay.storage.getAddresses(address.group);
        addresses = addresses.concat(group);
      }
    }
    return results.join(", ");
  },

  pub.execCommand = function(command, param) {
    switch(command) {  
      case "ForeColor":
        param = technalxs.simplemail.SimpleMailNewMessage.convertColor(param);
      case "FontName":
      case "FontSize":
        var font = technalxs.simplemail.SimpleMailPrefs.getObject("font");
		font[command] = param;
		technalxs.simplemail.SimpleMailPrefs.setObject("font", font);
    }
    technalxs.simplemail.SimpleMailDom.get("body").contentDocument.execCommand(command, false, param);
    technalxs.simplemail.SimpleMailDom.get("body").contentWindow.focus();
  },

  pub.insertLink = function() {
    var selection = technalxs.simplemail.SimpleMailDom.get("body").contentWindow.getSelection();
    var range = selection.getRangeAt(0);
  
    var url = { value: technalxs.simplemail.SimpleMailText.getURL(selection) || "http://" };
  
    var parent = range.startContainer.parentNode;
    if (parent.nodeName == "A") {
      if (selection == "") range.selectNodeContents(parent);
      url.value = parent.href;
    }
  
    if (technalxs.simplemail.SimpleMailUtils.prompt("enterLinkURL", url) && url.value) {
      if (selection != "") {
        technalxs.simplemail.SimpleMailNewMessage.execCommand("Unlink");
        technalxs.simplemail.SimpleMailNewMessage.execCommand("CreateLink", url.value);
      }
      else technalxs.simplemail.SimpleMailNewMessage.execCommand("InsertHtml",
                       "<a href='" + url.value + "'>" + url.value + "</a>");
    }
    selection.collapseToEnd();
    technalxs.simplemail.SimpleMailNewMessage.execCommand("Unlink");
  },
  
  pub.insertTable = function() {
    technalxs.simplemail.SimpleMailNewMessage.execCommand("InsertHtml", "<table style='font: inherit;' border='1'>" +
                              "<tr><td></td><td></td></tr>" +
                              "<tr><td></td><td></td></tr></table>");
  },
  
  // Don't focus colorpicker when switching fields by Tab/Shift-Tab keys
  pub.skipColorpicker = function(event) {
    if (event.keyCode == event.DOM_VK_TAB) {
      if (!event.shiftKey) technalxs.simplemail.SimpleMailDom.get("body").contentWindow.focus();
      else technalxs.simplemail.SimpleMailDom.get("subject").select();
    }
  },

  pub.setMessage = function(message) {
    document.title = message.subject || " ";
    var body = technalxs.simplemail.SimpleMailDom.get("body");
    technalxs.simplemail.SimpleMailDom.get("returnReceipt").checked = message.returnReceiptTo ||
                                         technalxs.simplemail.SimpleMailPrefs.getBool("returnReceipt");
    technalxs.simplemail.SimpleMailUtils.selectItem("from", message.accountId);
    var me = technalxs.simplemail.SimpleMailDom.get("from").selectedItem.label;
    technalxs.simplemail.SimpleMailDom.get("to").value = technalxs.simplemail.SimpleMailNewMessage.filterAddressList(technalxs.simplemail.SimpleMailNewMessage.expandGroups(message.to), me);
    technalxs.simplemail.SimpleMailDom.get("cc").value = technalxs.simplemail.SimpleMailNewMessage.filterAddressList(technalxs.simplemail.SimpleMailNewMessage.expandGroups(message.cc), me);
    technalxs.simplemail.SimpleMailDom.get("bcc").value = technalxs.simplemail.SimpleMailNewMessage.expandGroups(message.bcc);
    technalxs.simplemail.SimpleMailUtils.selectItem("charset", message.charset ||
                                  technalxs.simplemail.SimpleMailPrefs.getString("charset"), true);
    technalxs.simplemail.SimpleMailDom.get("subject").value = message.subject || "";
    if (technalxs.simplemail.SimpleMailPrefs.getBool("plaintextOnSend")) {
      if (message.html == undefined){
        var fragment = technalxs.simplemail.SimpleMailUtils.parseHTML(body.contentDocument, "\r\n", true);
        body.contentDocument.body.innerHTML = "";
        body.contentDocument.body.appendChild(fragment);
      } else {
        var fragment = technalxs.simplemail.SimpleMailUtils.parseHTML(body.contentDocument, message.html, true);
        body.contentDocument.body.innerHTML = "";
        body.contentDocument.body.appendChild(fragment);
      }      
    }
    else {
      if (message.html == undefined){
        var fragment = technalxs.simplemail.SimpleMailUtils.parseHTML(body.contentDocument, "<br>", true);
        body.contentDocument.body.innerHTML = "";
        body.contentDocument.body.appendChild(fragment);
      } else {
        var fragment = technalxs.simplemail.SimpleMailUtils.parseHTML(body.contentDocument, message.html, true);
        body.contentDocument.body.innerHTML = "";
        body.contentDocument.body.appendChild(fragment);
      }
    }

    technalxs.simplemail.SimpleMailNewMessage.populateSubject();
    if (message.folderId !== 3) {
      technalxs.simplemail.SimpleMailNewMessage.populateSignature();
    }
  },

  pub.populateSubject = function() {
    var accountId = technalxs.simplemail.SimpleMailDom.get("from").selectedItem.value;
    var account = technalxs.simplemail.SimpleMailOverlay.storage.getAccount(accountId);
    var lastSubject;
    var subject = account.subject || "";
    var regexp = new RegExp("^(" + (lastSubject || subject) + ")?$");
    technalxs.simplemail.SimpleMailDom.get("subject").value = technalxs.simplemail.SimpleMailDom.get("subject").value.replace(regexp, lastSubject = subject);
  },
  
  pub.getCurrentSignature = function() {
    var accountId = technalxs.simplemail.SimpleMailDom.get("from").selectedItem.value;
    var account = technalxs.simplemail.SimpleMailOverlay.storage.getAccount(accountId);
    var signature = account.signature.replace(/\r?\n/g, "<br>");

    if (signature) {
      var doc = technalxs.simplemail.SimpleMailDom.get("body").contentDocument;
      var tmp = doc.createElement("div");
      var fragment = technalxs.simplemail.SimpleMailUtils.parseHTML(doc, signature, true);
      tmp.appendChild(fragment);
      signature = tmp.innerHTML + "<br>";
    }
    return signature;
  },
  
  pub.populateSignature = function() {
    var body = technalxs.simplemail.SimpleMailDom.get("body");
  
    var signature = technalxs.simplemail.SimpleMailNewMessage.getCurrentSignature();
    var prepend = technalxs.simplemail.SimpleMailDom.get("subject").value.match(/^(Re:|Fwd:)/i);

    var accounts = technalxs.simplemail.SimpleMailOverlay.storage.getAccounts();

    for(var i in accounts) {
      if (lastSignature){
        var currentSignature = lastSignature;
      } else {
        var currentSignature = accounts[i].signature.replace(/\r?\n/g, "<br>");
      }

     var regexp = new RegExp("(" + currentSignature + ")?$");

      if (body.contentDocument.body.innerHTML.match(regexp)){
        var signatureFragment = technalxs.simplemail.SimpleMailUtils.parseHTML(body.contentDocument, signature, true);
        
        if (prepend){
          if (lastSignature){
            return;
          }
          body.contentDocument.body.insertBefore(signatureFragment, body.contentDocument.body.childNodes[0]);
        } else {
          if (lastSignature){
            return;
          }
          if (body.contentDocument.getElementById("Signature")){
            var node = body.contentDocument.getElementById("Signature");
            if (node.parentNode) {
              node.parentNode.removeChild(node);
            }
          }
          var tmp = body.contentDocument.createElement("div");
          tmp.setAttribute("id", "Signature");
          var tmp2 = body.contentDocument.createElement("div");
          tmp2.setAttribute("id", "Text");
          tmp.appendChild(tmp2)
          tmp2.appendChild(signatureFragment);
          body.contentDocument.body.appendChild(tmp)

        }
       var lastSignature = signature; 
       return;
      }
    }    
  },
  
  pub.updateLayout = function() {
    var hide = !technalxs.simplemail.SimpleMailPrefs.getBool("fullEdit");
    technalxs.simplemail.SimpleMailDom.get("cc-row").hidden = hide;
    technalxs.simplemail.SimpleMailDom.get("bcc-row").hidden = hide;
    technalxs.simplemail.SimpleMailDom.get("message-edit-toolbar").hidden = hide;
  },
  
  pub.switchLayout = function() {
    technalxs.simplemail.SimpleMailPrefs.setBool("fullEdit", !technalxs.simplemail.SimpleMailPrefs.getBool("fullEdit"));
    technalxs.simplemail.SimpleMailNewMessage.updateLayout();
  },
  
  pub.isNewLine = function() {
    var selection = technalxs.simplemail.SimpleMailDom.get("body").contentWindow.getSelection();
    var element = selection.focusNode;
  
    return selection.focusOffset == 0 ||
           element.nodeType != element.TEXT_NODE;
  },
  
  pub.insertQuoteBreak = function(event) {
    if (!technalxs.simplemail.SimpleMailNewMessage.isNewLine()) return;
  
    var selection = technalxs.simplemail.SimpleMailDom.get("body").contentWindow.getSelection();
  
    var blockquoteCount = 0;
    for(var element = selection.focusNode;
        element;
        element = element.parentNode)
    {
      if (element.nodeName == "BLOCKQUOTE") blockquoteCount++;
    }
  
    if (blockquoteCount) {
      for(var i = 0; i < blockquoteCount; i++) {
        technalxs.simplemail.SimpleMailNewMessage.execCommand("Outdent");
      }
      event.preventDefault();
    }
  },
  
  pub.initToolbarMode = function() {
    var mode = technalxs.simplemail.SimpleMailPrefs.getString("toolbarMode");
    technalxs.simplemail.SimpleMailDom.get("message-toolbar").setAttribute("mode", mode);
  
    var menuitems = technalxs.simplemail.SimpleMailDom.get("toolbar-menu").childNodes;
    var len = menuitems.length;
    for(var i = 0; i < len; i++) {
      if (menuitems[i].value == mode) {
        menuitems[i].setAttribute("checked", true);
      }
    }
  },
  
  pub.updateToolbarMode = function() {
    var menuitems = technalxs.simplemail.SimpleMailDom.get("toolbar-menu").childNodes;
    var len = menuitems.length;
    for(var i = 0; i < len; i++) {
      if (menuitems[i].getAttribute("checked")) {
        technalxs.simplemail.SimpleMailPrefs.setString("toolbarMode", menuitems[i].value);
        technalxs.simplemail.SimpleMailDom.get("message-toolbar").setAttribute("mode", menuitems[i].value);
      }
    }
  },
  
  pub.populateFontName = function() {
    var popup = technalxs.simplemail.SimpleMailDom.get("fontName").menupopup;
    var fonts = technalxs.simplemail.SimpleMailUtils.getFontList();
    var len = fonts.length;
    for(var i = 0; i < len; i++) {
      var menuitem = document.createElement("menuitem");
      menuitem.setAttribute("label", fonts[i]);
      menuitem.setAttribute("value", fonts[i]);
      popup.appendChild(menuitem);
    }
  },
  
  pub.populateCharset = function() {
    var popup = technalxs.simplemail.SimpleMailDom.get("charset").menupopup;
    var charsets = technalxs.simplemail.SimpleMailUtils.getDefaultCharsets();
    var len = charsets.length;
    for(var i = 0; i < len; i++) {
      var menuitem = document.createElement("menuitem");
      menuitem.setAttribute("label", charsets[i]);
      popup.appendChild(menuitem);
    }
  },
  
  pub.onKeyUp = function(event) {
    if (!technalxs.simplemail.SimpleMailPrefs.getBool("plaintextOnSend")) {
      technalxs.simplemail.SimpleMailNewMessage.updateLink(event);
    }
    technalxs.simplemail.SimpleMailNewMessage.getFont();
  },
  
  pub.onKeyPress = function(event) {
    if (event.keyCode == event.DOM_VK_RETURN) {
      if (event.ctrlKey) {
        technalxs.simplemail.SimpleMailNewMessage.sendMail();
      }
      else technalxs.simplemail.SimpleMailNewMessage.insertQuoteBreak(event);
    }
    else {
      var char = String.fromCharCode(event.charCode);
      switch(char) {
        case " ":
        case ",": technalxs.simplemail.SimpleMailNewMessage.execCommand("Unlink");
                  break;
      }
    }
  },
  
  pub.onMouseUp = function(event) {
    if (event.ctrlKey) {
      var font = technalxs.simplemail.SimpleMailPrefs.getObject("font");
      technalxs.simplemail.SimpleMailNewMessage.execCommand("ForeColor", font.ForeColor);
    }
    if (!technalxs.simplemail.SimpleMailPrefs.getBool("plaintextOnSend")) {
      technalxs.simplemail.SimpleMailNewMessage.updateLink(event);
    }
    technalxs.simplemail.SimpleMailNewMessage.getFont();
  },
  
  pub.convertColor = function(color) {
    var match = color.match(/rgb\((\d+), (\d+), (\d+)\)/);
    
      function toHex(value) {
        value = parseInt(value).toString(16).toUpperCase();
        return value.length == 1 ? "0" + value : value;
      }
    
    if (match) {

      color = "#" + toHex(match[1]) + toHex(match[2]) + toHex(match[3]);
    }
    if (color == "#000000") color = "normal";
    return color;
  },
  
  pub.disableCss = function(disable) {
    var doc = technalxs.simplemail.SimpleMailDom.get("body").contentDocument;
    var len = doc.styleSheets.length;
    for(var i = 0; i < len; i++) {
      doc.styleSheets[i].disabled = disable;
    }
  },
  
  pub.setFont = function() {
    var selection = technalxs.simplemail.SimpleMailDom.get("body").contentWindow.getSelection();
    var range = selection.getRangeAt(0);
  
    if (selection == "" &&
        range.startContainer.nodeName == "BODY") // This is a new line
    {
      var font = technalxs.simplemail.SimpleMailPrefs.getObject("font");
      for(var i in font) {
        technalxs.simplemail.SimpleMailNewMessage.execCommand(i, font[i]);
      }
    }
  },

  pub.getFont = function() {
    technalxs.simplemail.SimpleMailNewMessage.setFont();
    technalxs.simplemail.SimpleMailNewMessage.disableCss(true);
    var doc = technalxs.simplemail.SimpleMailDom.get("body").contentDocument;
    technalxs.simplemail.SimpleMailUtils.selectItem("fontName", doc.queryCommandValue("FontName"), true);
    technalxs.simplemail.SimpleMailUtils.selectItem("fontSize", doc.queryCommandValue("FontSize"));
    technalxs.simplemail.SimpleMailDom.get("color").color = doc.queryCommandValue("ForeColor") || "#000000";
    technalxs.simplemail.SimpleMailNewMessage.getTextProperties();
    technalxs.simplemail.SimpleMailNewMessage.getTextJustify();
    technalxs.simplemail.SimpleMailNewMessage.disableCss(false);
  },

  pub.getTextProperties = function() {
    var selection = technalxs.simplemail.SimpleMailDom.get("body").contentWindow.getSelection();
  
    var bold, italic, underline, bullet, number;
    for(var element = selection.focusNode;
        element;
        element = element.parentNode)
    {
      bold = bold ||
             element.nodeName == "B" ||
             element.nodeName == "STRONG" ||
             element.style && element.style.fontWeight == "bold";
  
      italic = italic ||
               element.nodeName == "I" ||
               element.nodeName == "EM" ||
               element.style && element.style.fontStyle == "italic";
  
      underline = underline ||
                  element.nodeName == "U" ||
                  element.style && element.style.textDecoration == "underline";
  
      bullet = bullet || element.nodeName == "UL";
      number = number || element.nodeName == "OL";
    }
    technalxs.simplemail.SimpleMailDom.get("bold").checked = bold;
    technalxs.simplemail.SimpleMailDom.get("italic").checked = italic;
    technalxs.simplemail.SimpleMailDom.get("underline").checked = underline;
    technalxs.simplemail.SimpleMailDom.get("bullet").checked = bullet;
    technalxs.simplemail.SimpleMailDom.get("number").checked = number;
  },
  
  pub.getTextJustify = function() {
    var doc = technalxs.simplemail.SimpleMailDom.get("body").contentDocument;
    var justify = doc.queryCommandValue("justifyLeft");
  
    var names = ["left", "center", "right"];
    for(var i in names) {
      technalxs.simplemail.SimpleMailDom.get(names[i]).checked = names[i] == justify;
    }
  },
  
  pub.updateLink = function(event) {
    var doc = technalxs.simplemail.SimpleMailDom.get("body").contentDocument;
    var selection = technalxs.simplemail.SimpleMailDom.get("body").contentWindow.getSelection();
    var range = selection.getRangeAt(0); 
  
    var node = range.startContainer;
    var parent = node.parentNode;
    if (parent && parent.nodeName == "A") {
      var url = technalxs.simplemail.SimpleMailText.getURL(node.textContent);
      if (url && url != parent.href) parent.href = url;
    }
    else {
      var url;
      while(node && node.nodeType == node.TEXT_NODE &&
            (url = technalxs.simplemail.SimpleMailText.getURL(node.textContent)))
      {
        var start = node.textContent.indexOf(url);
        range = selection.getRangeAt(0);
        range.selectNode(node);
        range.setStart(node, start);
        range.setEnd(node, start + url.length);
        technalxs.simplemail.SimpleMailNewMessage.execCommand("CreateLink", url);
  
        range = selection.getRangeAt(0);
        range.collapse(false);
        var link = range.startContainer.parentNode;
        node = link.nextSibling;
      }
    }
  },
  
  pub.populateSmiles = function() { 
    var menupopup = technalxs.simplemail.SimpleMailDom.get("smile").firstChild;
    technalxs.simplemail.SimpleMailUtils.clearElement(menupopup);
    technalxs.simplemail.SimpleMailNewMessage.populateSmilesFrom(technalxs.simplemail.SimpleMailFile.getSmilesDirectory(), "chrome://simplemail/skin/smiles/");
    technalxs.simplemail.SimpleMailNewMessage.populateSmilesFrom(technalxs.simplemail.SimpleMailFile.getDirectory("smiles"), "simplemail://smiles/");
    var horizontalBox = document.createElement("hbox");
    menupopup.appendChild(horizontalBox);
  
    var browse = document.createElement("label");
    browse.setAttribute("value", "...");
    browse.addEventListener("click", technalxs.simplemail.SimpleMailNewMessage.browseSmiles, false);
    horizontalBox.appendChild(browse);
  },
  
  pub.populateSmilesFrom = function(directory, baseUrl) {
    var SMILES_PER_ROW = 5;
    var horizontalBox, i = 0;
    var menupopup = technalxs.simplemail.SimpleMailDom.get("smile").firstChild;
    
    technalxs.simplemail.SimpleMailFile.forEachFile(directory, function(file) {
      var image = document.createElement("image");
      image.setAttribute("src", baseUrl + file.leafName);
  
      var verticalBox = document.createElement("vbox");
      verticalBox.appendChild(image);

      if (i++ % SMILES_PER_ROW == 0) {
        horizontalBox = document.createElement("hbox");
        horizontalBox.setAttribute("align", "baseline");
        menupopup.appendChild(horizontalBox);
      }
      horizontalBox.appendChild(verticalBox);
    });
  },
  
  pub.browseSmiles = function() {
    technalxs.simplemail.SimpleMailDom.get("smile").firstChild.hidePopup();
  
    var files = technalxs.simplemail.SimpleMailFile.chooseFile("multiple", ["images"]);
    var targetDir = technalxs.simplemail.SimpleMailFile.getDirectory("smiles");
  
    for(var i in files) {
      var target = targetDir.clone();
      target.append(files[i].leafName);
      if (target.exists()) target.remove(false);
      files[i].copyTo(targetDir, files[i].leafName);
    }
    technalxs.simplemail.SimpleMailDom.get("smile").firstChild.showPopup();
  },
  
  pub.insertSmile = function(element) {
    var url = element.getAttribute("src") || element.getAttribute("image");
    if (url) {
      technalxs.simplemail.SimpleMailNewMessage.execCommand("InsertImage", url);
      technalxs.simplemail.SimpleMailDom.get("smile").firstChild.hidePopup();
    }
  },
  
  pub.removeSmile = function(element) {
    var url = element.getAttribute("src");
    var name = technalxs.simplemail.SimpleMailFile.getFileName(url);
    var file = technalxs.simplemail.SimpleMailFile.getDirectory("smiles");
    file.append(name);
    try {
      file.remove(false);
      technalxs.simplemail.SimpleMailNewMessage.populateSmiles();
    }
    catch(e) {}
  },
  
  pub.onSmileClick = function(event) {
    if (event.button == 0) technalxs.simplemail.SimpleMailNewMessage.insertSmile(event.target);
    if (event.button == 2) technalxs.simplemail.SimpleMailNewMessage.removeSmile(event.target);
  },
  
  pub.insertImage = function() {
    var files = technalxs.simplemail.SimpleMailFile.chooseFile("multiple", ["images"]);
    if (!files) return;
    
    for(var i in files) {
      var url = technalxs.simplemail.SimpleMailFile.getFileURL(files[i]);
      technalxs.simplemail.SimpleMailNewMessage.execCommand("InsertImage", url);
    }
  },  
  
  pub.attachFile = function() {
    var files = technalxs.simplemail.SimpleMailFile.chooseFile("multiple");
    if (!files) return;
    var html = "";

    for(var i in files) {
      var url = technalxs.simplemail.SimpleMailFile.getFileURL(files[i]);
      var filename = technalxs.simplemail.SimpleMailFile.getFileName(url);
      var background = technalxs.simplemail.SimpleMailMessageEncoder.getIconForAttachment(filename);
      filename = filename.toString().replace(/[\'] */gi, "_");
      html = "<a class='attachment' style='background: url(" + background + ")center left no-repeat;' href='" + url + "'>" + filename + "</a>";
      technalxs.simplemail.SimpleMailNewMessage.pushAttachFile(html);
    } 
  },
  
  pub.pushAttachFile  = function(html){
    var body = technalxs.simplemail.SimpleMailDom.get("body");
    var range = document.createRange();
    var documentFragment = range.createContextualFragment(html)
    body.contentDocument.body.appendChild(documentFragment);
    var message = technalxs.simplemail.SimpleMailNewMessage.getMessage();

    // Need this to update RichText Editor
    technalxs.simplemail.SimpleMailNewMessage.execCommand("selectAll");
    technalxs.simplemail.SimpleMailNewMessage.execCommand("delete");
    technalxs.simplemail.SimpleMailNewMessage.execCommand("InsertHtml", message.html);
  },  
  
  pub.dodrop = function(event) {
    var MOZ_URL = "text/x-moz-url";
    var html = ""; 
    var dt = event.dataTransfer;
    var count = dt.mozItemCount;
    var origin = dt.mozSourceNode;

    if (origin == null) {
      for (var i = 0; i < count; i++) {
        var files = dt.mozGetDataAt(MOZ_URL, i);
        var url = files;
        var ttype = technalxs.simplemail.SimpleMailFile.getMimeType(url);
        if (ttype.match(/^image/i)){
          event.preventDefault();
          var filename = technalxs.simplemail.SimpleMailFile.getFileName(url);
          var background = technalxs.simplemail.SimpleMailMessageEncoder.getIconForAttachment(filename);
          html = "<a class='attachment' style='background: url(" + background + ")center left no-repeat;' href='" + url + "'>" + filename + "</a>";
          technalxs.simplemail.SimpleMailNewMessage.pushAttachFile(html); 
        }  
        else if (url.match(/^file:/)) { 
          var filename = technalxs.simplemail.SimpleMailFile.getFileName(url);
          var background = technalxs.simplemail.SimpleMailMessageEncoder.getIconForAttachment(filename);
          html = "<a class='attachment' style='background: url(" + background + ")center left no-repeat;' href='" + url + "'>" + filename + "</a>";
          technalxs.simplemail.SimpleMailNewMessage.pushAttachFile(html); 
        }
      }
    }
  }
  return pub;
}();

technalxs.simplemail.AutoComplete = function (){
var pub = {};
  pub.values = new Array(),
  pub.REGEXP = /\s*([^,;]*)$/,

  pub.onInput = function(textbox) {
    if (textbox.userAction == "typing") { // SeaMonkey
      technalxs.simplemail.AutoComplete.values[textbox.id] = textbox.value;
    }
    var result = technalxs.simplemail.AutoComplete.REGEXP.exec(textbox.value);
    textbox.setAttribute("autocompletesearchparam", result[1]);
  },

  pub.onSearchComplete = function(textbox) {
    technalxs.simplemail.AutoComplete.values[textbox.id] = textbox.value;
  },

  pub.onTextEntered =  function(textbox) {
    var value = technalxs.simplemail.AutoComplete.values[textbox.id] || "";
    if (value != textbox.value) {
      textbox.value = value.replace(technalxs.simplemail.AutoComplete.REGEXP, technalxs.simplemail.SimpleMailNewMessage.expandGroups(textbox.value));
      textbox.setAttribute("autocompletesearchparam", "");
    }
    return false;
  }
  return pub;
}();