if(typeof(technalxs) == "undefined") {var technalxs = {};};
if(typeof(technalxs.simplemail) == "undefined" ) {technalxs.simplemail = {};};

technalxs.simplemail.SimpleMailOverlay = function(){
  var pub = {};

  pub.addonVersion = "2.86.8.1",//userok210
  pub.URL          = "chrome://simplemail/content/main/main.xul",
  pub.storage      = new technalxs.simplemail.SimpleMailStorageManager.SimpleMailStorage(),

  pub.getMainWindow = function(initialized) {
   var gBrowser = technalxs.simplemail.SimpleMailUtils.getBrowser();
    for(var i = 0; i < gBrowser.browsers.length; i++) {
      var browser = gBrowser.browsers[i];
      if (browser.currentURI.spec ==
                            technalxs.simplemail.SimpleMailOverlay.URL) {
        var wnd = browser.contentWindow.wrappedJSObject;
        if (!initialized || wnd.initialized) {
          return wnd;
        }
      }
    }
  },

  pub.initialize = function() {
    var addonVersion = technalxs.simplemail.SimpleMailOverlay.addonVersion;
    var smurl = "http://www.userlogos.org/extensions/simplemail/changelog";

    // add SM button for first run
    if (technalxs.simplemail.SimpleMailOverlay.storage.firstRun) {
      technalxs.simplemail.SimpleMailOverlay.installSimpleMailIcon("nav-bar", "SimpleMailButton");
    }

    // create welcome letter for first run and open userlogos when first run or update
    //console.error("SM.SimpleMailOverlay.initialize.setTimeout1", this);//userok210
    setTimeout(function() {
			//console.error("SM.SimpleMailOverlay.initialize.dosetTimeout", this);//userok210
      // First Run
      if (technalxs.simplemail.SimpleMailOverlay.storage.firstRun) {
				technalxs.simplemail.SimpleMailOverlay.createWelcomeLetter();
        technalxs.simplemail.SimpleMailOverlay.handleMailto();
        var gBrowser = technalxs.simplemail.SimpleMailUtils.getBrowser();
        gBrowser.selectedTab = gBrowser.addTab(smurl);
        technalxs.simplemail.SimpleMailPrefs.setString("version", addonVersion);
      } else { // is Update ?
        if (addonVersion !== technalxs.simplemail.SimpleMailPrefs.getString("version")) {
          var gBrowser = technalxs.simplemail.SimpleMailUtils.getBrowser();
          gBrowser.selectedTab = gBrowser.addTab(smurl);
          technalxs.simplemail.SimpleMailPrefs.setString("version", addonVersion);
        }
      }

      // check mail on start and create autocheck timers
      if (technalxs.simplemail.SimpleMailPrefs.getBool("checkOnStartup")) 
        technalxs.simplemail.SimpleMailOverlay.getMail();
      else {
        technalxs.simplemail.SimpleMailOverlay.lastCheckTime = new Date();
        var accounts = technalxs.simplemail.SimpleMailOverlay.storage.getAccounts();
        for (var i in accounts) {
          var account = accounts[i];
          if (account.refresh <= 0) continue;
          var listener = new technalxs.simplemail.SimpleMailOverlay.GetMailListener(account);
          if (account.refresh > 0) {
            //userok210
            technalxs.simplemail.SimpleMailOverlay.timeouts[account.id] = 
              setTimeout(function(accId) {
                //console.error("SM.SimpleMailOverlay.initialize.accId: ", accId);
                technalxs.simplemail.SimpleMailOverlay.getMail(accId);
              }, account.refresh * 60 * 1000, account.id);
          }
        }
        technalxs.simplemail.SimpleMailOverlay.updateIcons();
      }
    }, 500);//userok210
    //console.error("SM.SimpleMailOverlay.initialize.setTimeout2", this);//userok210

    technalxs.simplemail.SimpleMailDom.get("contentAreaContextMenu").addEventListener("popupshowing", technalxs.simplemail.SimpleMailOverlay.onContentMenuShowing, false);
  },

  pub.handleMailto = function() {
    // Make "mailto:" URLs handled by SM
    var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
    prefs.setBoolPref("network.protocol-handler.expose.mailto", true);
    prefs.setBoolPref("network.protocol-handler.external.mailto", false);
  },

  pub.createWelcomeLetter = function() {
    var text = "Content-Type: text/plain; charset=utf-8\r\n" + technalxs.simplemail.SimpleMailBundle.getString("welcomeMessage");
    var message = technalxs.simplemail.SimpleMailModel.SimpleMailMessage.parse(technalxs.simplemail.SimpleMailText.fromUnicode(text, "utf-8"));
    message.date = new Date();
    message.folderId = technalxs.simplemail.SimpleMailModel.SimpleMailFolder.INBOX;
    technalxs.simplemail.SimpleMailOverlay.addMessage(message);
  },
  
  pub.installSimpleMailIcon = function (toolbarId, buttonId) {
    if (!document.getElementById(buttonId)) {
      var toolbar = document.getElementById(toolbarId);
 
      toolbar.insertItem(buttonId, null, null, false);
      toolbar.setAttribute("currentset", toolbar.currentSet);
      document.persist(toolbar.id, "currentset");
    }
  },
  
  pub.isRunning = function() {
    return technalxs.simplemail.SimpleMailOverlay.instances.length;
  },

  pub.onClick = function(event) {
    if (event.button == 1) technalxs.simplemail.SimpleMailOverlay.getMail();
    else if (!event.button) {
      if (event.type == "dblclick") technalxs.simplemail.SimpleMailOverlay.stop();
      else technalxs.simplemail.SimpleMailOverlay.open(event);
    }
  },

  pub.stop = function() {
    for(var i = 0; i < technalxs.simplemail.SimpleMailOverlay.instances.length; i++) {
      technalxs.simplemail.SimpleMailOverlay.instances[i].stop();
    }
  },

  pub.open = function(event) {
    var mainWindow = technalxs.simplemail.SimpleMailOverlay.getMainWindow();
    if (mainWindow) {
      if (mainWindow.initialized)
                 mainWindow.technalxs.simplemail.SimpleMailManageFolder.displayInbox();
    }
    else {
      var where = technalxs.simplemail.SimpleMailUtils.whereToOpenLink(event);
      if (!where && !technalxs.simplemail.SimpleMailPrefs.getBool("openInCurrentTab")) where = "tab";
      if (where == "window")
               where = "tabshifted";
      technalxs.simplemail.SimpleMailUtils.openUILink(technalxs.simplemail.SimpleMailOverlay.URL, where);
    }
  },
  
  pub.prefsWindow = null,

  pub.openPreferences = function() {
      technalxs.simplemail.SimpleMailOverlay.prefsWindow = openDialog("chrome://simplemail/content/preferences/preferences.xul",
                                          "simplemail-preferences-window","chrome,centerscreen,modal,resizable");
  },

  pub.tmp = new Array(),
  pub.mailWindow = null,
  pub.mailTab = null,

  pub.openNewMessage = function(message, mailto) {
    var accounts = technalxs.simplemail.SimpleMailOverlay.storage.getAccounts();
    if (accounts.length == 0) return;

    if (mailto) message = technalxs.simplemail.SimpleMailModel.SimpleMailMessage.parseMailto(mailto);
    if (!message) message = new technalxs.simplemail.SimpleMailModel.SimpleMailMessage();

    var tmpId = technalxs.simplemail.SimpleMailUtils.getUniqueId();
    technalxs.simplemail.SimpleMailOverlay.tmp[tmpId] = message;

    var url = "chrome://simplemail/content/newmessage.xul";
    
    if (technalxs.simplemail.SimpleMailPrefs.getBool("messagesInWindow")) {
      technalxs.simplemail.SimpleMailPrefs.setString('tmpId', tmpId);
      technalxs.simplemail.SimpleMailPrefs.setObject('message', message);
      var gBrowser = technalxs.simplemail.SimpleMailUtils.getBrowser();
    }

    if (technalxs.simplemail.SimpleMailPrefs.getBool("newMessagesInWindow")) {
      technalxs.simplemail.SimpleMailOverlay.mailWindow = window.open(url, tmpId, "dependent,chrome=no,location=no,status=no,height=400,width=700,resizable");
      technalxs.simplemail.SimpleMailPrefs.setString('tmpId', tmpId);
      technalxs.simplemail.SimpleMailPrefs.setObject('message', message);
    }
    else {
      var gBrowser = technalxs.simplemail.SimpleMailUtils.getBrowser();
      content.location != "about:blank"
        ? gBrowser.selectedTab = gBrowser.addTab(url + "?" + tmpId)
        : content.location.assign(url + "?" + tmpId);
    }
  },

  pub.openedWindows = [],

  pub.refreshTab = function(url) { 
    var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]  
                        .getService(Components.interfaces.nsIWindowMediator);  
    var browserEnumerator = wm.getEnumerator("navigator:browser");  

    var found = false;  
    while (!found && browserEnumerator.hasMoreElements()) {  
      var browserWin = browserEnumerator.getNext();  
      var tabbrowser = browserWin.gBrowser;  

      var numTabs = tabbrowser.browsers.length;  
      for (var index = 0; index < numTabs; index++) {  
        var currentBrowser = tabbrowser.getBrowserAtIndex(index);  
        if (url == currentBrowser.currentURI.spec) {  
          tabbrowser.selectedTab = tabbrowser.tabContainer.childNodes[index];  
          browserWin.focus();

          if (technalxs.simplemail.SimpleMailOverlay.openedWindows.length > 0) {
            var openedWin = technalxs.simplemail.SimpleMailOverlay.openedWindows;
            tabbrowser.reload();
            technalxs.simplemail.SimpleMailOverlay.openedWindows = openedWin;
          } else {
            tabbrowser.reload();
          }

          found = true;  
          break;  
        }  
      }  
    }

    if (!found) {  
      var recentWindow = wm.getMostRecentWindow("navigator:browser");  
      if (recentWindow) {
        recentWindow.delayedOpenTab(url, null, null, null, null);  
      }  
      else {
        window.open(url); 
      }  
    }
  },

  pub.testTabUrl = function(url) { 
    var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                   .getService(Components.interfaces.nsIWindowMediator);
    var recentWindow = wm.getMostRecentWindow("navigator:browser");
    var actualWindow = recentWindow.getBrowser();

    if (actualWindow.currentURI.spec == url) return true;
  },

  pub.populateMenu = function(menupopup) {
    var accounts = technalxs.simplemail.SimpleMailOverlay.storage.getAccounts();
    if (!accounts.length) return false;

    technalxs.simplemail.SimpleMailUtils.clearElement(menupopup);

    for(var i in accounts) {
      var account = accounts[i];
      if (!account.pop3.host) continue;

      var menuitem = document.createElement("menuitem");
      menuitem.setAttribute("id", account.id);
      menuitem.setAttribute("label", account);
      menuitem.setAttribute("class", "menuitem-iconic");
      menuitem.setAttribute("image", technalxs.simplemail.SimpleMailFile.getEnvelopeIconURL(account.color));
      menuitem.addEventListener("click", technalxs.simplemail.SimpleMailOverlay.onMenuClick, false);//userok210
      menuitem.setAttribute("disabled", !technalxs.simplemail.SimpleMailOverlay.timeouts[account.id]);
      menupopup.appendChild(menuitem);
    }
  },

  pub.onMenuClick = function(event) {
    //console.error("SM.Overlay.onMenuClick", event, this);//userok210
    var accountId = event.target.id;
    switch(event.button) {
      case 0:
        technalxs.simplemail.SimpleMailOverlay.getMail(accountId);
        for (var element = event.target; element; element = element.parentNode) {
          if (element.nodeName == "menupopup") 
            element.hidePopup();
        }
        break;
      case 2:
        clearTimeout(technalxs.simplemail.SimpleMailOverlay.timeouts[accountId]);
        delete technalxs.simplemail.SimpleMailOverlay.timeouts[accountId];
        break;
    }
    event.target.setAttribute("disabled", !technalxs.simplemail.SimpleMailOverlay.timeouts[accountId]);
  },

  pub.onContentMenuShowing = function(event) {
    var accounts = technalxs.simplemail.SimpleMailOverlay.storage.getAccounts();
    if (event.target.id == "contentAreaContextMenu") {
      technalxs.simplemail.SimpleMailDom.get("SimpleMail-content-send-menu").hidden = !accounts.length;
    }
    else if (event.target.id == "SimpleMail-content-send-menu") {
      technalxs.simplemail.SimpleMailOverlay.populateFavoriteMenu(event.target);
    }
  },

  pub.populateFavoriteMenu = function(menupopup) {
    technalxs.simplemail.SimpleMailUtils.clearElement(menupopup);
    var favorites = technalxs.simplemail.SimpleMailOverlay.storage.getFavoriteAddresses();

    for(var i in favorites) {
      var menuitem = document.createElement("menuitem");
      menuitem.setAttribute("label", favorites[i].name || favorites[i]);
      var fav = favorites[i].toString();
      menuitem.addEventListener("command",
                                  function(fav) {
                                      return function() { technalxs.simplemail.SimpleMailOverlay.openSendContent(fav); }
                                  }(fav), false);
      menupopup.appendChild(menuitem);
    }
    if (favorites.length) {
      var menuseparator = document.createElement("menuseparator");
      menupopup.appendChild(menuseparator);
    }
    var menuitem = document.createElement("menuitem");
    menuitem.setAttribute("label", technalxs.simplemail.SimpleMailBundle.getString("new"));
    menuitem.addEventListener("command", function(){technalxs.simplemail.SimpleMailOverlay.openSendContent();}, false); 
    menupopup.appendChild(menuitem);
  },

  pub.openSendContent = function(address) {
    var message = new technalxs.simplemail.SimpleMailModel.SimpleMailMessage();
    message.to = address;
    message.html = technalxs.simplemail.SimpleMailOverlay.getContent(gContextMenu.target);
    if (technalxs.simplemail.SimpleMailPrefs.getBool("plaintextOnSend")) {
      message.html = technalxs.simplemail.SimpleMailText.linkToText(message.html);
    }
    technalxs.simplemail.SimpleMailOverlay.openNewMessage(message);
  },

  pub.getContent = function(element) {
    function link(url, title) {
      return technalxs.simplemail.SimpleMailFile.isLocalURL(url) ? ""
              : "<a href='" + url + "'>" + (title || url) + "</a>";
    }
    var doc = element.ownerDocument;
    var html = technalxs.simplemail.SimpleMailText.getSelectedHtml(doc);

    if (!html && element.value) { // INPUT & TEXTAREA
      var length = element.selectionEnd - element.selectionStart;
      html = element.value.substr(element.selectionStart, length);
    }
    if (!html && element.nodeName == "IMG") {
      html = "<img src='" + element.src + "'>";
    }
    if (html) {
      var link = link(doc.location, doc.title);
      if (link) html += "<br><br>" + technalxs.simplemail.SimpleMailBundle.getString("infoSource", [link]);
      return html;
    }
    else if (element.nodeName == "A") {
      return link(element.href, element.innerHTML);
    }
    else return link(doc.location, doc.title);
  },

  pub.errors = 0,
  pub.instances = new Array(), // Running GetMail, deleteMail, SendMail instances

  pub.error = function(messageId, params) {
    technalxs.simplemail.SimpleMailOverlay.errors++;
    technalxs.simplemail.SimpleMailUtils.error(messageId, params);
  },

  pub.getStatus = function() {
    return technalxs.simplemail.SimpleMailOverlay.instances.length ? "loading" :
           technalxs.simplemail.SimpleMailOverlay.errors ? "errors" :
           technalxs.simplemail.SimpleMailOverlay.storage.getUnreadCount() ? "mail" :
           technalxs.simplemail.SimpleMailOverlay.lastCheckTime
               ? "noMail" : "notChecked";
  },

  pub.updateIcons = function() {
    technalxs.simplemail.SimpleMailDom.get("SimpleMailStatusBar-unreadCount").value = technalxs.simplemail.SimpleMailOverlay.storage.getUnreadCount();

    var toolbarButton = technalxs.simplemail.SimpleMailDom.get("SimpleMail-toolbarbutton");
    if (toolbarButton) {
      technalxs.simplemail.SimpleMailDom.get("SimpleMailToolbar-unreadCount").value = technalxs.simplemail.SimpleMailOverlay.storage.getUnreadCount();
    }
    var status = technalxs.simplemail.SimpleMailOverlay.getStatus();

    technalxs.simplemail.SimpleMailDom.get("SimpleMail-status").hidden =
       ((status == "noMail" || status == "loading" || status == "notChecked" ) && technalxs.simplemail.SimpleMailPrefs.getBool("hideStatusNoMail"))
       || technalxs.simplemail.SimpleMailPrefs.getBool("hideAll");

    technalxs.simplemail.SimpleMailDom.get("SimpleMailStatusBar-unreadCount").hidden =
        ((status == "noMail" || status == "loading" || status == "notChecked" ) && technalxs.simplemail.SimpleMailPrefs.getBool("hideNoMail"))
        || technalxs.simplemail.SimpleMailPrefs.getBool("hideAll");

    if (toolbarButton) {
      technalxs.simplemail.SimpleMailDom.get("SimpleMailToolbar-unreadCount").hidden = 
        (status == "noMail" || status == "loading" || status == "notChecked" ) && technalxs.simplemail.SimpleMailPrefs.getBool("hideNoMail");
    }

    technalxs.simplemail.SimpleMailDom.get("SimpleMail-icon").setAttribute("SimpleMail-status", status);

    if (toolbarButton) {
      toolbarButton.setAttribute("SimpleMail-status", status);
      technalxs.simplemail.SimpleMailDom.get("SimpleMailToolbar-unreadCount").setAttribute("SimpleMail-status", status);
      technalxs.simplemail.SimpleMailDom.get("SimpleMailStatusBar-unreadCount").setAttribute("SimpleMail-status", status);
    }

    var mainWindow = technalxs.simplemail.SimpleMailOverlay.getMainWindow(true);

    if (mainWindow) mainWindow.updateFavIcon();
    if (!technalxs.simplemail.SimpleMailOverlay.instances.length)
                        technalxs.simplemail.SimpleMailOverlay.errors = 0;
  },

  pub.updateTooltip = function() {
    var status = technalxs.simplemail.SimpleMailDom.get("SimpleMail-icon").getAttribute("SimpleMail-status");
    var timePassed = technalxs.simplemail.SimpleMailDate.
        timePassed(technalxs.simplemail.SimpleMailOverlay.lastCheckTime);
	
	tooltip = technalxs.simplemail.SimpleMailBundle.getString(status) + (timePassed ? " (" + timePassed + ")" : "");
    technalxs.simplemail.SimpleMailDom.get("SimpleMail-tooltip").label = tooltip

	var toolbarButton = technalxs.simplemail.SimpleMailDom.get("SimpleMail-toolbarbutton");
    if (toolbarButton) 
		toolbarButton.setAttribute("tooltiptext", tooltip);
  },

  pub.lastCheckTime = null,
  pub.timeouts = new Array(), // Holds timeouts for each account
  
  pub.InstanceListener = function() {
    var self = this;
    this._instance;

    this.__defineSetter__("instance", function(instance) {
      self._instance = instance;
      technalxs.simplemail.SimpleMailOverlay.instances.push(instance);
    });

    this.cleanUp = function() {
      for(var i = 0; i < technalxs.simplemail.SimpleMailOverlay.instances.length; i++) {
        if (technalxs.simplemail.SimpleMailOverlay.instances[i] == self._instance) {
          technalxs.simplemail.SimpleMailOverlay.instances.splice(i, 1);
        }
      }
      technalxs.simplemail.SimpleMailOverlay.updateIcons();
    }
    this.onFinish = function(error) {
      technalxs.simplemail.SimpleMailOverlay.errors |= error;
      self.cleanUp();
    }
  },

  // Add to database
  pub.addMessage = function(message) {
    technalxs.simplemail.SimpleMailOverlay.storage.saveMessage(message);
    var mainWindow = technalxs.simplemail.SimpleMailOverlay.getMainWindow(true);
    if (mainWindow){
      mainWindow.technalxs.simplemail.messageTreeView.onMessageAdded(message);
    } else {
      technalxs.simplemail.SimpleMailOverlay.updateIcons();
    }
  },

  pub.newMessagesCount = 0,
  pub.finish = null,

  pub.GetMailListener = function(account) {
    var self = this;
    this.inheritFrom = technalxs.simplemail.SimpleMailOverlay.InstanceListener;
    this.inheritFrom();
          
    this.existOnServer = new Array();

    this.messageExists = function(accountId, uid) {
      self.existOnServer[uid] = uid;
      return technalxs.simplemail.SimpleMailOverlay.storage.messageExists(accountId, uid);
    }

    this.onMessage = function(message, mailInterface) {
      message.folderId = technalxs.simplemail.SimpleMailModel.SimpleMailFolder.INBOX;
      var filterManager = new technalxs.simplemail.SimpleMailModel.SimpleMailFilterManager(technalxs.simplemail.SimpleMailOverlay.storage, mailInterface);
      
      message = filterManager.execute(message, technalxs.simplemail.SimpleMailModel.SimpleMailFilter.INBOX);
      
      if (message) {
        if (message.folderId != technalxs.simplemail.SimpleMailModel.SimpleMailFolder.TRASH) {
          technalxs.simplemail.SimpleMailOverlay.newMessagesCount++;

          if (technalxs.simplemail.SimpleMailPrefs.getString("popupNotification") == "onEveryMessage") {
            popup(message.subject, message.from, message.spam);
          }
        }
        technalxs.simplemail.SimpleMailOverlay.addMessage(message);
  
        if(technalxs.simplemail.SimpleMailPrefs.getBool("mailSound")){
          var param = technalxs.simplemail.SimpleMailPrefs.getString("mailSoundPath");
          technalxs.simplemail.SimpleMailSound.play(param);
        }
        
        if (technalxs.simplemail.SimpleMailPrefs.getString('forwardParam') !== null){ 
        var filters = technalxs.simplemail.SimpleMailOverlay.storage.getFilters();      
          for(var i = 0; message && i < filters.length; i++){ 
            var filter = filters[i];
            for (var j in filter.rules){
              if (filter.rules[j].param) {
                for(var k in filter.actions) {
                  var action = filter.actions[k];
                  if (!message.fwd && message.uid && !message.partial && action.name == "forward"){
                    technalxs.simplemail.messageTreeView.autoForward(message);
                  }
                }
              }
            }     
          }
        }
      }
    }

    function synchronizeIMAP() {
      var messages = technalxs.simplemail.SimpleMailOverlay.storage.getAccountMessages(account.id);
      var deleted = new Array();
      for (var i in messages) {
        var message = messages[i];
        if (message.uid && !self.existOnServer[message.uid]) {
          message.uid = "";
          deleted.push(message);
        }
      }
      technalxs.simplemail.SimpleMailOverlay.deleteMessages(deleted);
    }

    function popup(text, title, messageType) {
      if (messageType){
        messageType = "Spam";
        title = "SPAM - " + title;
      }
      technalxs.simplemail.SimpleMailPopup.open("chrome://simplemail/skin/status/mail_large.png", title, text, technalxs.simplemail.SimpleMailOverlay.open, messageType);
    }

    this.onFinish = function(error) {
      if (!error && account.pop3.isImap) {
        synchronizeIMAP();
      }

      technalxs.simplemail.SimpleMailOverlay.errors |= error;
      self.cleanUp();

      for(var i = 0; i < technalxs.simplemail.SimpleMailOverlay.instances.length; i++) {
        if (technalxs.simplemail.SimpleMailOverlay.instances[i] instanceof technalxs.simplemail.SimpleMailSocks.SimpleMailGetMail){
        technalxs.simplemail.SimpleMailOverlay.finish = account;
        return;
        }
      }
      if (technalxs.simplemail.SimpleMailOverlay.newMessagesCount &&
          technalxs.simplemail.SimpleMailPrefs.getString("popupNotification") == "summary")
      {
        var text = technalxs.simplemail.SimpleMailBundle.getString("newMessages", [technalxs.simplemail.SimpleMailOverlay.newMessagesCount]);
        popup(text, "Simple Mail");
      }
      technalxs.simplemail.SimpleMailOverlay.newMessagesCount = 0;
    }
    technalxs.simplemail.SimpleMailPrefs.clear('forwardParam'); // Clean up temporary prefs
  },

  pub.getMail = function(accountId) {
    technalxs.simplemail.SimpleMailOverlay.lastCheckTime = new Date();
    var accounts = technalxs.simplemail.SimpleMailOverlay.storage.getAccounts();

    for(var i = 0, j = accounts.length; i < j; i++) {
      var account = accounts[i];
        if (!account.pop3.host || (accountId && account.id != accountId)) continue;
        if(!accountId && account.refresh < 0) continue;

        technalxs.simplemail.SimpleMailCheck.open(account);

        clearTimeout(technalxs.simplemail.SimpleMailOverlay.timeouts[account.id]);
        if (account.refresh > 0) {
          //userok210
          technalxs.simplemail.SimpleMailOverlay.timeouts[account.id] = 
            setTimeout(function(accId) {
              //console.error("SM.getMail.accId: ", accId);//userok210
              technalxs.simplemail.SimpleMailOverlay.getMail(accId);
            }, account.refresh * 60 * 1000, account.id);
        }
        
      if (account.pop3.isImap) {
        var messages = technalxs.simplemail.SimpleMailOverlay.storage.getAccountMessages(account.id);
        var flag = "";
        var folder = "inbox";
        technalxs.simplemail.SimpleMailOverlay.SynchroMail(account, messages, folder, flag);
      }
      technalxs.simplemail.SimpleMailOverlay.updateIcons();
    }
  },

  pub.groupByAccounts = function(messages) {
    var grouped = new Array();
    for(var i in messages) {
      var message = messages[i];
      if (!grouped[message.accountId]) {
        grouped[message.accountId] = new Array();
      }
      grouped[message.accountId][message.id] = message;
    }
    return grouped;
  },

  // Delete from database
  pub.deleteMessages = function(messages) {
    for(var i in messages) {
      technalxs.simplemail.SimpleMailOverlay.storage.deleteMessage(messages[i]);
    }
    var mainWindow = technalxs.simplemail.SimpleMailOverlay.getMainWindow(true);
    if (mainWindow) {
      mainWindow.technalxs.simplemail.messageTreeView.onMessagesDeleted(messages);
    } else {
      technalxs.simplemail.SimpleMailOverlay.updateIcons();
    }
  },

  pub.askDeleteMail = function(messages, confirmText, wnd, onDelete) {
    function confirmDelete(confirmText, server) {
      if (technalxs.simplemail.SimpleMailPrefs.getBool("confirmdelete")) {
        var check = { value: technalxs.simplemail.SimpleMailPrefs.getBool("deleteFromServer") };
        var result = !server ? technalxs.simplemail.SimpleMailUtils.confirm(confirmText, wnd)
                             : technalxs.simplemail.SimpleMailUtils.confirmCheck(confirmText,
                                                    technalxs.simplemail.SimpleMailBundle.getString("deleteFromServer"),
                                                    check, wnd);
        if (result) technalxs.simplemail.SimpleMailPrefs.setBool("deleteFromServer", check.value);
          return { delete: result, server: check.value };
        }
        else {
          return { delete: true, server: true };
        }
    }  
    var grouped = new Array();

    for(var i in messages) {
      var message = messages[i];
      var deleteMode = technalxs.simplemail.SimpleMailModel.SimpleMailAccount.NEVER;
      if (message.uid) {
        var account = technalxs.simplemail.SimpleMailOverlay.storage.getAccount(message.accountId);
        if (account) deleteMode = account.deleteMode;
      }
      if (deleteMode == technalxs.simplemail.SimpleMailModel.SimpleMailAccount.ON_RECEIVE) {
        deleteMode = message.partial ? technalxs.simplemail.SimpleMailModel.SimpleMailAccount.ASK : technalxs.simplemail.SimpleMailModel.SimpleMailAccount.NEVER;
      }
      if (!grouped[deleteMode]) grouped[deleteMode] = new Array();
      grouped[deleteMode].push(message);
    }

    var confirm = confirmDelete(confirmText, grouped[technalxs.simplemail.SimpleMailModel.SimpleMailAccount.ASK]);
    if (!confirm.delete) return;

    var deleteMode = confirm.server ? technalxs.simplemail.SimpleMailModel.SimpleMailAccount.ALWAYS : technalxs.simplemail.SimpleMailModel.SimpleMailAccount.NEVER;
    grouped[deleteMode] = (grouped[deleteMode] || []).concat(
                                    grouped[technalxs.simplemail.SimpleMailModel.SimpleMailAccount.ASK] || []);

    technalxs.simplemail.SimpleMailOverlay.deleteMessages(grouped[technalxs.simplemail.SimpleMailModel.SimpleMailAccount.NEVER]);
    technalxs.simplemail.SimpleMailOverlay.deleteMail(grouped[technalxs.simplemail.SimpleMailModel.SimpleMailAccount.ALWAYS], onDelete);
  },

  pub.DeleteMailListener = function(onDelete) {
    var self = this;
    this.inheritFrom = technalxs.simplemail.SimpleMailOverlay.InstanceListener;
    this.inheritFrom();

    this.onFinish = function(error, deleted) {
      technalxs.simplemail.SimpleMailOverlay.deleteMessages(deleted);
      if (onDelete) onDelete();

      technalxs.simplemail.SimpleMailOverlay.errors |= error;
      self.cleanUp();
    }
  },

  pub.deleteMail = function(messages, onDelete) {
    if (!messages || !messages.length) {
      if (onDelete) onDelete();
      return;
    }
    messages = technalxs.simplemail.SimpleMailOverlay.groupByAccounts(messages);
    for(var accountId in messages) {
      var account = technalxs.simplemail.SimpleMailOverlay.storage.getAccount(accountId);
      if (!account) technalxs.simplemail.SimpleMailOverlay.error("accountNoLongerExist");
      else {
        var listener = new technalxs.simplemail.SimpleMailOverlay.DeleteMailListener(onDelete);
        listener.instance = new technalxs.simplemail.SimpleMailSocks.SimpleMailDeleteMail(account, listener, messages[accountId]).execute();
      }
    }
    technalxs.simplemail.SimpleMailOverlay.updateIcons();
  },

  pub.SendMailListener = function(message, onSend) {
    var self = this;
    this.inheritFrom = technalxs.simplemail.SimpleMailOverlay.InstanceListener;
    this.inheritFrom();

    this.onFinish = function(error) {
      if (!error) {
        message.folderId = technalxs.simplemail.SimpleMailModel.SimpleMailFolder.SENT;
        message.read = true;
        var account = technalxs.simplemail.SimpleMailOverlay.storage.getAccount(message.accountId);

        var filterManager = new technalxs.simplemail.SimpleMailModel.SimpleMailFilterManager(technalxs.simplemail.SimpleMailOverlay.storage, {
          getBody: function(msg) {},
          delete: function(msg) {
            technalxs.simplemail.SimpleMailOverlay.deleteMessages([msg]);
          }
        });

        if (account.pop3.isImap) {
          var folder = "sent";
          var messages = new Array();
          messages.push(message);
          var flag = "";
          technalxs.simplemail.SimpleMailOverlay.SynchroMail(account, messages, folder, flag);
        }

        if (technalxs.simplemail.SimpleMailPrefs.getBool("addressBookAddOnSend")) {
          var recipients = message.to + "," + message.cc + "," + message.bcc;
          technalxs.simplemail.SimpleMailOverlay.storage.addAddressList(recipients);
        }
        
        if (message && technalxs.simplemail.SimpleMailPrefs.getString('forwardParam')) {
          message = filterManager.execute(message, technalxs.simplemail.SimpleMailModel.SimpleMailFilter.SENT);
          technalxs.simplemail.SimpleMailOverlay.storage.saveMessage(message);
        }
        
        if (message && technalxs.simplemail.SimpleMailPrefs.getString('forwardParam') == null) {
          message = filterManager.execute(message, technalxs.simplemail.SimpleMailModel.SimpleMailFilter.SENT); 
          message.to = technalxs.simplemail.SimpleMailPrefs.getString('originalTo');
          message.cc = technalxs.simplemail.SimpleMailPrefs.getString('originalCc');
          message.bcc = technalxs.simplemail.SimpleMailPrefs.getString('originalBcc');
          technalxs.simplemail.SimpleMailOverlay.addMessage(message);
                         
          if (message.subject.match(/^(Re:)/i)){
            var originalId = technalxs.simplemail.SimpleMailPrefs.getString('originalId');
            var messageOri = technalxs.simplemail.SimpleMailOverlay.storage.getMessage(originalId);
            if (typeof(messageOri) == 'undefined'){
              var messageOri = message;
            }
            messageOri.replied = true;
            technalxs.simplemail.SimpleMailOverlay.storage.saveMessageState(messageOri);
            if (messageOri.replied) {
              var flag = "Answered";
              var account = technalxs.simplemail.SimpleMailOverlay.storage.getAccount(messageOri.accountId);
              var messages = new Array();
              messages.push(messageOri);
              technalxs.simplemail.SimpleMailOverlay.SynchroMail(account, messages, folder, flag);
              flag = "";
            }
          }
          if (message.subject.match(/^(Fwd:)/i)){
            var originalId = technalxs.simplemail.SimpleMailPrefs.getString('originalId');
            var messageOri = technalxs.simplemail.SimpleMailOverlay.storage.getMessage(originalId);
            if (typeof(messageOri) == 'undefined'){
              var messageOri = message;
            }
            messageOri.fwd = true;
            technalxs.simplemail.SimpleMailOverlay.storage.saveMessageState(messageOri);
          }
          technalxs.simplemail.SimpleMailPrefs.clear('forwardParam'); // Clean up temporary prefs
        }

        if (onSend) {
          onSend();
          var textsent = message.subject + " - " + technalxs.simplemail.SimpleMailBundle.getString("messagesent");
          var account = technalxs.simplemail.SimpleMailOverlay.storage.getAccount(message.accountId);
          technalxs.simplemail.SimpleMailPopup.open("chrome://simplemail/skin/status/mail_large.png", "Simple Mail - " + account, textsent);
        }
      }

      technalxs.simplemail.SimpleMailOverlay.errors |= error;
      self.cleanUp();

      technalxs.simplemail.SimpleMailPrefs.clear('originalId');
      technalxs.simplemail.SimpleMailPrefs.clear('originalTo');
      technalxs.simplemail.SimpleMailPrefs.clear('originalCc');
      technalxs.simplemail.SimpleMailPrefs.clear('originalBcc');
    }
  },
  
  pub.autosendMail = function(message, onSend) { 
    var account = technalxs.simplemail.SimpleMailOverlay.storage.getAccount(message.accountId);
    if (!account) technalxs.simplemail.SimpleMailOverlay.error("accountNoLongerExist");
    else {
      var listener = new technalxs.simplemail.SimpleMailOverlay.SendMailListener(message, onSend);
      listener.instance = new technalxs.simplemail.SimpleMailSocks.SimpleMailSendMail(account, listener, message).execute();
    }
    technalxs.simplemail.SimpleMailOverlay.updateIcons();
  },
      
  pub.sendMail = function(message, onSend) {
    var account = technalxs.simplemail.SimpleMailOverlay.storage.getAccount(message.accountId);
    technalxs.simplemail.SimpleMailPrefs.setString('accountError', account.name);
    if (!account) technalxs.simplemail.SimpleMailOverlay.error("accountNoLongerExist");
    else {
      var listener = new technalxs.simplemail.SimpleMailOverlay.SendMailListener(message, onSend);
      listener.instance = new technalxs.simplemail.SimpleMailSocks.SimpleMailSendMail(account, listener, message).execute();
      
      var gBrowser = technalxs.simplemail.SimpleMailUtils.getBrowser();
      for(var i = 0; i < gBrowser.browsers.length; i++) {
        var browser = gBrowser.browsers[i];
        var uri = browser.currentURI.spec.replace (/(\?).*?/ig, "");
        var uri = uri.replace(/([0-9]).*?/ig, "");
        if (uri == "chrome://simplemail/content/newmessage.xul") {
          technalxs.simplemail.SimpleMailOverlay.mailTab = browser.contentWindow.wrappedJSObject;
        }
      }
      
      function cancelSend () {
        var win = technalxs.simplemail.SimpleMailOverlay.mailTab;
        if (typeof(win) == 'undefined') {
          var win = technalxs.simplemail.SimpleMailOverlay.mailWindow;
        }
        if (win == null) {
          var win = browser.contentWindow.wrappedJSObject;
        }
        win.document.getElementById("cancelsend").value = "cancelsend";
      }

      function setProgress(counter) {
        var win = technalxs.simplemail.SimpleMailOverlay.mailTab;
        if (typeof(win) == 'undefined') {
          var win = technalxs.simplemail.SimpleMailOverlay.mailWindow;
        }
        if (win == null) {
          var win = browser.contentWindow.wrappedJSObject;
        }
        var progressMeter = win.document.getElementById("progressMeter");
        progressMeter.value = counter;
      }
      
      function endSend() {
        var win = technalxs.simplemail.SimpleMailOverlay.mailTab;
        if (typeof(win) == 'undefined') {
          var win = technalxs.simplemail.SimpleMailOverlay.mailWindow;
        }
        if (win == null) {
          var win = browser.contentWindow.wrappedJSObject;
        }
        clearTimeout(timeoutID);
        if (win !== null) {
          win.document.getElementById("cancelsend").value = "";
          win.document.getElementById("cancelsend").hidden=true;
          win.document.getElementById("cancelsend").removeEventListener ('click', cancelSend, false);
          win.document.getElementById("progressMeter").collapsed=true;
          win.document.getElementById("progressMeterText").value = "";
          win.document.getElementById("progressMeterText").hidden=true;
        }
      }

      function timeout(counter) {
        var win = technalxs.simplemail.SimpleMailOverlay.mailTab;
        var stat = technalxs.simplemail.SimpleMailOverlay.getStatus();
        var buttoncancelsend = win.document.getElementById("cancelsend");
        buttoncancelsend.addEventListener ('click', cancelSend, false);
          
        if (stat !== "loading" || buttoncancelsend.value == "cancelsend") {
          if (buttoncancelsend.value == "cancelsend") {
            technalxs.simplemail.SimpleMailOverlay.stop();
            endSend();
          }
          else{
            endSend();
          }
        }
        else {
          counter = counter+5;
          if (counter == 100) {
            counter = 0;
          }
            setProgress(counter);
            var timeoutID = setTimeout(function(){timeout(counter);}, 100);
          }
        }

        var counter = 10;
        setProgress(counter);
        var timeoutID = setTimeout(function(){timeout(counter);}, 100);

        var win = technalxs.simplemail.SimpleMailOverlay.mailTab;
        if (typeof(win) == 'undefined') {
          var win = technalxs.simplemail.SimpleMailOverlay.mailWindow;
        }

        win.document.getElementById("cancelsend").hidden=false;
        win.document.getElementById("progressMeter").collapsed=false;
        win.document.getElementById("progressMeterText").hidden=false;
        win.document.getElementById("progressMeterText").value=account.name;
      }
      technalxs.simplemail.SimpleMailOverlay.updateIcons();
    },

  pub.GetMailBodyListener = function(messages) {
    var self = this;
    this.inheritFrom = technalxs.simplemail.SimpleMailOverlay.InstanceListener;
    this.inheritFrom();

    this.onMessage = function(message) {
      var old = messages[message.id];
      technalxs.simplemail.SimpleMailFile.deleteAttachments(old.attachmentsDir);
      message = technalxs.simplemail.SimpleMailUtils.merge(old, message);

      technalxs.simplemail.SimpleMailOverlay.storage.saveMessage(message);
      var mainWindow = technalxs.simplemail.SimpleMailOverlay.getMainWindow(true);
      if (mainWindow) mainWindow.technalxs.simplemail.messageTreeView.onMessageUpdated(message);
    }
  },

  pub.getMailBody = function(messages) {
    messages = technalxs.simplemail.SimpleMailOverlay.groupByAccounts(messages);
    for(var accountId in messages) {
      var account = technalxs.simplemail.SimpleMailOverlay.storage.getAccount(accountId);
      if (!account) technalxs.simplemail.SimpleMailOverlay.error("accountNoLongerExist");
      else {
        var listener = new technalxs.simplemail.SimpleMailOverlay.GetMailBodyListener(messages[accountId]);
        listener.instance = new technalxs.simplemail.SimpleMailSocks.SimpleMailGetMailBody(account, listener, messages[accountId]).execute();
      }
    }
    technalxs.simplemail.SimpleMailOverlay.updateIcons();
  },

  pub.SynchroMailListener = function(account, messages, folder, flag) {
    var self = this;
    this.inheritFrom = technalxs.simplemail.SimpleMailOverlay.InstanceListener;
    this.inheritFrom();

    this.existOnServer = new Array();

    this.messageExists = function(accountId, uid) {
      self.existOnServer[uid] = uid;
      return technalxs.simplemail.SimpleMailOverlay.storage.messageExists(accountId, uid);
    }
    this.onMessage = function(message) {
    }
    this.onFinish = function(error) {
      technalxs.simplemail.SimpleMailOverlay.errors |= error;
      self.cleanUp();
    }
  },

  pub.SynchroMail = function(account, messages, folder, flag) {
    if (typeof(account) !== 'undefined') {
      if (account.pop3.isImap) {
        var listener = new technalxs.simplemail.SimpleMailOverlay.SynchroMailListener(account, messages, folder, flag);
        listener.instance = new technalxs.simplemail.SimpleMailSocks.SimpleMailSynchroMail(account, listener, messages, folder, flag).execute();
      }
      technalxs.simplemail.SimpleMailOverlay.updateIcons();
    }
  }
  return pub;
}();

addEventListener("load", technalxs.simplemail.SimpleMailOverlay.initialize, false);

if(!technalxs) var technalxs = {};
if(!technalxs.simplemail) technalxs.simplemail = {}; 

technalxs.simplemail.SimpleMailCheck = function (){
  var pub = {};
  
  pub.queue = [],
  pub.inProgress = false,
  pub.timeoutID = [],

  pub.setProgress = function(counter) {
   var win = technalxs.simplemail.SimpleMailOverlay.getMainWindow();
   var progressMeter = win.document.getElementById("progressMeter");
   progressMeter.value = counter;
  }, 

  pub.cancelCheck = function(event) {
    var win = technalxs.simplemail.SimpleMailOverlay.getMainWindow();
    win.document.getElementById("cancelcheck").value = "cancelcheck";
  },

  pub.open = function(accountItem) {
      technalxs.simplemail.SimpleMailCheck.queue.push({
      accountItem: accountItem
    });
    technalxs.simplemail.SimpleMailCheck.showNext();
  },

  pub.showNext = function() {
    if (technalxs.simplemail.SimpleMailCheck.inProgress) return;
    
    var item = technalxs.simplemail.SimpleMailCheck.queue.shift();
    if (!item) return;

    technalxs.simplemail.SimpleMailPrefs.setString('accountError', item.accountItem);

    var listener = new technalxs.simplemail.SimpleMailOverlay.GetMailListener(item.accountItem);
    listener.instance = new technalxs.simplemail.SimpleMailSocks.SimpleMailGetMail(item.accountItem, listener, technalxs.simplemail.SimpleMailPrefs.getBool("headersOnly")).execute();
    
    technalxs.simplemail.SimpleMailCheck.inProgress = true;

    var actualWindow = technalxs.simplemail.SimpleMailOverlay.testTabUrl("chrome://simplemail/content/main/main.xul");
    if (actualWindow) {
      var win = technalxs.simplemail.SimpleMailOverlay.getMainWindow();
      win.document.getElementById("progressMeter").collapsed=false; 
      win.document.getElementById("cancelcheck").hidden=false;
      win.document.getElementById("progressMeterText").hidden=false;
      win.document.getElementById("progressMeterText").value = item.accountItem;
      var counter = 10;
    }
    technalxs.simplemail.SimpleMailOverlay.updateIcons();
    technalxs.simplemail.SimpleMailCheck.show(item, counter);
  },

  pub.show = function(item, counter) {
    var stat = technalxs.simplemail.SimpleMailOverlay.getStatus();  
    var actualWindow = technalxs.simplemail.SimpleMailOverlay.testTabUrl("chrome://simplemail/content/main/main.xul");
    
    if (actualWindow) {
      var win = technalxs.simplemail.SimpleMailOverlay.getMainWindow();
      win.document.getElementById("cancelcheck").addEventListener ('click', technalxs.simplemail.SimpleMailCheck.cancelCheck, false);
      technalxs.simplemail.SimpleMailCheck.setProgress(counter);
  
      win.document.getElementById("progressMeterText").value = item.accountItem;

                   
      if (win.document.getElementById("cancelcheck").value == "cancelcheck") {
        technalxs.simplemail.SimpleMailOverlay.stop();
          setTimeout(function(){endCheck();}, 10);
      }
    }
    
    if (stat !== "loading") {
      setTimeout(function(){endCheck();}, 10);
    }

    if (technalxs.simplemail.SimpleMailOverlay.finish == item.accountItem) {
      technalxs.simplemail.SimpleMailCheck.inProgress = false;
      technalxs.simplemail.SimpleMailCheck.showNext();
    }

    counter = counter+5;
    if (counter == 105) {
      counter = 0;
    }

    technalxs.simplemail.SimpleMailCheck.timeoutID[item] = setTimeout(function(){technalxs.simplemail.SimpleMailCheck.show(item,counter);}, 100);

    function endCheck() {
      clearTimeout(technalxs.simplemail.SimpleMailCheck.timeoutID[item]);
      if (actualWindow) {
        win.document.getElementById("cancelcheck").value = "";
        win.document.getElementById("cancelcheck").hidden=true;
        win.document.getElementById("progressMeter").collapsed=true;
        win.document.getElementById("progressMeterText").value = "";
        win.document.getElementById("progressMeterText").hidden = true;
        win.document.getElementById("cancelcheck").removeEventListener ('click', technalxs.simplemail.SimpleMailCheck.cancelCheck, false); 
      }
      
      technalxs.simplemail.SimpleMailCheck.inProgress = false;
      technalxs.simplemail.SimpleMailPrefs.clear('accountError');
      technalxs.simplemail.SimpleMailCheck.showNext();
    }
  }
  return pub;
}();