// Pre-load due to asynchronous callback in AddonManager
var dirLocation = technalxs.simplemail.SimpleMailFile.getExtensionDirectory();
var account = window.arguments[0].inn.account;

function initialize() {
  document.title = account.id ? technalxs.simplemail.SimpleMailBundle.getString("editAccount", [account])
                              : technalxs.simplemail.SimpleMailBundle.getString("newAccount");

  getValues(account);
}

//userok210 function checkValues(txtBox, evt){
function checkValues(txtBox){
	var accountEmail = account.email;
	if(accountEmail) {
		accountEmail = accountEmail.toLowerCase();
	}
	technalxs.simplemail.SimpleMailOverlay = technalxs.simplemail.SimpleMailUtils.getBrowserWindow().technalxs.simplemail.SimpleMailOverlay;
	var accounts = technalxs.simplemail.SimpleMailOverlay.storage.getAccounts();
	document.getElementById('email').value = txtBox.value;
	for(var i in accounts) {
		if (accounts[i].email.toLowerCase() == txtBox.value.toLowerCase() && txtBox.value.toLowerCase() !== accountEmail){
			var confirmText = technalxs.simplemail.SimpleMailBundle.getString("accountAlert");
			technalxs.simplemail.SimpleMailUtils.alert(confirmText);
			setTimeout (function () {
				document.getElementById('email').focus();
			}, 0);
			account.email = accountEmail;
			txtBox.value = accountEmail;
			//userok210       evt.preventDefault();
			//userok210       document.documentElement.getButton("accept").addEventListener("click", event.preventDefault(), false);
			//userok210
			return false;
		}
	}

	if (!txtBox.value.toLowerCase().match(/^[a-z0-9._%+-]+@(?:[a-z0-9-])/gim)) {
		var confirmText = technalxs.simplemail.SimpleMailBundle.getString("addressAlert");
		technalxs.simplemail.SimpleMailUtils.alert(confirmText);
		setTimeout (function () {
			document.getElementById('email').focus();
		}, 0);
		if (accountEmail) {
			account.email = accountEmail;
			txtBox.value = accountEmail;
		} else {
			account.email = null;
			txtBox.value = "someone@somewhere.com";
		}
		//userok210     evt.preventDefault();
		//userok210     document.documentElement.getButton("accept").addEventListener("click", event.preventDefault(), false);
		//userok210
		return false;
	}
	//userok210
	return true;
}

function getValues(account){
  technalxs.simplemail.SimpleMailDom.get("name").value = account.name;
  technalxs.simplemail.SimpleMailDom.get("email").value = account.email;
  technalxs.simplemail.SimpleMailDom.get("replyTo").value = account.replyTo;
  technalxs.simplemail.SimpleMailDom.get("refresh").value = account.refresh;
  technalxs.simplemail.SimpleMailUtils.selectItem("deleteMode", account.deleteMode);
  technalxs.simplemail.SimpleMailDom.get("subject").value = account.subject;
  technalxs.simplemail.SimpleMailDom.get("signature").value = account.signature;

  technalxs.simplemail.SimpleMailDom.get("isImap").selectedIndex = account.pop3.isImap || 0;
  technalxs.simplemail.SimpleMailDom.get("pop3auth").selectedIndex = account.pop3.auth || 0;
  technalxs.simplemail.SimpleMailDom.get("pop3host").value = account.pop3.host;
  technalxs.simplemail.SimpleMailDom.get("pop3port").value = account.pop3.port;
  technalxs.simplemail.SimpleMailDom.get("pop3ssl").checked = account.pop3.ssl;
  technalxs.simplemail.SimpleMailDom.get("pop3login").value = account.pop3.login;
  technalxs.simplemail.SimpleMailDom.get("pop3password").value = account.pop3.getPassword();

  technalxs.simplemail.SimpleMailDom.get("onreceive").disabled = technalxs.simplemail.SimpleMailDom.get("isImap").selectedIndex ? true : false;

  technalxs.simplemail.SimpleMailDom.get("smtpHost").value = account.smtp.host;
  technalxs.simplemail.SimpleMailDom.get("smtpPort").value = account.smtp.port;
  technalxs.simplemail.SimpleMailDom.get("smtpSsl").checked = account.smtp.ssl;
  technalxs.simplemail.SimpleMailDom.get("smtpTls").checked = account.smtp.tls;  
  technalxs.simplemail.SimpleMailDom.get("smtpLogin").value = account.smtp.login;
  technalxs.simplemail.SimpleMailDom.get("smtpPassword").value = account.smtp.getPassword();
  technalxs.simplemail.SimpleMailDom.get("smtpAuth").checked = account.smtp.auth;

  technalxs.simplemail.SimpleMailDom.get("email").addEventListener("change", function(event) {
    var address = technalxs.simplemail.SimpleMailModel.SimpleMailAddress.parse(event.target.value);
    technalxs.simplemail.SimpleMailDom.get("pop3host").value = "pop." + address.getHost();
    technalxs.simplemail.SimpleMailDom.get("smtpHost").value = "smtp." + address.getHost();
    technalxs.simplemail.SimpleMailDom.get("pop3login").value = address.getLogin()+ "@" + address.getHost();
    technalxs.simplemail.SimpleMailDom.get("smtpLogin").value = address.getLogin()+ "@" + address.getHost();

    // Presets for specific hosts
    switch(address.getHost()) {
      case "gmail.com":
          technalxs.simplemail.SimpleMailDom.get("isImap").selectedIndex = 1;
          technalxs.simplemail.SimpleMailDom.get("pop3host").value = "imap.gmail.com";
          technalxs.simplemail.SimpleMailDom.get("pop3ssl").checked = true;
          technalxs.simplemail.SimpleMailDom.get("smtpSsl").checked = true;
          technalxs.simplemail.SimpleMailDom.get("smtpTls").checked = false;
          technalxs.simplemail.SimpleMailDom.get("pop3port").value = 993;
          technalxs.simplemail.SimpleMailDom.get("smtpPort").value = 465;
          break;
      case "gmx.com":
          technalxs.simplemail.SimpleMailDom.get("isImap").selectedIndex = 1;
          technalxs.simplemail.SimpleMailDom.get("pop3host").value = "imap.gmx.com";
          technalxs.simplemail.SimpleMailDom.get("smtpHost").value = "mail.gmx.com";
          technalxs.simplemail.SimpleMailDom.get("pop3ssl").checked = true;
          technalxs.simplemail.SimpleMailDom.get("smtpSsl").checked = true;
          technalxs.simplemail.SimpleMailDom.get("smtpTls").checked = false;
          technalxs.simplemail.SimpleMailDom.get("pop3port").value = 993;
          technalxs.simplemail.SimpleMailDom.get("smtpPort").value = 465;
          break;
      case "gmx.de":
          technalxs.simplemail.SimpleMailDom.get("isImap").selectedIndex = 1;
          technalxs.simplemail.SimpleMailDom.get("pop3host").value = "imap.gmx.net";
          technalxs.simplemail.SimpleMailDom.get("smtpHost").value = "mail.gmx.net";
          technalxs.simplemail.SimpleMailDom.get("pop3ssl").checked = true;
          technalxs.simplemail.SimpleMailDom.get("smtpSsl").checked = true;
          technalxs.simplemail.SimpleMailDom.get("smtpTls").checked = false;
          technalxs.simplemail.SimpleMailDom.get("pop3port").value = 993;
          technalxs.simplemail.SimpleMailDom.get("smtpPort").value = 465;
          break;
      case "hotmail.com":
          technalxs.simplemail.SimpleMailDom.get("isImap").selectedIndex = 1;
          technalxs.simplemail.SimpleMailDom.get("pop3host").value = "imap3.live.com";
          technalxs.simplemail.SimpleMailDom.get("smtpHost").value = "smtp.live.com";
          technalxs.simplemail.SimpleMailDom.get("pop3ssl").checked = true;
          technalxs.simplemail.SimpleMailDom.get("smtpSsl").checked = true;
          technalxs.simplemail.SimpleMailDom.get("smtpTls").checked = false;
          technalxs.simplemail.SimpleMailDom.get("pop3port").value = 993;
          technalxs.simplemail.SimpleMailDom.get("smtpPort").value = 465;
          break;
      case "localhost":
          technalxs.simplemail.SimpleMailDom.get("pop3host").value = "localhost";
          technalxs.simplemail.SimpleMailDom.get("smtpHost").value = "localhost";
          break;
    }
  },
  false);

  function updatePop3Port() {
    var ssl = technalxs.simplemail.SimpleMailDom.get("pop3ssl").checked;
    technalxs.simplemail.SimpleMailDom.get("pop3port").value =
      technalxs.simplemail.SimpleMailDom.get("isImap").selectedIndex ? (ssl ? 993 : 143) : (ssl ? 995 : 110);
  }

  technalxs.simplemail.SimpleMailDom.get("pop3ssl").addEventListener("command", updatePop3Port, false);
  technalxs.simplemail.SimpleMailDom.get("isImap").addEventListener("command", function(event) {
    updatePop3Port();
    technalxs.simplemail.SimpleMailDom.get("pop3host").value = technalxs.simplemail.SimpleMailDom.get("isImap").selectedIndex
      ? technalxs.simplemail.SimpleMailDom.get("pop3host").value.replace(/^pop/, "imap")
      : technalxs.simplemail.SimpleMailDom.get("pop3host").value.replace(/^imap/, "pop");

    if (technalxs.simplemail.SimpleMailDom.get("isImap").selectedIndex) {
      technalxs.simplemail.SimpleMailDom.get("onreceive").disabled = true;
      technalxs.simplemail.SimpleMailUtils.selectItem("deleteMode", "never");
      technalxs.simplemail.SimpleMailDom.get("deleteMode").selectedItem.value = "never";
    } else {
      technalxs.simplemail.SimpleMailDom.get("onreceive").disabled = false;
      technalxs.simplemail.SimpleMailUtils.selectItem("deleteMode", account.deleteMode);
      technalxs.simplemail.SimpleMailDom.get("deleteMode").selectedItem.value = account.deleteMode;
    }
  }, false);

  technalxs.simplemail.SimpleMailDom.get("smtpSsl").addEventListener("command", function(event) {
    technalxs.simplemail.SimpleMailDom.get("smtpPort").value = event.target.checked ? 465 : 25;
    if (technalxs.simplemail.SimpleMailDom.get("smtpSsl").checked) {
      technalxs.simplemail.SimpleMailDom.get("smtpTls").checked = false;
    }
  },
  false);
  
  technalxs.simplemail.SimpleMailDom.get("smtpTls").addEventListener("command", function(event) {
    technalxs.simplemail.SimpleMailDom.get("smtpPort").value = event.target.checked ? 587 : 25;
    if (technalxs.simplemail.SimpleMailDom.get("smtpTls").checked) {
      technalxs.simplemail.SimpleMailDom.get("smtpSsl").checked = false;
    }
  },
  false);
  
  setColor(account.color || "00.png");
}

function populateEnv() {
  var ICONS_PER_ROW = 5;
  var dirLocation = technalxs.simplemail.SimpleMailFile.getEnvDirectory();     

  var hbox, i = 0;
  var menupopup = technalxs.simplemail.SimpleMailDom.get("color").firstChild;
  technalxs.simplemail.SimpleMailUtils.clearElement(menupopup);

  technalxs.simplemail.SimpleMailFile.forEachFile(dirLocation, function(file) {
    var image = document.createElement("image");
    image.setAttribute("src", technalxs.simplemail.SimpleMailFile.getEnvelopeIconURL(file.leafName));
    image.value = file.leafName;

    if (i++ % ICONS_PER_ROW == 0) {
      hbox = document.createElement("hbox");
      menupopup.appendChild(hbox);
    }
    hbox.appendChild(image);
  });
}

function setColor(value) {
  if (!value) return;

  var color = technalxs.simplemail.SimpleMailDom.get("color");
  color.image = technalxs.simplemail.SimpleMailFile.getEnvelopeIconURL(value);
  color.value = value;
  color.firstChild.hidePopup();
}

function onAccept() {
	//userok210
	if (!checkValues(technalxs.simplemail.SimpleMailDom.get("email")))
		return false;

	account.name = technalxs.simplemail.SimpleMailDom.get("name").value;
	account.email = technalxs.simplemail.SimpleMailDom.get("email").value;
//userok210 var evt = document.createEvent("MouseEvents");
//userok210 evt.initMouseEvent("click", true, true, window, 0, 0, 0, 0, 0, false, false, false, false, 0, null);
//userok210 var cb = document.documentElement.getButton("accept");
//userok210 cb.addEventListener("click", checkValues(technalxs.simplemail.SimpleMailDom.get("email"), evt), false);
	account.replyTo = technalxs.simplemail.SimpleMailDom.get("replyTo").value;
	account.refresh = technalxs.simplemail.SimpleMailDom.get("refresh").value;
	if (technalxs.simplemail.SimpleMailDom.get("isImap").selectedIndex && account.deleteMode == "onreceive") {
		account.deleteMode = "never";
	} else {
		account.deleteMode = technalxs.simplemail.SimpleMailDom.get("deleteMode").selectedItem.value;
	}

	account.subject = technalxs.simplemail.SimpleMailDom.get("subject").value;
	account.signature = technalxs.simplemail.SimpleMailDom.get("signature").value;

	account.pop3.isImap = technalxs.simplemail.SimpleMailDom.get("isImap").selectedIndex;
	account.pop3.auth = technalxs.simplemail.SimpleMailDom.get("pop3auth").selectedIndex;
	account.pop3.host = technalxs.simplemail.SimpleMailDom.get("pop3host").value;
	account.pop3.port = technalxs.simplemail.SimpleMailDom.get("pop3port").value;
	account.pop3.ssl = technalxs.simplemail.SimpleMailDom.get("pop3ssl").checked;
	account.pop3.login = technalxs.simplemail.SimpleMailDom.get("pop3login").value;
	account.pop3.password = technalxs.simplemail.SimpleMailDom.get("pop3password").value;

	account.smtp.host = technalxs.simplemail.SimpleMailDom.get("smtpHost").value;
	account.smtp.port = technalxs.simplemail.SimpleMailDom.get("smtpPort").value;
	account.smtp.ssl = technalxs.simplemail.SimpleMailDom.get("smtpSsl").checked;
	account.smtp.tls = technalxs.simplemail.SimpleMailDom.get("smtpTls").checked;  
	account.smtp.login = technalxs.simplemail.SimpleMailDom.get("smtpLogin").value;
	account.smtp.password = technalxs.simplemail.SimpleMailDom.get("smtpPassword").value;
	account.smtp.auth = technalxs.simplemail.SimpleMailDom.get("smtpAuth").checked;
	account.color = technalxs.simplemail.SimpleMailDom.get("color").value;
	window.arguments[0].out = {account:account};

	//userok210
	return true;
}

function onCancel() {
  if (technalxs.simplemail.SimpleMailDom.get("isImap").selectedIndex) {
    if (account.deleteMode == "onreceive") {
      account.deleteMode = "never";
    }
  }
}