var rule = window.arguments[0].rule;
var storage;

function initialize() {
  technalxs.simplemail.SimpleMailOverlay = technalxs.simplemail.SimpleMailUtils.getBrowserWindow().technalxs.simplemail.SimpleMailOverlay;
  storage = technalxs.simplemail.SimpleMailOverlay.storage;

  document.title = rule.id ? technalxs.simplemail.SimpleMailBundle.getString("editRule")
                           : technalxs.simplemail.SimpleMailBundle.getString("newRule");
  populateProperty();
  technalxs.simplemail.SimpleMailUtils.selectItem("property", rule.property);
  technalxs.simplemail.SimpleMailDom.get("not").checked = rule.not;
  populateCondition();
  technalxs.simplemail.SimpleMailUtils.selectItem("condition", rule.condition);
  populateSize();
  populateAccountId();
  setParam(rule.param);
}

function onAccept() {
  rule.property = technalxs.simplemail.SimpleMailDom.get("property").selectedItem.value;
  rule.not = technalxs.simplemail.SimpleMailDom.get("not").checked;
  var condition = technalxs.simplemail.SimpleMailDom.get("condition").selectedItem.value;
  rule.condition = condition;
  rule.param = getParam();
}

function onCancel() {
  window.arguments[0].rule = null;
}

function populateMenuList(menuId, values) {
  var popup = technalxs.simplemail.SimpleMailDom.get(menuId).menupopup;
  technalxs.simplemail.SimpleMailUtils.clearElement(popup);

  for(var i = 0; i < values.length; i++) {
    var menuitem = document.createElement("menuitem");
    menuitem.setAttribute("label", technalxs.simplemail.SimpleMailBundle.getString(values[i]));
    menuitem.setAttribute("value", values[i]);
    popup.appendChild(menuitem);
  }
  popup.parentNode.selectedIndex = 0;
}

function populateProperty() {
  populateMenuList("property", technalxs.simplemail.SimpleMailModel.SimpleMailRule.getProperties());
}

function populateCondition() {
  var property = technalxs.simplemail.SimpleMailDom.get("property").value;
  populateMenuList("condition", technalxs.simplemail.SimpleMailModel.SimpleMailRule.getConditions(property));
}

function populateSize() {
  populateMenuList("size", ["bytes", "kb", "mb"]);
}

function setParam(value) {
  var property = technalxs.simplemail.SimpleMailDom.get("property").selectedItem.value;
  switch(property) {
    case "size":
        if (value > 1000000) {
          value = value / 1000000;
          technalxs.simplemail.SimpleMailUtils.selectItem("size", "mb");
        }
        else if (value > 1000) {
          value = value / 1000;
          technalxs.simplemail.SimpleMailUtils.selectItem("size", "kb");
        }
        break;
    case "accountId":
        technalxs.simplemail.SimpleMailUtils.selectItem("accountId", value);
        break;
  }
  technalxs.simplemail.SimpleMailDom.get("param").value = value;

  showParam();
}

function getParam() {
  var condition = technalxs.simplemail.SimpleMailDom.get("condition").selectedItem.value;
  if (condition == "inAddressBook") return;

  var value = technalxs.simplemail.SimpleMailDom.get("param").value;

  var property = technalxs.simplemail.SimpleMailDom.get("property").selectedItem.value;
  switch(property) {
    case "size":
        var size = technalxs.simplemail.SimpleMailDom.get("size").selectedItem.value;
        switch(size) {
          case "mb": value = value * 1000000; break;
          case "kb": value = value * 1000;    break;
        }
        value = value || 0;
        break;
    case "accountId":
        value = technalxs.simplemail.SimpleMailDom.get("accountId").selectedItem.value;
        break;
  }
  return value;
}

function showParam() {
  var property = technalxs.simplemail.SimpleMailDom.get("property").selectedItem.value;
  var condition = technalxs.simplemail.SimpleMailDom.get("condition").selectedItem.value;
  technalxs.simplemail.SimpleMailDom.get("param").hidden = condition == "inAddressBook" || property == "accountId";
  technalxs.simplemail.SimpleMailDom.get("param-label").hidden = condition == "inAddressBook";
  technalxs.simplemail.SimpleMailDom.get("size").hidden = property != "size";
  technalxs.simplemail.SimpleMailDom.get("accountId").hidden = property != "accountId";
}

function showTooltip(element) {
  var condition = technalxs.simplemail.SimpleMailDom.get("condition").selectedItem.value;
  if (condition == "contains") {
    technalxs.simplemail.SimpleMailDom.get("tooltip").showPopup(element, -1, -1, "tooltip", null, "topright");
  }
}

function hideTooltip() {
  technalxs.simplemail.SimpleMailDom.get("tooltip").hidePopup();
}

function populateAccountId() {
  var accounts = storage.getAccounts();
  var popup = technalxs.simplemail.SimpleMailDom.get("accountId").menupopup;

  for(var i = 0; i < accounts.length; i++) {
    var menuitem = document.createElement("menuitem");
    menuitem.setAttribute("label", accounts[i]);
    menuitem.setAttribute("value", accounts[i].id);
    popup.appendChild(menuitem);
  }
  popup.parentNode.selectedIndex = 0;
}