var ruleTree, rules, ruleType;

function initRules(aRules, aType) {
  rules = aRules;
  ruleType = aType;
  ruleTree = technalxs.simplemail.SimpleMailDom.get("rule-tree");
  ruleTree.view = ruleTreeView;
  if (ruleTree.view.rowCount > 0) ruleTree.view.selection.select(0);
}

var ruleTreeView = {
  get rowCount() {
    return rules.length;
  },
  getCellText: function(row, column) {
    var name = column.id.replace(/rule-/, "");
    var value = rules[row][name];
    switch(name) {
      case "not":
        value = value ? "not" : "";
        break;
      case "param":
        var property = rules[row]["property"];
        switch(property) {
          case "size":
              value = technalxs.simplemail.SimpleMailUtils.size2string(value);
              break;
          case "accountId":
              value = technalxs.simplemail.SimpleMailOverlay.storage.getAccount(value);
              break;
        }
        break;
    }
    return technalxs.simplemail.SimpleMailBundle.getString(value) || value;
  },
  action: editRule,
  delete: deleteRules
};
technalxs.simplemail.DefaultTreeView.extend(ruleTreeView);

function onSelectRule() {
  technalxs.simplemail.SimpleMailDom.get("rule-edit").disabled =
  technalxs.simplemail.SimpleMailDom.get("rule-delete").disabled = !ruleTree.view.selection.getRangeCount();
}

function editRule(add) {
  var rule = add ? technalxs.simplemail.SimpleMailModel.SimpleMailRule.create(ruleType) : rules[ruleTree.currentIndex];
  var param = { rule: rule };

  openDialog("chrome://simplemail/content/preferences/filter/rule.xul",
             "simplemail-preferences-filter-rule-window",
             "chrome,centerscreen,modal,resizable", param);
  if (!param.rule) return;

  if (add) {
    rules.push(rule);
    ruleTreeView.treebox.rowCountChanged(ruleTreeView.rowCount - 1, 1);
    ruleTree.view.selection.select(ruleTreeView.rowCount - 1);
  } else {
    ruleTreeView.treebox.invalidateRow(ruleTree.currentIndex);
  }
}

function deleteRules() {
  if (technalxs.simplemail.SimpleMailUtils.confirm(technalxs.simplemail.SimpleMailBundle.getString("deleteRule"))) {
    ruleTreeView.forEachSelected(function(index) {
      rules.splice(index, 1);
      ruleTreeView.treebox.rowCountChanged(index, -1);
    });
  }
}
