if(typeof(technalxs) == "undefined") {var technalxs = {};};
if(typeof(technalxs.simplemail) == "undefined" ) {technalxs.simplemail = {};};
Components.utils.import("resource://gre/modules/CharsetMenu.jsm");

technalxs.simplemail.SimpleMailDom = function(){
  var pub = {};
  
  pub.get = function(id) {
    return document.getElementById(id);
  },
  pub.remove = function(id) {
    var element = technalxs.simplemail.SimpleMailDom.get(id);
    if (element) {
      element.parentNode.removeChild(element);
    }
  }
  return pub;
}();

technalxs.simplemail.SimpleMailDate = function(){
  var pub = {};
  
  pub.toMIME = function(date) {
    date = new Date(date);
    return date.toString().replace(/(^\w+) (\w+) (\w+) (.*) GMT(.*)/,
                                   "$1, $3 $2 $4 $5");
  },

  pub.toString = function(date) {
    date = new Date(date);
    if (!date.getTime()) return "";

    var timeZone = - date.getTimezoneOffset() / 60;
    if (technalxs.simplemail.SimpleMailPrefs.getBool("eu")) {
    return technalxs.simplemail.SimpleMailUtils.pad(date.getDate()) + "/" +
           technalxs.simplemail.SimpleMailUtils.pad(date.getMonth() + 1) + "/" +
           date.getFullYear().toString().substr(2) + " " +
           technalxs.simplemail.SimpleMailUtils.pad(date.getHours()) + ":" +
           technalxs.simplemail.SimpleMailUtils.pad(date.getMinutes()) + ":" +
           technalxs.simplemail.SimpleMailUtils.pad(date.getSeconds());    
    }
    else { 
    return technalxs.simplemail.SimpleMailUtils.pad(date.getMonth() + 1) + "/" +
           technalxs.simplemail.SimpleMailUtils.pad(date.getDate()) + "/" +
           date.getFullYear().toString().substr(2) + " " +
           technalxs.simplemail.SimpleMailUtils.pad(date.getHours()) + ":" +
           technalxs.simplemail.SimpleMailUtils.pad(date.getMinutes()) + ":" +
           technalxs.simplemail.SimpleMailUtils.pad(date.getSeconds());
    }
  },

  pub.toShortString = function(date) {
    date = new Date(date);
    if (!date.getTime()) return "";

    var timeZone = - date.getTimezoneOffset() / 60;
    return technalxs.simplemail.SimpleMailUtils.pad(date.getDate()) + "/" +
           technalxs.simplemail.SimpleMailUtils.pad(date.getMonth() + 1) + "/" +
           date.getFullYear().toString().substr(2);
  },

  pub.toGMT = function(date) {
    date = new Date(date);
    if (!date.getTime()) return "";

    var gmt = new Date(date.getTime() + date.getTimezoneOffset() * 60 * 1000);
    return gmt.getFullYear() + "-" +
           technalxs.simplemail.SimpleMailUtils.pad(gmt.getMonth() + 1) + "-" +
           technalxs.simplemail.SimpleMailUtils.pad(gmt.getDate()) + " " +
           technalxs.simplemail.SimpleMailUtils.pad(gmt.getHours()) + ":" +
           technalxs.simplemail.SimpleMailUtils.pad(gmt.getMinutes()) + ":" +
           technalxs.simplemail.SimpleMailUtils.pad(gmt.getSeconds()) + " GMT";
  },

  pub.timePassed = function(date) {
    if (date) {
      var seconds = Math.floor((new Date() - date) / 1000);
      var hours = Math.floor(seconds / 3600);
      seconds = seconds - hours * 3600;
      var minutes = Math.floor(seconds / 60);
      seconds = seconds - minutes * 60;
      return technalxs.simplemail.SimpleMailUtils.pad(hours) + ":" +
             technalxs.simplemail.SimpleMailUtils.pad(minutes) + ":" +
             technalxs.simplemail.SimpleMailUtils.pad(seconds);
    }
  },

  pub.parse = function(date) {
    // Convert short year to full
    date = date.replace(/(\w+, \d+ \w+) (\d{2}) /, "$1 20$2 ");
    return Date.parse(date);
  }
  return pub;
}();

technalxs.simplemail.SimpleMailUtils = function (){
  var pub = {};

  pub.getVersion = function() {
    var id = "simplemail@telega.phpnet.us";
    // Firefox 3.6 and before; Mozilla 1.9.2 and before  
    if (typeof(Components.classes["@mozilla.org/extensions/manager;1"]) !== 'undefined')   {
      var em = Components.classes["@mozilla.org/extensions/manager;1"]
      .getService(Components.interfaces.nsIExtensionManager);
       var addon = em.getItemForID(id);
       addonVersion =  addon.version;
    }
    else if (typeof(Components.utils) !== 'undefined' && typeof(Components.utils.import) !== 'undefined') {    
    // Firefox 4 and later; Mozilla 2 and later
      Components.utils.import("resource://gre/modules/AddonManager.jsm");
        AddonManager.getAddonByID("simplemail@telega.phpnet.us", function(addon) {
          if (addon.version) {
            technalxs.simplemail.SimpleMailPrefs.setString("currentversion", addon.version);
           }
          else {
            technalxs.simplemail.SimpleMailUtils.getVersion();
          }
        }
      );
    }
  },

  pub.logToConsole = function (msg, optionTitle) {
		if (this.ConsoleService == null)
		  this.ConsoleService = Components.classes["@mozilla.org/consoleservice;1"]
		                             .getService(Components.interfaces.nsIConsoleService);

		var title = "SimpleMail : ";
		this.ConsoleService.logStringMessage(title + " " + this.logTime() + "\n"+ msg);
	},
  
	pub.logTime = function() {
		var timePassed = '';
		try {
			var end= new Date();
			var endTime = end.getTime();
			var elapsed = new String(endTime  - this.lastTime); // Time in milliseconds
			timePassed = '[' + elapsed + ' ms]   ';
			this.lastTime = endTime; // Remember last time
		}
		catch(e) {;}
		return end.getHours() + ':' + end.getMinutes() + ':' + end.getSeconds() + '.' + end.getMilliseconds() + '  ' + timePassed;
	},
  
  pub.pad = function(number) {
    return (number < 10) ? "0" + number : number;
  },

  // Make a reversed copy of an array, preserving keys
  pub.reverse = function(array) {
    var reverseKeys = new Array();
    for(var i in array) {
      reverseKeys.unshift(i);
    }
    var result = new Object();
    for(var i in reverseKeys) {
      var key = reverseKeys[i];
      result[key] = array[key];
    }
    return result;
  },

  pub.merge = function(array1, array2) {
    var result = new Array();
    for(var i in array1) {
      result[i] = array1[i];
    }

    for(var i in array2) {
      if (array2[i] != null) result[i] = array2[i];
    }
    return result;
  },

  pub.clearElement = function(element) {
    for(var i = element.childNodes.length - 1; i >= 0; i--) {
      element.removeChild(element.childNodes[i]);
    }
  },

  pub.alert = function(message, title) {
    var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                  .getService(Components.interfaces.nsIPromptService);
    return prompts.alert(window, title || "Simple Mail", message);
  },

  pub.confirm = function(message, wnd) {
    var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                  .getService(Components.interfaces.nsIPromptService);
    return prompts.confirm(wnd || window, "Simple Mail", message);
  },

  pub.confirmCheck = function(message, checkMessage, check, wnd) {
    var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                  .getService(Components.interfaces.nsIPromptService);
    return prompts.confirmCheck(wnd || window, "Simple Mail", message, checkMessage, check);
  },

  pub.prompt = function(message, value) {
    var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                  .getService(Components.interfaces.nsIPromptService);
    message = (technalxs.simplemail.SimpleMailBundle.getString(message) || message) + ":";
    return prompts.prompt(window, "Simple Mail", message, value, null, { value: false });
  },

  pub.promptPassword = function(email, savePassword) {
    var password = { value: "" };
    var check = { value: false };
    var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                  .getService(Components.interfaces.nsIPromptService);
    var message = technalxs.simplemail.SimpleMailBundle.getString("enterPasswordFor", [ email ]) + ":";
    prompts.promptPassword(window, "Simple Mail", message,
                           password, technalxs.simplemail.SimpleMailBundle.getString("savePassword"), check);

    if (check.value && savePassword) savePassword(password.value);
    return password.value;
  },

  pub.error = function(message, params) {
    message = technalxs.simplemail.SimpleMailBundle.getString(message, params);
    var messageType = "error";
    var accountError = technalxs.simplemail.SimpleMailPrefs.getString('accountError');

    var browserWindow = technalxs.simplemail.SimpleMailUtils.getBrowserWindow();
    technalxs.simplemail.SimpleMailPopup.open("chrome://simplemail/skin/status/errors_large.png",
                 "Simple Mail - " + accountError, message, browserWindow.toJavaScriptConsole, messageType);

    message = "Simple Mail : " + message;

    // Write log file
    var today = new Date().getTime();
    var date = technalxs.simplemail.SimpleMailDate.toString(today);
    var date = date.replace(/\//g,"-");
    var dataLog = "";
    if (technalxs.simplemail.SimpleMailPrefs.getBool("enableLog")) {
      var logFile = technalxs.simplemail.SimpleMailFile.createLogFile();
      var out = technalxs.simplemail.SimpleMailFile.createOutputStream2(logFile);
      out.write("\r\n", 2);
      out.write(date + " ERROR: " + message);
      out.write("\r\n", 2);
      out.close();
    }
    return message;
  },

  pub.getBrowserWindow = function() {
    var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
             .getService(Components.interfaces.nsIWindowMediator);
    return wm.getMostRecentWindow("navigator:browser");
  },

  pub.getBrowser = function() {
    return technalxs.simplemail.SimpleMailUtils.getBrowserWindow().getBrowser();
  },

  pub.getDocumentTab = function(doc) {
    var gBrowser = technalxs.simplemail.SimpleMailUtils.getBrowser();
    var tabs = gBrowser.tabContainer.childNodes;
    var len = tabs.length;
    for(var i = 0; i < len; i++) {
      if (tabs[i].linkedBrowser.contentDocument == doc) {
        return tabs[i];
      }
    }
  },

  pub.toJSON = function(object, indent, level) {
    if (!level) level = 0;
    if (!indent) indent = " ";
    var json = "";

    json = JSON.stringify(object);
    return level ? json : json ;
  },

  pub.whereToOpenLink = function(event) {
    if (!event) return "";

    if (!event.button) {
      return event.shiftKey ? (event.ctrlKey ? "tabshifted" : "window")
                            : (event.ctrlKey ? "tab" : "");
    } else if (event.button == 1) {
      return event.shiftKey ? "tab" : "tabshifted";
    }
  },

  // Works in both FF & SeaMonkey

  pub.openUILink = function(url, where) {
    if (where instanceof Event) {
      where = technalxs.simplemail.SimpleMailUtils.whereToOpenLink(where);
    }
    switch(where) {
      case "tabshifted": return gBrowser.addTab(url);
      case "tab":        return gBrowser.selectedTab = gBrowser.addTab(url);
      case "window":     return open(url);
      default:           return loadURI(url);
    }
  },

  pub.md5 = function(string) {
    // Build array of character codes to MD5
    var array = new Array();
    var len = string.length;
    for(var i = 0; i < len; i++) {
      array.push(string.charCodeAt(i));
    } 

    var hash = Components.classes["@mozilla.org/security/hash;1"]
               .createInstance(Components.interfaces.nsICryptoHash);
    hash.init(hash.MD5);
    hash.update(array, array.length);
    var binary = hash.finish(false);

    // Unpack the binary data bin2hex style
    var result = "";
    for (var i = 0; i < binary.length; ++i) {
      var c = binary.charCodeAt(i);
      var ones = c % 16;
      var tens = c >> 4;
      result += String.fromCharCode(tens + (tens > 9 ? 87 : 48)) +
                String.fromCharCode(ones + (ones > 9 ? 87 : 48));
    }
    return result;
  },

  pub.size2string = function(value) {
    return value >= 1000000 ? (value / 1000000).toFixed(1) + " " + technalxs.simplemail.SimpleMailBundle.getString("mb") :
           value >= 1024 ? (value / 1024).toFixed(1) + " " + technalxs.simplemail.SimpleMailBundle.getString("kb")
                         : value + " " + technalxs.simplemail.SimpleMailBundle.getString("bytes");
  },

  pub.lastUniqueId = 0,

  pub.getUniqueId = function() {
    return technalxs.simplemail.SimpleMailUtils.lastUniqueId = Math.max(technalxs.simplemail.SimpleMailUtils.lastUniqueId + 1, new Date().getTime());
  },

  pub.getFontList = function() {
    var enumerator = Components.classes["@mozilla.org/gfx/fontenumerator;1"]
                     .getService(Components.interfaces.nsIFontEnumerator);
    var count = { value: 0 };
    return enumerator.EnumerateAllFonts(count);
  },

  // Select item in menulist
  pub.selectItem = function(menulistId, value, add) {
    var vl = value;
    var popup = technalxs.simplemail.SimpleMailDom.get(menulistId).menupopup;
    var len = popup.childNodes.length;
    for(var i = 0; i < len; i++) {
      var l = (popup.childNodes[i].label);//userok210 String.toLowerCase
      var v = (popup.childNodes[i].value);//userok210 String.toLowerCase
	  if (vl == l || vl == v) {
        popup.parentNode.selectedIndex = i;
        return;
      }
    }
    if (add && value) {
      var menuitem = popup.ownerDocument.createElement("menuitem");
      menuitem.setAttribute("label", value);
      menuitem.setAttribute("value", value);
      popup.parentNode.selectedItem = popup.appendChild(menuitem);
    }
    else popup.parentNode.selectedIndex = 0;
  },

  pub.getDefaultCharsets = function() {
    var data  = CharsetMenu.getData();
    
    function infoToCharset(info) {
      return { code: info.value, title: info.label };
    }

    var pinnedCharsets = data.pinnedCharsets.map(infoToCharset);
    var otherCharsets = data.otherCharsets.map(infoToCharset);

    this._charsets = pinnedCharsets.concat(otherCharsets);

    var charsets = new Array();
    var charsetsCount = this._charsets.length; 
    for (var i = 0; i < charsetsCount; i++) {
      charsets.push(this._charsets[i].code)
    } 
    return charsets
  },

  pub.isFirefox2 = function() {
    if (typeof Components.classes["@mozilla.org/passwordmanager;1"] != "undefined") {
      return true;
    } else {
      return false;
    }
  },

  pub.parseHTML = function(doc, html, allowStyle) {
    var PARSER_UTILS = "@mozilla.org/parserutils;1";
    // User the newer nsIParserUtils on versions that support it.
    if (PARSER_UTILS in Components.classes) {
      var parser = Components.classes[PARSER_UTILS]
                                  .getService(Components.interfaces.nsIParserUtils);
      if ("parseFragment" in parser)
              return parser.parseFragment(html, allowStyle ? parser.SanitizerAllowStyle : 0,
                                            false, null, doc.documentElement);
    }
    return Components.classes["@mozilla.org/feed-unescapehtml;1"]
                     .getService(Components.interfaces.nsIScriptableUnescapeHTML)
                     .parseFragment(html, false, null, doc.documentElement);
  },

  pub.htmlToText = function(html, flag, col) {
    var PARSER_UTILS = "@mozilla.org/parserutils;1";
    // User the newer nsIParserUtils on versions that support it.
    if (PARSER_UTILS in Components.classes) {
      var parser = Components.classes[PARSER_UTILS]
                                  .getService(Components.interfaces.nsIParserUtils);
      if ("parseFragment" in parser)
              return parser.convertToPlainText(html, flag, col);
    }
    return Components.classes["@mozilla.org/feed-unescapehtml;1"]
                     .getService(Components.interfaces.nsIScriptableUnescapeHTML)
                     .unescape(html);
  },
  
  pub.sanitizeHtml = function(html, allowStyle) {
    var PARSER_UTILS = "@mozilla.org/parserutils;1";
    // User the newer nsIParserUtils on versions that support it.
    if (PARSER_UTILS in Components.classes) {
      var parser = Components.classes[PARSER_UTILS]
                                  .getService(Components.interfaces.nsIParserUtils);
      if ("parseFragment" in parser)
              return parser.sanitize(html, allowStyle ? parser.SanitizerAllowStyle : 0);
    }
    return Components.classes["@mozilla.org/feed-unescapehtml;1"]
                     .getService(Components.interfaces.nsIScriptableUnescapeHTML)
                     .unescape(html);
  }
  return pub;
}();

technalxs.simplemail.SimpleMailText = function (){
  var pub ={};

  pub.REGEXP_URL = /(https?:\/\/|ftp:\/\/|mailto:)[^\s<>\[\]\(\){}]*/gi,
  pub.REGEXP_LINK = /<img[\s\S]*?src=['"](.*?)['"][\s\S]*?>|<a[\s\S]*?href=['"](.*?)['"][\s\S]*?<\/a>/gi,

  pub.getURL = function(text) {
    var match = ("" + text).match(technalxs.simplemail.SimpleMailText.REGEXP_URL);
    return match && match[0];
  },

  pub.toHtml = function(text) {
    return text.replace(/</g, "&lt;")
               .replace(/\r?\n/g, "<br>")
               .replace(technalxs.simplemail.SimpleMailText.REGEXP_URL, function(url) {
                if (technalxs.simplemail.SimpleMailPrefs.getBool("plaintextOnSend")) {
                  return url;
                } else {
                  return "<a href='" + url + "'>" + url + "</a>";
                } 
    });
  },
  
    
  pub.linkToLink = function(html) {
    return html.replace(technalxs.simplemail.SimpleMailText.REGEXP_URL, function(url) {
      return "<a href='" + url + "'>" + url + "</a>";
    });
  },

  pub.linkToText = function(html, onUrl) {
    return technalxs.simplemail.SimpleMailText.replaceURLs(html, function(text, url) {
      if (text.match(/href\=\"simplemail\:\/\/attachments/gim)) {
        return  text;
      } else { 
        return  url;
      }
    });
  },

  pub.replaceURLs = function(text, onUrl) {
    return text.replace(technalxs.simplemail.SimpleMailText.REGEXP_LINK, function(text, image, anchor) {
      return onUrl(text, image || anchor, image);
    });
  },

  pub.replaceURLs2 = function(text, onUrl) {
    return text.replace(technalxs.simplemail.SimpleMailText.REGEXP_URL, function(text) {
      return onUrl(text);
    });
  },

  pub.imageToLink = function(html) {
    return technalxs.simplemail.SimpleMailText.replaceURLs(html, function(text, url, isImage) {
      return isImage ? "<a href='" + url + "'>" + text + "</a>" : text;
    });
  },

  pub.trim = function(string) {
    return string.replace(/^\s+|\s+$/g, "");
  },

  pub.toUnicode = function(text, charset) {
    try {
      if (!charset) return text;
      var converter = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"]
                      .createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
      converter.charset = charset;
      return converter.ConvertToUnicode(text);
    }
    catch(e) {
      technalxs.simplemail.SimpleMailUtils.error("encodingError");
      throw e;
    }
  },

  pub.fromUnicode = function(text, charset) {
    try {
      if (!charset) return text;
      var converter = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"]
                      .createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
      converter.charset = charset;
      var result = converter.ConvertFromUnicode(text);
      return result + converter.Finish();
    }
    catch(e) {
      technalxs.simplemail.SimpleMailUtils.error("encodingError");
      throw e;
    }
  },

  pub.getSelectedHtml = function(doc) {
    var selection = doc.defaultView.getSelection();
    if (selection.rangeCount) {
      var fragment = selection.getRangeAt(0).cloneContents();
      var div = doc.createElement("div");
      div.appendChild(fragment);
      return div.innerHTML;
    }
  },

  // Highlight given phrase, skipping html tags & entities
  pub.highlight = function(phrase, html) {
    var regexp = new RegExp("(<[\\s\\S]*?>|&.*?;)|(" + phrase + ")", "gi");
    return html.replace(regexp, function($0, $1, $2) {
      return $1 || "<span class='highlight'>" + $2 + "</span>";
    });
  }
  return pub;
}();

technalxs.simplemail.SimpleMailPopup = function (){
var pub = {};

  pub.TIMEOUT = function(){
  return technalxs.simplemail.SimpleMailPrefs.getInt("popupTimeout") * 1000;
  },
  
  pub.queue = [],
  pub.inProgress = false,

  pub.open = function(image, title, text, onClick, messageType) {
    technalxs.simplemail.SimpleMailPopup.queue.push({
      image: image,
      title: title,
      text: text,
      onClick: onClick,
      messageType: messageType
    });
    
    var gBrowser = technalxs.simplemail.SimpleMailUtils.getBrowser();
    var len = gBrowser.browsers.length;  
    for(var i = 0; i < len; i++) {
      var browser = gBrowser.browsers[i];
      var uri = browser.currentURI.spec.replace (/(\?).*?/ig, "");
      var uri = uri.replace(/([0-9]).*?/ig, "");
    }

    if (!technalxs.simplemail.SimpleMailPrefs.getBool("popupOnTop")) {
      var actualWindow = technalxs.simplemail.SimpleMailOverlay.testTabUrl("chrome://simplemail/content/main/main.xul") || uri == "chrome://simplemail/content/newmessage.xul";
      if (actualWindow){
        technalxs.simplemail.SimpleMailPopup.showNext();
      } else return;
    } else {
      technalxs.simplemail.SimpleMailPopup.showNext();
    }
  },

  pub.showNext = function() {
    if (technalxs.simplemail.SimpleMailPopup.inProgress) return;
    
    var item = technalxs.simplemail.SimpleMailPopup.queue.shift();
    if (!item) return;
  
    technalxs.simplemail.SimpleMailPopup.inProgress = true;
  
    if (technalxs.simplemail.SimpleMailPrefs.getBool("customPopup")) technalxs.simplemail.SimpleMailPopup.showCustomPopup(item);
    else technalxs.simplemail.SimpleMailPopup.showStandardPopup(item);
  
    setTimeout(function() {
      technalxs.simplemail.SimpleMailPopup.inProgress = false;
      technalxs.simplemail.SimpleMailPopup.showNext();
    },
    technalxs.simplemail.SimpleMailPopup.TIMEOUT);
  },

  pub.showCustomPopup = function(item) {
    var wnd = technalxs.simplemail.SimpleMailUtils.getBrowserWindow();
    wnd.openDialog(
      "chrome://simplemail/content/customnotify.xul", "customnotify-window",
      "chrome,dependent,titlebar=no", item.image, item.title, item.text, technalxs.simplemail.SimpleMailPopup.TIMEOUT,
      function() {
        technalxs.simplemail.SimpleMailPopup.queue = [];
        if (item.onClick) item.onClick();
      }, item.messageType
    );
  },

  pub.showStandardPopup = function(item) {
    var wnd = technalxs.simplemail.SimpleMailUtils.getBrowserWindow(); 
    wnd.openDialog(
      "chrome://simplemail/content/classicnotify.xul", "classicnotify-window",
      "chrome,popup=yes,titlebar=no", item.image, item.title, item.text, true, null,
      function() {
        var listener = {
          observe: function(subject, topic) {
            if (topic == "alertclickcallback") {
              technalxs.simplemail.SimpleMailPopup.queue = [];
              if (item.onClick) item.onClick(); 
            }
          }
        }
      }
    );
  }
  return pub;
}();

technalxs.simplemail.SimpleMailBundle = function(){
  var pub = {};

  pub.bundle = Components.classes["@mozilla.org/intl/stringbundle;1"]
          .getService(Components.interfaces.nsIStringBundleService)
          .createBundle("chrome://simplemail/locale/simplemail.properties"),

  pub.getString = function(name, params) {
    try {
      return params ? technalxs.simplemail.SimpleMailBundle.bundle.formatStringFromName(name, params, params.length)
                    : technalxs.simplemail.SimpleMailBundle.bundle.GetStringFromName(name);
    }
    catch(e) {
      return null;
    }
  }
  return pub;
}();